/* MGH is a trademark of Morris G. Hirsch.
 * Morris G. Hirsch is a trademark of Morris G. Hirsch.
 *
 * Morris G. Hirsch ASSUMES NO RESPONSIBILITY FOR THE USE,
 * OR INABILITY TO USE ANY OF HIS SOFTWARE.
 * MGH SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 * AND MGH EXPRESSLY DISCLAIMS ALL IMPLIED WARRANTIES,
 * INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. */

/* Unix (tm) stuff */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>

/* X / Motif (tm) stuff */

#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/MwmUtil.h>
#include <X11/Xlib.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/SelectioB.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>
#include <Xm/MenuShell.h>

void disinherit(Widget anyw)
{
  if ((fcntl(ConnectionNumber(XtDisplay(anyw)), F_SETFD, 1)) == -1)
    fprintf(stderr, "Child cannot disinherit X Connection\n");
}

main(int argc, char *argv[])

{ static char   kws[] = "@(#)map.c	1.1 ARGOS 93/12/22 14:46:26";

  XtAppContext  app_context;

  Widget    toplevel, mainwindow, menubar;

  int       ii;

/* Put ourself (actually our clone) in background. */

  if (fork())
    exit(0);

/* Application class "Demos" determines where to look for help files.
   See the Makefile. */

  toplevel = XtAppInitialize(&app_context, "Demos",
                 NULL, 0,
                 &argc, argv,
                 NULL,
                 NULL, 0);

/* Works w/out this -- books say to do it. */

  disinherit(toplevel);

/* Make a MainWindow,
   and let gui runtime fill the MenuBar as specified. */

  XtManageChild(mainwindow =
          XmCreateMainWindow(toplevel, "mainwindow", NULL, 0));

  XtManageChild(menubar =
          XmCreateMenuBar(mainwindow, "menubar", NULL, 0));

  XmMainWindowSetAreas(mainwindow,
                       menubar,
                       NULL, NULL, NULL,
                       NULL);

/* Populate and show the GUI. */

  gui_init(menubar);

  gui_show();

  XtRealizeWidget(toplevel);

  XtAppMainLoop(app_context);
}
