#include <string.h>
#include <malloc.h>

char * listops(char *firsts, char op, char *seconds)

/* Operations on two lists of words.
   '-' returns words in first that are not in second.
   '+' returns words that are in either w/out duplication.
   '*' returns words that are in both. */

/* NOTE WE USE STRCASECMP */

{ static char   kws[] = "@(#)listops.c	1.1 ARGOS 93/12/13 17:37:09";

/* This returns the static address of an allocated array.
   It is valid only until the next call.
   We assume that the caller will make their own copy,
   and be responsible for releasing it when done. 
   We do not use strtok at all because it is too risky.
   Only one use may be active, even across calling routines. */

    static char * result = NULL;

    static char   asecond[100];
    char       *second_get;
    char       *second_put;

    static char   afirst[100];
    char       *first_get;
    char       *first_put;

    int       found;

    int lfirst, lsecond;

/* printf("listops %s %c %s\n", firsts, op, seconds); */

    if (result) {
       free(result);
       result = 0;
    }

    if (!firsts || !seconds)
        return 0;

    lfirst = strlen(firsts);
    lsecond = strlen(seconds);

    if (op == '+')
       result = (char *)malloc(lfirst + lsecond +2);

    else if (op == '-')
       result = (char *)malloc(lfirst +1);

    else if (op == '*') {
       if (lfirst > lsecond)
          result = (char *)malloc(lfirst +1);
       else
          result = (char *)malloc(lsecond +1);
    }

    result[0] = 0;

    if (op == '+')
        strcat(result, seconds);

/* Try each word from first list. */

    first_get = firsts;
    do {

        while (*first_get == ' ')
            first_get++;

        first_put = afirst;
        while ((*first_get) && (*first_get != ' '))
            *first_put++ = *first_get++;
        *first_put = 0;

        if (strlen(afirst)) {

/* Check entire seconds list looking for this word from first. */

            second_get = seconds;
            do {

                while (*second_get == ' ')
                    second_get++;

                second_put = asecond;
                while ((*second_get) && (*second_get != ' '))
                    *second_put++ = *second_get++;
                *second_put = 0;

/* Equal compare ends loop early. */

                found = (strlen(asecond)
                && !strcasecmp(afirst, asecond));

            } while (*second_get && !found);

/* Copy or not per option and result of loop.

   '-' copy word in first that is not in second.
   '+' copy word in first that is not in second.
   '*' copy word in first that is in second. */

            if ((found && (op == '*'))
             || (!found && (op != '*'))) {
                if (strlen(result))
                    strcat(result, " ");
                strcat(result, afirst);
            }
        }
    } while (*first_get);

/* printf("return %s %c %s = %s\n", firsts, op, seconds, result); */
    return result;
}
