#include <stdio.h>
#include <string.h>
#include <memory.h>

#include "uitoc_comm.h"

void uicopynode(int onode, char *name)

/* Allocate a new copy node.
   Make an exact copy of the original,
   except for clearing the sibling linkage.

   Make the copy node a child of the parent if none yet,
   otherwise append (not prepend) it to the sibling chain.
   Note that chain is in order of mention.

   Push the node address onto the in-creation stack.

   Caller may now set option fields through the node pointer.
   We just give them no chance in yacc to set a child node. */

{ static char   kws[] = "@(#)uicopynode.c	1.1 ARGOS 93/12/13 17:37:12";

  int parent;
  int child, prev;
  int new = ++Allocated;

/* fprintf(stderr,
  "uicopynode: onode %d new %d old %s new %s\n",
   onode, new, Node_Name(onode), name); */

  memcpy((char *)&Nodes[new],
	 (char *)&Nodes[onode], 
	sizeof(UINODE));

  Node_Sibling(new) = 0;
  Node_Name(new) = strdup(name);

  if (Actives > 0) {
    parent = Active_Nodes[Actives];
    Node_Back(new) = parent;

    if (Node_Child(parent)) {
        for (child = Node_Child(parent);
             child;
             child = Node_Sibling(child))
            prev = child;

        Node_Sibling(prev) = new;
    }

    else
        Node_Child(parent) = new;
  }

  Active_Nodes[++Actives] = new;

  return;
}
