#include <stdio.h>
#include <string.h>
#include <memory.h>

#include "uitoc_comm.h"

void uidupnode(int onode)

/* Allocate a newdup node.
   It is exact copy of the original,
   except for clearing the sibling linkage.

   Make the dup node a child of the parent if none yet,
   otherwise append (not prepend) it to the sibling chain.
   Note that chain is in order of mention.

   Push the node address onto the in-creation stack.

   Caller may now set other fields through the node pointer. */

{ static char   kws[] = "@(#)uidupnode.c	1.1 ARGOS 93/12/13 17:37:14";

  int parent;
  int child, prev;
  int newdup = ++Allocated;

fprintf(stderr, "onode %d newdup %d %s\n", onode, newdup, Node_Name(onode));

  memcpy((char *)&Nodes[newdup],
	 (char *)&Nodes[onode], 
	sizeof(UINODE));

  Node_Sibling(newdup) = 0;

  if (Actives > 0) {
    parent = Active_Nodes[Actives];

    if (Node_Child(parent)) {
        for (child = Node_Child(parent);
             child;
             child = Node_Sibling(child))
            prev = child;

        Node_Sibling(prev) = newdup;
    }

    else
        Node_Child(parent) = newdup;
  }
  return;
}
