#include <string.h>
#include <memory.h>

#include "uitoc_comm.h"

void uinewnode(int kind, char *name)

/* Allocate a new node and set the name.

   Make the new node a child of the parent if none yet,
   otherwise append to the sibling chain.
   Note that chain is in order of mention.

   Push the node address onto the in-creation stack.

   Caller may now set other fields through the node pointer. */

{ static char   vers[] = "@(#)uinewnode.c	1.1 ARGOS 93/12/13 17:37:17";

  int new;
  int parent;

  int child, prev;

  new = ++Allocated;

/* Zero-fill allows testing for repeated attribute setting */

  memset((char *)&Nodes[new], 0x00, sizeof(UINODE));

  Node_Kind(new) = kind;
  Node_Name(new) = strdup(name);

  if (Actives > 0) {
    parent = Active_Nodes[Actives];
    Node_Back(new) = parent;

    if (Node_Child(parent)) {
        for (child = Node_Child(parent);
             child;
             child = Node_Sibling(child))
            prev = child;

        Node_Sibling(prev) = new;
    }

    else
        Node_Child(parent) = new;
  }

  Active_Nodes[++Actives] = new;

  Node_Level(new) = Actives;

  return;
}
