#include <stdio.h>
#include <string.h>

#include "uitoc_comm.h"

#define UITOP Active_Nodes[Actives]
#define UIPARENT Active_Nodes[Actives-1]

char * uisibling(char *name, int match)

/* Validate name as an existing sibling if match true,
   or as a new name if match false.
   Return valid name as "pass through" else null. */

{ static char     kws[] = "@(#)uisibling.c	1.1 ARGOS 93/12/13 17:37:17";

    int             child;

/* Looking for a sibling as attribute when already in a new node,
   so check the list for the UIPARENT of this node. */

    if (match) {
	if (!UIPARENT)
	    return 0;

	for (child = Node_Child(UIPARENT);
	     child;
	     child = Node_Sibling(child)) {
	    if (!strcasecmp(name, Node_Name(child)))
		return name;
	}

/*	fprintf(stderr,
		"%s is not a sibling in %s\n",
		name,
		Node_Name(UIPARENT)); */
	return 0;
    }

/* Looking for a new name before we open the new node,
   so check the list for the current node. */

    else {
	for (child = Node_Child(UITOP);
	     child;
	     child = Node_Sibling(child)) {
	    if (!strcasecmp(name, Node_Name(child))) {
/*		fprintf(stderr,
			"%s is already used in %s\n",
			name, Node_Name(UITOP)); */
		return 0;
	    }
	}
	return name;
    }
}
