/********************************************************************

 > For greater portability isolate any Unix specifics:
 ) the "what_which" version info is Unix or SCCS specific,
 ) opening a debug file if not via getenv then how? a resource of course!

 > Beware of 'int' declarations when defined types are provided.
 For example, Dimension, Position, Boolean should be used per docs.
 Several XmList and XmText resources really are 'int' per docs.
 We are ok last I looked but be careful always.

 > help-abbrevs tree-walker is sketched-in but not done.

 > need to correctly position popups for FSB and for string input.
   setting x y works for our own but not for the ready made dialogs.

 > Should do summary button different way -- produce a combination label,
   then could always use a simple button and show it anywhere.

 > Study this:
 Use valueChanged callbacks for dependencies between values.
 To prevent circles do NOT post value if it does not actually change.
 Try something like Centigrade and Fahrenheit value_buttons,
 with no-change meaning within some tolerance.

 > NO_ECHO for STRING (for passwords) via Callback, see O'Reilly example.
   if (Cond(Node_Str_No_Echo(anode), anode))

********************************************************************/

static char   kws[] = "%W% ARGOS %E% %U%";

#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>

#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <unistd.h>
#include <fcntl.h>

/* System V or BSD flavor.
   This spelling of SYSV is declared for us on SGI machines. */

#ifdef _SYSTYPE_SYSV
#include <dirent.h>
#else
#include <sys/dir.h>
#endif

#define DIRSLASH '/'

#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/MwmUtil.h>
#include <X11/Xlib.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/Protocols.h>
#include <Xm/DrawingA.h>
#include <Xm/DialogS.h>
#include <Xm/BulletinB.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <Xm/Command.h>
#include <Xm/FileSB.h>
#include <Xm/Frame.h>
#include <Xm/MainW.h>
#include <Xm/MessageB.h>
#include <Xm/SelectioB.h>
#include <Xm/CascadeB.h>
#include <Xm/CascadeBG.h>
#include <Xm/ArrowB.h>
#include <Xm/ArrowBG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/SelectioB.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>
#include <Xm/Label.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/List.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>

#include "ui_defs.h"
#include "gui_heads.h"

/* Exactly ONE compilation file (here this one) must "own" the externals. */

#define GUI_INIT
#include "gui_comm.h"

static char   test_file_name[80];
static char   test_type_in[80];

/* Declared here -- used as externals in attribute code blocks.
   We write this same block into emitted code via gui_exts routine.
   This is bad because they appear in both places.
   Should use an include file.
   Here we would simply include it with EXTERN def'd as nil;
   in uitoc we would copy it into the code file we produce,
   with EXTERN def'd as extern.
   Minor problem is that would make it part of the developers package,
   with a question of what directory to put it in. */

int       BOOLEAN_ON;
int       INT_VAL;
float     FLOAT_VAL;
double    DOUBLE_VAL;
char     *STRING_VAL = NULL;
int       CYCLE_INDEX;
char     *CYCLE_STRING = NULL;
char     *CHOICE_LIST = NULL;
char     *CHOICE_ADD = NULL;
char     *CHOICE_DEL = NULL;
int       CLICK_DOWN;
long      CLICK_TIME;
int       DOUBLE_CLICK;
char     *TEST_FILE_NAME = test_file_name;
char     *TEST_TYPE_IN = test_type_in;
#define   MRU_MAX 5
char     *M_R_U[MRU_MAX];
int       MOUSE_X, MOUSE_Y, MOUSE_Y_COMP;

int       DOING_LIST_ALL = False;
int       DOING_LIST_NONE = False;
int       DOING_LIST_FIRST = False;

/* definitions from MwmUtil.h
   bit flags for MwmHints.decorations
#define MWM_DECOR_ALL  (1L << 0)
#define MWM_DECOR_BORDER  (1L << 1)
#define MWM_DECOR_RESIZEH  (1L << 2)
#define MWM_DECOR_TITLE  (1L << 3)
#define MWM_DECOR_MENU  (1L << 4)
#define MWM_DECOR_MINIMIZE  (1L << 5)
#define MWM_DECOR_MAXIMIZE  (1L << 6)

   values (not bit flags) for MwmHints.input_mode
#define MWM_INPUT_MODELESS  0
#define MWM_INPUT_PRIMARY_APPLICATION_MODAL  1
#define MWM_INPUT_SYSTEM_MODAL  2
#define MWM_INPUT_FULL_APPLICATION_MODAL  3
*/

static XmStringCharSet charset =
(XmStringCharSet) XmSTRING_DEFAULT_CHARSET;

static Widget   menubar = NULL;
static Widget   toolbar = NULL;

static NODEID   Toolbar_Node = NULL;

static XtAppContext appcontext = NULL;
static char  *app_name = NULL;
static char  *app_class = NULL;

/* Some non-statics we share with other 'cx' compile files.
   Not yet enough to bother with a dot h file?
   Could put them in gui_comm.h maybe? */

Display    *cx_display;
Screen     *cx_screen;
Window      cx_rootwindow;

Widget      cx_toplevel;
Window      cx_topwindow;

Widget      cx_draw_widget = NULL;

int         cx_TimeOut_Time = NULL;

static Atom   WM_SAVE_YOURSELF = NULL;
static Atom   WM_DELETE_WINDOW = NULL;

static Atom   _GUI_BALLOON_HELP = NULL;

/* To detect and ignore input caused by keyboard auto-repeat.
   Server time is in unsigned long milliseconds worth almost 50 days.
   A careful test should consider rollover. */

/* NOTE! We can 'defeat' auto-repeat on F1 taking help away by testing time.
   Save the time that we put help up,
   if another F1 comes within our limit ignore it but update the time.

   Need a different trick for enter/leave events and Balloon help;
   we want to ignore 'passing through' event-pairs,
   and would also like to ignore 'out and back in' pairs.
   We cannot look ahead so instead we must wait and see.
   Read up on timer examples in Heller and Young.
   Prefer doing it ourself with a select. */

static Time   cxm_event_time = NULL;
static Time   cxm_help_time = NULL;

/* Balloon-help (flagged globally on or off) and support.
   Note that Boolean may be typedef'ed as char or int or long!
   Avoid problems with inter-client messages by forcing the type. */

static int    want_Balloon = NULL;

static Widget   showBalloon = NULL;
static Widget   hideBalloon = NULL;
static Widget   Balloon_Dialog = NULL;
static NODEID   Balloon_Node = NULL;

/* Error popup and Node reporting Error. */

static Widget   Error_Dialog = NULL;
static NODEID   Error_Node = NULL;

/* Support a Y_N popup over any Immediate needing a Confirm.
   The pop is invoked instead of action only when confirmation is needed,
   and the node number and thus the deferred action is passed in. */

static Widget   Yes_No_Dialog = NULL;
static NODEID   Yes_No_Node = NULL;

/* We should probably just pop one of these up and down.
   Get rid of old contents (and free anything we should). */

static Widget   Help_Dialog = NULL;

/* Log internal steps here if user setenv GUI_DEBUG to enable it. */

static char   debugfile[80] = "";

/* Use this instead of the forbidden XtMoveWidget call! */

static void
cxm_move_widget(Widget w, Position x, Position y)
{
  int       nn = 0;
  Arg       args[10];

  XtSetArg(args[nn], XtNx, x);
  nn++;
  XtSetArg(args[nn], XtNy, y);
  nn++;
  XtSetValues(w, args, nn);
}

/* Not yet using pixmap via node attributes.
   (We need to add such attributes to the spec language.)
   These have been somewhat tested via kludge calls. */

/* Set background (or foreground) color and compatible trim colors. */

/* Colors now supported from UI spec:
   BODY_COLOR background for a button or other terminal. (!reverse)
   LABEL_COLOR foreground (ink) for a button or other terminal. (reverse)

   Colors MAYBE to be supported:
   FILL_COLOR background for a dialog box.

   Colors probably NOT to be supported:
   MOUSE_COLOR background for a button or other terminal with focus.
   ON_COLOR background for a turned on toggle button. */

static void
cxm_set_widget_color(Widget w,
           Pixel color_index, char *color_name, Boolean reverse)
{
  Colormap    cmap;

  Pixel       bg_col, fg_col, top_col, bot_col, arm_col, temp_col;

  if (!w) {
    printf("cxm: %s ERROR cmx_set_widget_color for NULL widget\n",
         app_name);
    exit(-1);
  }

/* Zero index is black (and legal) so negative means no-spec.
   Beware! Pixel is typedef'ed unsigned long! */

  if ((long) color_index < 0)
    return;

/* Empty string means no-spec. */

  if (color_name && !strlen(color_name))
    return;

/* We should catch these sooner and make_WIDGET instead of make_GADGET */

  if (!XtIsWidget(w)) {
    printf("cxm: %s ERROR cmx_set_widget_color %s not a widget\n",
         app_name, XtName(w));
    return;
  }

/* First set background color by given name or index.
   We have already tested for legal values.
   No guarantee what will be set!

   Notice the details of this call for using a string:
   TypedArg, Resource, Conversion, String, Length. */

  if (color_name && strlen(color_name))
    XtVaSetValues(w,
            XtVaTypedArg, XmNbackground,
            XmRString, color_name, strlen(color_name) + 1,
            NULL);

  else if ((long) color_index >= 0)
    XtVaSetValues(w,
            XmNbackground, color_index,
            NULL);

/* Get the actual map (and background color pixel) used by this Widget. */

  XtVaGetValues(w,
          XmNbackground, &bg_col,
          XmNcolormap, &cmap,
          NULL);

/* Calculate suitable trim-colors for the bg color in the same color map. */

  XmGetColors(XtScreen(w), cmap, bg_col,
        &fg_col, &top_col, &bot_col, &arm_col);

/* If reverse is set,
   the given "bg" color is really intended as foreground,
   so use the computed complimentary "fg" color as background in new call,
   to get proper trim colors. */

  if (reverse) {
    temp_col = fg_col;
    XmGetColors(XtScreen(w), cmap, temp_col,
          &fg_col, &top_col, &bot_col, &arm_col);
    fg_col = bg_col;
    bg_col = temp_col;
  }

/* Set the back and fore and all the trim-color resources.
   NOTICE! May have to test class first to only set valid ones.
   So far no complaint about setting unused resources. */

/********

  DSL : Always using Black (color 0) for the shadows,
  text and so forth.
  Maybe someday use the values shown here:

  XtVaSetValues(w,
    XmNbackground, bg_col,
    XmNforeground, fg_col,
    XmNborderColor, fg_col,
    XmNtopShadowColor, top_col,
    XmNbottomShadowColor, bot_col,
    XmNarmColor, arm_col,
    NULL);

*********/

  if (reverse)
    XtVaSetValues(w,
            XmNbackground, 0,
            XmNforeground, color_index,
            XmNborderColor, color_index,
            XmNtopShadowColor, 0,
            XmNbottomShadowColor, color_index,
            XmNarmColor, arm_col,
            NULL);
  else
    XtVaSetValues(w,
            XmNbackground, color_index,
            XmNforeground, 0,
            XmNborderColor, 0,
            XmNtopShadowColor, color_index,
            XmNbottomShadowColor, 0,
            XmNarmColor, arm_col,
            NULL);
}

/* Set principal and related pixmaps for a widget.
   Notice! Must do it ALL again for changed colors.
   No way to change fg and bg color indices of an existing pixmap. */

/* Also notice -- not using this resource but should try it:
   XmNbackgroundPixmap (will "tile" if smaller than button window)
   provides a textured bg and still allows labelString / XmSTRING. */

static void
cxm_set_pixmaps(Widget w, char *base_name)
{
  int       nn = 0;
  Arg       args[10];

  Pixmap      pixmap;
  Pixel       bg_col, fg_col;

  char       *longname = NULL;
  char       *apathname = NULL;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm_set_pixmaps %s %s\n",
        XtName(w), base_name);
    fflush(DEBUG);
  }
#endif

/* c y a */

  if (!w || !XtIsWidget(w) || !base_name || !strlen(base_name))
    return;

  XtVaGetValues(w,
          XmNforeground, &fg_col,
          XmNbackground, &bg_col,
          NULL);

/* Note! The application class gives sub-directory name.
   The NULL path means to use XFILESEARCHPATH if one is defined,
   otherwise a built-in default is provided.

   Typically install the file (on the client machine) as:
   "/usr/lib/X11/MyAppClass/base_name.bmp" */

  apathname = XtResolvePathname(cx_display,
                  app_class,
                  base_name,
                  ".bmp",
                  NULL, NULL, 0, NULL);

/* The pixmap is a small-integer handle not a structure pointer.
   We do NOT free it after assigning it as a resource setting.
   We can call XmDestroyPixmap(pixmap) when done with it,
   but not clear when that would be so not doing so.
   Repeated Get of same one is detected and cached copy is used. */

/* NOTE!
   sgi provides XmGetPixmapByDepth undocumented in Motif 1.1,
   but prototyped in <Xm.h> and later documented in Motif 1.2,
   and recommended if using other than default Visual,
   to avoid a BadMatch error setting label pixmaps.
   Pursue this only if in trouble. */

  pixmap = XmUNSPECIFIED_PIXMAP;
  if (apathname && strlen(apathname))
    pixmap = XmGetPixmap(cx_screen, apathname, fg_col, bg_col);

  if (pixmap == XmUNSPECIFIED_PIXMAP) {
    printf("cxm: %s set_pixmaps ERROR reading %s from file %s\n",
         app_name, base_name, apathname);
    if (apathname)
      XtFree(apathname);
    return;
  }

  if (apathname)
    XtFree(apathname);

  XtSetArg(args[nn], XmNlabelType, XmPIXMAP);
  nn++;
  XtSetArg(args[nn], XmNlabelPixmap, pixmap);
  nn++;

/* Insensitive pixmap if found else default,
   since otherwise goes to blank. */

  longname = (char *) malloc(strlen(base_name) + 12);

  strcpy(longname, base_name);
  strcat(longname, "_ins");

  apathname = XtResolvePathname(cx_display,
                  app_class,
                  longname,
                  ".bmp",
                  NULL, NULL, 0, NULL);

  pixmap = XmUNSPECIFIED_PIXMAP;
  if (apathname && strlen(apathname))
    pixmap = XmGetPixmap(cx_screen, apathname, fg_col, bg_col);

  if (pixmap == XmUNSPECIFIED_PIXMAP)
    pixmap = XmGetPixmap(cx_screen, "vertical", fg_col, bg_col);

  XtSetArg(args[nn], XmNlabelInsensitivePixmap, pixmap);
  nn++;

  if (apathname)
    XtFree(apathname);

/* Toggles have some more resources. */

  if (XtClass(w) == xmToggleButtonWidgetClass) {

    XtSetArg(args[nn], XmNindicatorOn, False);
    nn++;

    strcpy(longname, base_name);
    strcat(longname, "_sel");

    apathname = XtResolvePathname(cx_display,
                    app_class,
                    longname,
                    ".bmp",
                    NULL, NULL, 0, NULL);

    pixmap = XmUNSPECIFIED_PIXMAP;
    if (apathname && strlen(apathname))
      pixmap = XmGetPixmap(cx_screen, apathname, fg_col, bg_col);

    if (pixmap == XmUNSPECIFIED_PIXMAP)
      pixmap = XmGetPixmap(cx_screen, "slant_left", fg_col, bg_col);

    XtSetArg(args[nn], XmNselectPixmap, pixmap);
    nn++;

    if (apathname)
      XtFree(apathname);

    strcpy(longname, base_name);
    strcat(longname, "_insel");

    apathname = XtResolvePathname(cx_display,
                    app_class,
                    longname,
                    ".bmp",
                    NULL, NULL, 0, NULL);

    pixmap = XmUNSPECIFIED_PIXMAP;
    if (apathname && strlen(apathname))
      pixmap = XmGetPixmap(cx_screen, apathname, fg_col, bg_col);

    if (pixmap == XmUNSPECIFIED_PIXMAP)
      pixmap = XmGetPixmap(cx_screen, "slant_right", fg_col, bg_col);

    XtSetArg(args[nn], XmNselectInsensitivePixmap, pixmap);
    nn++;

    if (apathname)
      XtFree(apathname);
  }

  XtSetValues(w, args, nn);

  if (longname)
    XtFree(longname);
}

static      Widget
cxm_make_label(Widget parent, char *lname,
         char *string, Position posx, Position posy)
{
  Widget      widget;
  XmString    tcs;
  Arg       args[10];
  int       nn = 0;

  if (!lname || !strlen(lname))
    lname = "label";

  if (posx || posy) {
    XtSetArg(args[nn], XmNx, posx);
    nn++;
    XtSetArg(args[nn], XmNy, posy);
    nn++;
  }

/* At least one space now or later changes are impossible!
   Bug may be fixed by now but this can't hurt. */

  if (string && strlen(string))
    tcs = XmStringLtoRCreate(string, XmSTRING_DEFAULT_CHARSET);
  else
    tcs = XmStringLtoRCreate(" ", XmSTRING_DEFAULT_CHARSET);

  XtSetArg(args[nn], XmNrecomputeSize, True);
  nn++;
  XtSetArg(args[nn], XmNlabelString, tcs);
  nn++;

/* Use Widget (not Gadget) so we can set colors. */

  XtManageChild(widget =
          XmCreateLabel(parent, lname, args, nn));

  XmStringFree(tcs);

  return (widget);
}

#define cxm_MAKE_DEFAULT   (1L <<  0)
#define cxm_MAKE_INSENSE   (1L <<  1)
#define cxm_MAKE_ARROW   (1L <<  2)
#define cxm_MAKE_ARROW_L   (1L <<  3)
#define cxm_MAKE_ARROW_R   (1L <<  4)
#define cxm_MAKE_ARROW_U   (1L <<  5)
#define cxm_MAKE_ARROW_D   (1L <<  6)
#define cxm_MAKE_CASCADE   (1L <<  7)
#define cxm_MAKE_TOGGLE  (1L <<  8)
#define cxm_MAKE_SET_ON  (1L <<  9)
#define cxm_PUSH_STYLE_TOGGLE (1L << 10)
#define cxm_MAKE_SINGLE  (1L << 11)
#define cxm_MAKE_MULTI   (1L << 12)
#define cxm_MAKE_GADGET  (1L << 13)
#define cxm_MAKE_ARM_CB  (1L << 14)

/* The name provides a default label;
   we do not explicitly set the label,
   so that a user may provide resource to change it.

   The first single-letter is the mnemonic underlined in label,
   available only in a menu and only when it is showing.

   The second single-letter is the ctrl-key shortcut following label,
   available even when it is not showing.

   These shortcuts are dangerous! */

static      Widget
cxm_make_button(Widget parent,
        char *name,
        char mnemonic,
        char acc_key,
        int bit_flag,
        void *CB,
        void *CB_data)
{
  Widget      awidget;
  int       nn = 0;
  Arg       args[10];
  XmString    acc_text = NULL;

  unsigned char   rowcolumntype;

/* This may be too rigid a style but seems OK and it works.
   The "Ctrl+X" form is how it is shown for the user.
   This could be shorter "^X" instead.
   Make sure to fill the 'X' into the right place. */

  char       *acc_text_str = "Ctrl+ ";
  char       *accelerator_str = "Ctrl<Key> ";

/* c y a */

  if (!parent) {
    printf("cxm: %s ERROR cmx_make_button no parent\n",
         app_name);
    exit(-1);
  }

  if (!name || !strlen(name)) {
    printf("cxm: %s ERROR cmx_make_button no name\n",
         app_name);
    exit(-1);
  }

/* if there is a mnemonic key,
   it works when in a menu when visible,
   and is ignored otherwise. */

  if (mnemonic) {
    XtSetArg(args[nn], XmNmnemonic, mnemonic);
    nn++;
  }

/* if there is an accelerator key,
   it works when in a menu even when not visible,
   and is ignored otherwise. */

  if (acc_key) {
    acc_text_str[5] = acc_key;
    accelerator_str[9] = acc_key;
    acc_text = XmStringLtoRCreate(acc_text_str, XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[nn], XmNacceleratorText, acc_text);
    nn++;
    XtSetArg(args[nn], XmNaccelerator, accelerator_str);
    nn++;
  }

/* Kind of button to make depends on the kind of parent:
   XmCascadeButton[Gadget] must have parent of xmRowColumnWidgetClass
   with one of XmMENU_PULLDOWN or _POPUP or _OPTION,
   or equivalently anything but XmWORK_AREA as rowColumnType. */

  if (!bit_flag
    && (XtClass(parent) == xmRowColumnWidgetClass)) {
    nn = 0;
    XtSetArg(args[nn], XmNrowColumnType, &rowcolumntype);
    nn++;
    XtGetValues(parent, args, nn);
    if (XmWORK_AREA != rowcolumntype)
      bit_flag = cxm_MAKE_CASCADE;
  }

  if (bit_flag & cxm_MAKE_DEFAULT) {
    XtSetArg(args[nn], XmNshowAsDefault, True);
    nn++;
  }

/* Alright to set resource directly here but later only via call. */

  if (bit_flag & cxm_MAKE_INSENSE) {
    XtSetArg(args[nn], XmNsensitive, False);
    nn++;
  }

  if (bit_flag & cxm_MAKE_MULTI) {
    XtSetArg(args[nn], XmNmultiClick, XmMULTICLICK_KEEP);
    nn++;
  }

  if (bit_flag & cxm_MAKE_SINGLE) {
    XtSetArg(args[nn], XmNmultiClick, XmMULTICLICK_DISCARD);
    nn++;
  }

  if (bit_flag & cxm_MAKE_ARROW) {
    if (bit_flag & cxm_MAKE_ARROW_L) {
      XtSetArg(args[nn], XmNarrowDirection, XmARROW_LEFT);
      nn++;
    }
    else if (bit_flag & cxm_MAKE_ARROW_R) {
      XtSetArg(args[nn], XmNarrowDirection, XmARROW_RIGHT);
      nn++;
    }
    else if (bit_flag & cxm_MAKE_ARROW_U) {
      XtSetArg(args[nn], XmNarrowDirection, XmARROW_UP);
      nn++;
    }
    else {
      XtSetArg(args[nn], XmNarrowDirection, XmARROW_DOWN);
      nn++;
    }
  }

  if ((bit_flag & cxm_MAKE_TOGGLE)
    && (bit_flag & cxm_MAKE_SET_ON)) {
    XtSetArg(args[nn], XmNset, True);
    nn++;
  }

/* Does NOT look how I wanted! */

  if ((bit_flag & cxm_MAKE_TOGGLE)
    && (bit_flag & cxm_PUSH_STYLE_TOGGLE)) {
    XtSetArg(args[nn], XmNindicatorOn, False);
    nn++;
    XtSetArg(args[nn], XmNborderWidth, 2);
    nn++;
  }

/* When CascadeButton is used to pull a menu from a menubar,
   set the pulldown as this attribute on the button to make the connection.
   DO NOT use a callback routine of your own. */

  if ((bit_flag & cxm_MAKE_CASCADE)
    && !CB && CB_data) {
    XtSetArg(args[nn], XmNsubMenuId, CB_data);
    nn++;
  }

  if (bit_flag & cxm_MAKE_GADGET) {
    if (bit_flag & cxm_MAKE_CASCADE)
      awidget = XmCreateCascadeButtonGadget(parent, name, args, nn);
    else if (bit_flag & cxm_MAKE_TOGGLE)
      awidget = XmCreateToggleButtonGadget(parent, name, args, nn);
    else if (bit_flag & cxm_MAKE_ARROW)
      awidget = XmCreateArrowButtonGadget(parent, name, args, nn);
    else
      awidget = XmCreatePushButtonGadget(parent, name, args, nn);
  }

  else {
    if (bit_flag & cxm_MAKE_CASCADE)
      awidget = XmCreateCascadeButton(parent, name, args, nn);
    else if (bit_flag & cxm_MAKE_TOGGLE)
      awidget = XmCreateToggleButton(parent, name, args, nn);
    else if (bit_flag & cxm_MAKE_ARROW)
      awidget = XmCreateArrowButton(parent, name, args, nn);
    else
      awidget = XmCreatePushButton(parent, name, args, nn);
  }

  if (acc_text)
    XmStringFree(acc_text);

/* Callback if specified,
   proper for type of button,
   only one (pair for arm/disarm) but the caller could add others. */

  if (CB) {
    if (XtIsSubclass(awidget, xmToggleButtonWidgetClass)
      || XtIsSubclass(awidget, xmToggleButtonGadgetClass))
      XtAddCallback(awidget, XmNvalueChangedCallback, CB, (XtPointer)CB_data);
    else if (bit_flag & cxm_MAKE_ARM_CB) {
      XtAddCallback(awidget, XmNarmCallback, CB, (XtPointer)CB_data);
      XtAddCallback(awidget, XmNdisarmCallback, CB, (XtPointer)CB_data);
    }
    else
      XtAddCallback(awidget, XmNactivateCallback, CB, (XtPointer)CB_data);
  }

  return awidget;
}

/* NOTE! Should do this as ordinary button with special label.
   Always preserve label up through a delimiter and change tail. */

/* Ordinary pushbutton with an associated summary text display.
   Must get sibling via parent to reach the summary text.
   Called from cxm_set_terminal and from cxm_revise_node. */

/* This is called only when a Summary function is defined,
   but the Summary function may return "" or NULL;
   the NULL has special meaning as explained below. */

static void
cxm_set_button_summary(Widget button, int cols, char *summary)
{
  Widget      label, target;

  char      showstr[62];

/* c y a */

  if (!button)
    return;

  label = cx_find_named_child(XtParent(button), "summary", NULL);

  if (label)
    target = XtParent(button);
  else
    target = button;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm_set_button_summary: %s to %d width %s\n",
        XtName(button), cols, summary);
    fflush(DEBUG);
  }
#endif

/* Empty string is OK but NULL hides the button.
   We use this to hide M_R_U buttons when not valid.

   We really hide (unmanage) them,
   but we could just gray-out (unsensitive) them instead.

   Unmanage gets them out of a pulldown menu to reduce clutter.

   In a pulldown it is just a simple button,
   showing the summary string instead of the name.

   In a dialog box we unmanage the form holding label and button,
   leaving an empty but full-sized frame showing,
   but maybe it would be better to just gray them out. */

  if (summary) {
    if (!XtIsManaged(target))
      XtManageChild(target);
  }

  else {
    if (XtIsManaged(target))
      XtUnmanageChild(target);
    return;
  }

  if (cols > 60)
    cols = 60;

  showstr[0] = NULL;

  strncpy(showstr, summary, 60);

  while (strlen(showstr) < cols)
    strcat(showstr, " ");

  if (cols)
    showstr[cols] = NULL;

/* Need the 'else' for dynamic summary labels.
   But we should catch unused Summary for Option Menu here or upstream,
   rather than simply ignoring it in the following call. */

  if (label)
    cx_set_string(label, showstr);
  else
    cx_set_string(button, showstr);
}

/* We can show these in a Dialog but not in a Menu so we test parent.
   NOTE we return the button for compatability with ordinary one.  */

/* BAD! Should do this a different way -- produce a combination label,
   then could always use a simple button and show it anywhere.
   Still need this call and the updating call. */

static      Widget
cxm_make_summary_button(Widget parent,
            char *name,
            char mnemonic, char acc_key,
            char *initial, int cols,
            int bit_flag,
            void *CB,
            void *CB_data)
{
  Widget      frame;
  Widget      form;
  Widget      button;
  Widget      summary;

  unsigned char   rowcolumntype;
  XmString    tcs;
  Arg       args[10];
  int       nn = 0;

  char      showstr[62];

/* c y a */

  if (cols > 60)
    cols = 60;

  showstr[0] = NULL;

  if (initial)
    strncpy(showstr, initial, 60);

  while (strlen(showstr) < cols)
    strcat(showstr, " ");

  if (cols)
    showstr[cols] = NULL;

/* Only a simple button if parent is xmRowColumnWidgetClass
   with one of XmMENU_PULLDOWN or _POPUP or _OPTION,
   (or equivalently anything but XmWORK_AREA)
   as its rowColumnType. */

  if (XtClass(parent) == xmRowColumnWidgetClass) {
    nn = 0;
    XtSetArg(args[nn], XmNrowColumnType, &rowcolumntype);
    nn++;
    XtGetValues(parent, args, nn);
    if (XmWORK_AREA != rowcolumntype)
      return (button =
          cxm_make_button(parent, name,
                  mnemonic, acc_key,
                  bit_flag, CB, CB_data));
  }

/* Group the summary and button.
   But prevent the group from being a tab stop.
   Use a frame to make the grouping visible.
   Works w/out the frame too of course. */

  nn = 0;
  XtSetArg(args[nn], XmNshadowType, XmSHADOW_ETCHED_IN);
  nn++;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(frame =
          XmCreateFrame(parent, "summary_frame", args, nn));

  nn = 0;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(form =
          XmCreateForm(frame, "summary_form", args, nn));

/* The named button. */

  button =
    cxm_make_button(form, name,
            mnemonic, acc_key,
            bit_flag,
            CB, CB_data);

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(button, args, nn);

/* The summary will show in a label. */

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNleftWidget, button);
  nn++;

/* The default _CENTER alignment is not what we want here. */

  XtSetArg(args[nn], XmNalignment, XmALIGNMENT_BEGINNING);
  nn++;

  tcs = XmStringLtoRCreate(showstr, XmSTRING_DEFAULT_CHARSET);

  XtSetArg(args[nn], XmNlabelString, tcs);
  nn++;
  XtManageChild(summary =
          XmCreateLabel(form, "summary", args, nn));
  XmStringFree(tcs);

  return button;
}

/* Called by
   cxm_show_Yes_No_CB(NODEID anode)
   cxm_show_Dialog_CB(Widget button, ..)
   cxm_show_Terminal_CB(Widget w, ..)
   cxm_do_term_action

   Both the dialog and the parent shell must be managed if not already.
   Then popup the parent shell without any Grab.
   Finally raise to make sure this is visible. */

static void
cxm_popup_dialog(Widget dialog)
{
  if (!dialog)
    return;

  if (!XtIsManaged(dialog))
    XtManageChild(dialog);
  if (!XtIsManaged(XtParent(dialog)))
    XtManageChild(XtParent(dialog));
  XtPopup(XtParent(dialog), XtGrabNone);
  XMapRaised(XtDisplay(dialog), XtWindow(XtParent(dialog)));
}

/* Popdown the parent shell and unmanage the dialog. */

static void
cxm_popdown_dialog(Widget dialog)
{
  if (!dialog)
    return;

  XtPopdown(XtParent(dialog));
  if (XtIsManaged(dialog))
    XtUnmanageChild(dialog);
}

/* Used to position pop-up dialogs. */

static Position cxm_cursor_x;
static Position cxm_cursor_y;

/* This is called from CBs but is not itself a CB.
   It saves root coordinates recorded in the event.
   Using XQueryPointer would be a round-trip request. */

static void
cxm_save_event_coords(XtPointer call_data)
{
  XmAnyCallbackStruct *ACS = (XmAnyCallbackStruct *) call_data;
  XEvent     *XE = NULL;

  if (!call_data)
    return;

  XE = (XEvent *) ACS->event;

/* Seems not to matter but supposed to do this.
   Key and Button are all we expect or get.
   Note that 'time' is not part of the basic event,
   but is part of Key, Button, Enter, Leave. */

  if (XE->type == KeyPress || XE->type == KeyRelease) {
    cxm_cursor_x = XE->xkey.x_root;
    cxm_cursor_y = XE->xkey.y_root;
    cxm_event_time = XE->xkey.time;
  }

  else if (XE->type == ButtonPress || XE->type == ButtonRelease) {
    cxm_cursor_x = XE->xbutton.x_root;
    cxm_cursor_y = XE->xbutton.y_root;
    cxm_event_time = XE->xbutton.time;
  }
}

static Widget   cxm_default_focus = NULL;

/* Widget box is the dialog not the shell around it.
   Position the parent shell so the default button is at cursor.
   The cursor position should have been set for us.

   Calling this for AndNode,
   and String and List and FSB popup Terminals,
   and Error and Yes_No dialogs.
   Maybe will for permanent Help dialog too. */

static void
cxm_Dialog_Map_CB(Widget box,
          XtPointer client_data,
          XtPointer call_data)
{
  Position    x;
  Position    y;
  Dimension     Pwidth, Pheight, dBwidth, dBheight, xoff, yoff;
  Boolean     trav;
  Arg       args[10];
  int       nn = 0;

  NODEID      anode;

  Widget      dialogshell;

/* The CB may specify a special placement.
   I would like to traverse the focus to here as well,
   but this CB is actually called prior to mapping,
   so the traversal is denied. */

  Widget      defaultButton = (Widget) client_data;

  cxm_default_focus = defaultButton;

/* Use the cursor coordinates that were set for us. */

  x = cxm_cursor_x;
  y = cxm_cursor_y;

/* Find the shell. */

  dialogshell = box;
  while (!XtIsShell(dialogshell))
    dialogshell = XtParent(dialogshell);

/* Try to pick a default button to position at the same place. */

  nn = 0;

  if (!defaultButton) {
    XtSetArg(args[nn], XmNdefaultButton, defaultButton);
    nn++;
  }

  XtSetArg(args[nn], XtNwidth, &Pwidth);
  nn++;
  XtSetArg(args[nn], XtNheight, &Pheight);
  nn++;
  XtSetArg(args[nn], XmNuserData, &anode);
  nn++;
  XtGetValues(box, args, nn);

  if (!defaultButton)
    defaultButton =
      cx_find_named_child(dialogshell, "Yes", NULL);

  if (!defaultButton)
    defaultButton =
      cx_find_named_child(dialogshell, "Ok", NULL);

  if (!defaultButton)
    defaultButton =
      cx_find_named_child(dialogshell, "Apply", NULL);

  if (!defaultButton)
    defaultButton =
      cx_find_named_child(dialogshell, "Cancel", NULL);

/* Offset for center of default button if we have one. */

  if (defaultButton) {
    nn = 0;
    XtSetArg(args[nn], XtNx, &xoff);
    nn++;
    XtSetArg(args[nn], XtNy, &yoff);
    nn++;
    XtSetArg(args[nn], XtNwidth, &dBwidth);
    nn++;
    XtSetArg(args[nn], XtNheight, &dBheight);
    nn++;
    XtGetValues(defaultButton, args, nn);

    xoff += dBwidth / 2;
    yoff += dBheight / 2;
  }

/* Offset for center of dialog if no default button. */

  else {
    xoff = Pwidth / 2;
    yoff = Pheight / 2;
  }

/* Set dialog position so centers match unless too near an edge. */

  x -= xoff;
  y -= yoff;
  if (x - Pwidth / 2 < 0)
    x = Pwidth / 2;

  if (x > (cx_screen->width) - Pwidth / 2)
    x = (cx_screen->width) - Pwidth / 2;

  if (y - Pheight / 2 < 0)
    y = Pheight / 2;

  if (y > (cx_screen->height) - Pheight / 2)
    y = (cx_screen->height) - Pheight / 2;

/* Position the shell that parents the box.
   Use the "safe" SetValues method not XtMoveWidget. */

  cxm_move_widget(dialogshell, x, y);
}

/* Called when "box" OR ONE OF IT'S CHILDREN gets focus.
   Doing the XmPT causes another callback right away.
   Test and clear a flag BEFORE the call to avoid an endless loop. */

/* XmPT returns a True but doesn't work the first time popped up!
   Fought with this a couple of days! */

static void
cxm_Dialog_Focus_CB(Widget box,
          XtPointer client_data,
          XtPointer call_data)
{
  Widget      new_focus = (Widget) client_data;

  if (new_focus && cxm_default_focus) {
    cxm_default_focus = NULL;
    XmProcessTraversal(new_focus, XmTRAVERSE_CURRENT);
  }
}

/* --- Help Stuff --- */

static int
cxm_GetFileLen(int fd)
{
  struct stat   statbuf;
  (void) fstat(fd, &statbuf);
  return statbuf.st_size;
}

/* Most Recently Used several from given list of files.
   We use later of read or write times but could do otherwise. */

void
cxm_set_mru(char **fnames)
{
  time_t      ftime, times[MRU_MAX];
  struct stat   buff;
  int       ii, mm, nn;

  for (ii = 0; ii < MRU_MAX; ii++) {
    M_R_U[ii] = NULL;
    times[ii] = 0;
  }

  for (nn = 0; fnames[nn]; nn++) {

    if (!stat(fnames[nn], &buff)) {

      ftime = buff.st_atime;
      if (ftime < buff.st_mtime)
        ftime = buff.st_mtime;

      for (ii = 0; ii < MRU_MAX; ii++) {

/* Take next empty slot because first or older than any others on list. */

        if (times[ii] == 0) {
          times[ii] = ftime;
          M_R_U[ii] = fnames[nn];
          break;
        }

/* Newer than current occupant of this slot so bump into the list. */

        else if (times[ii] < ftime) {
          for (mm = MRU_MAX - 1; mm > ii; mm--) {
            times[mm] = times[mm - 1];
            M_R_U[mm] = M_R_U[mm - 1];
          }
          times[ii] = ftime;
          M_R_U[ii] = fnames[nn];
          break;
        }
      }
    }
  }
}

/* Search the given directory with given matching pattern.
   Subject each matching filename to further optional application test.
   A custom search proc could for example list only writable files,
   or only files with some "magic number" in the first few bytes.
   NOTE that any test of file contents updates last-access-time. */

char      **
cxm_dirscan(char *dir, char *pattern, int (*app_test) (char *))
{
  static char   test_file_name[80];

  char       *regcmp();
  char       *regex();
  int       matched = NULL;

#define MAX_FNAMES 500
  static char  *fnames[MAX_FNAMES];
  static int    fcount = 0;

/* System V or BSD flavor.
   This spelling of SYSV is declared for us on SGI machines.
   Read 'man opendir' for how to use these;
   WARNING!
   Both versions have the same calling names in different libs;
   the tell-tale clue is filenames with missing or extra characters. */

#ifdef _SYSTYPE_SYSV
#include <dirent.h>
  struct dirent  *dp = NULL;
  DIR      *dirp = NULL;
  char       *expr = NULL;
#else
#include <sys/dir.h>
  struct direct  *dp = NULL;
  DIR      *dirp = NULL;
  int       badexp = 1;
#endif

/* Release any file names from prior use. */

  while (fcount > 0)
    free(fnames[--fcount]);

  fnames[0] = NULL;

/* Default to 'dot' (current at program start) if no directory specified. */

  if (!dir || !strlen(dir))
    dir = ".";

  if (pattern && strlen(pattern)) {
#ifdef _SYSTYPE_SYSV
    expr = (char *) regcmp(pattern, NULL);
#else
    badexp = re_comp(pattern);
#endif
  }

/* Open the specified or default directory and check each file.
   Find "nothing" if unable to open the directory. */

  if (dirp = opendir(dir)) {

    while (dp = readdir(dirp)) {

/* Accept names matching regular expression or all if no expression. */

#ifdef _SYSTYPE_SYSV
      matched = !expr || (regex(expr, dp->d_name, NULL) != NULL);
#else
      matched = badexp || (re_exec(dp->d_name) > 0);
#endif

/* Accepted names must still pass custom file test to be listed.
   Use the full path name or start from dot,
   so the app-test and later uses can get at the file. */

      if (matched) {
        strcpy(test_file_name, dir);
        strcat(test_file_name, "/");
        strcat(test_file_name, dp->d_name);

        if (!app_test || app_test(test_file_name)) {
          fnames[fcount++] = strdup(test_file_name);
          fnames[fcount] = NULL;
        }
      }
    }
    closedir(dirp);
  }

#ifdef _SYSTYPE_SYSV
  free(expr);
#endif

/* return pointer to our static array of alloc'd names.
   we will free them and clear it before re-use on next call. */

  return fnames;
}

/* Attempt to open the named file with read privelege,
   working down the directory list until sucess or empty.

   The list uses space or colon separators and null termination.

   If no directory list (zero), or a null list, is provided,
   the current 'dot' directory is assumed.

   If a directory list is provided, we start with dot anyway,
   then work down the list.  This is less general than using
   only directory list, done for compatability with argos,
   which considers FILEDIR only if not local.

   NOTE that failure due to permissions in an early directory
   causes attempt in later directory just as if not found. */

static char   cxm_file_name[256];

static int
cxm_opener(char *name, char *dirlist)
{

/* Attempting to read a non-existent file returns failure,
   but creates the file.  The next try finds it.

   We prevent this by using access test (which works correctly)
   to see if the file exists before doing the open. */

  char       *fx;
  char       *nx;
  int       fd;

/* c y a */

  if (!name || !strlen(name))
    return (-1);

  strcpy(cxm_file_name, name);

/* First try the name as full pathname with leading slash,
   or relative pathname with leading dot or double-dot,
   or short (local) name if no dirlist was provided. */

  if (((name[0] == DIRSLASH)
    || (name[0] == '.')
    || !dirlist)
   && (access(name, 0) == 0)
   && (fd = open(name, O_RDONLY)))
      return (fd);

/* Otherwise try along the search path if one is given.
   Look in 'dot' only as it appears in the search path. */

  if (!dirlist)
    return (-1);

  while (*dirlist != '\0' && *dirlist != ':' && *dirlist != ' ') {
    fx = cxm_file_name;
    nx = name;
    while (*dirlist != '\0' && *dirlist != ':' && *dirlist != ' ')
      *fx++ = *dirlist++;
    *fx++ = DIRSLASH;
    while (*fx++ = *nx++);

    if (access(cxm_file_name, 0) == 0)
      if (fd = open(cxm_file_name, O_RDONLY))
        return (fd);

    if (*dirlist == ' ' || *dirlist == ':')
      dirlist++;
  }
  return (-1);
}

/* This buffer pointer is shared by cxm_GetSource and cxm_What_Which */

static char  *retbuff = 0;

static char  *
cxm_GetSource(char *filename)
{
  int       fd, flen;

  char       *apathname = NULL;

  static char   searchpath[100];

  static char   fail_message[100];

/* Release prior buffer allocation.
   Caller could have sooner but at least prevents build-up.
   Be sure not to release it twice! */

  if (retbuff) {
    free(retbuff);
    retbuff = 0;
  }

/* c y a */

  if (!filename || !strlen(filename))
    return ((char *) NULL);

/* Leading "#" means string constant rather than file name.
   Caller attempting to free() this would be an error!
   We could pass back a copy just to be safe. */

  if (filename[0] == '\#')
    return &filename[1];

/* Note! The application class gives sub-directory name.
   The NULL path means to use XFILESEARCHPATH if one is defined,
   otherwise a built-in default is provided.

   Read the man page for XtResolvePathname for how it works.

   Typically install the file (on the client machine) as:
   "/usr/lib/X11/MyAppClass/base_name.txt"

   First try the approved X location with ".txt" extension.

   XtResolvePathname sets apathname if it finds the file,
   and the open should always succeed but we test anyway.

   Otherwise apathname is NULL (or somehow the open failed)
   so try the "old-style" locations w/out ".txt" extension.

   Pass back a fail_message to show instead if nothing found. */

  if (!(apathname = XtResolvePathname(cx_display,
                    app_class,
                    filename,
                    ".txt",
                    NULL, NULL, 0, NULL))
    || ((fd = cxm_opener(apathname, NULL)) < 0)) {

    if (!searchpath[0]) {
      if (getenv("GHELP"))
        strcat(searchpath, getenv("GHELP"));
      strcat(searchpath, " ");
      if (getenv("FILEDIR"))
        strcat(searchpath, getenv("FILEDIR"));
    }

    if ((fd = cxm_opener(filename, searchpath)) < 0) {
      strcpy(fail_message, "Cannot open: ");
      strcat(fail_message, filename);
      return fail_message;
    }
  }

  if (apathname)
    XtFree(apathname);

/* Found it somewhere... */

  flen = cxm_GetFileLen(fd);

  while (flen && !(retbuff = (char *) malloc(flen + 1))) {
    printf("cxm: %s GetSource ERROR cannot alloc buffer size %d\n",
         app_name, flen);
    flen = flen / 2;
  }

  if (!flen)
    return ((char *) NULL);

  if (read(fd, retbuff, flen) <= 0) {
    printf("cxm: %s GetSource ERROR reading file %s\n",
         app_name, filename);
    strcpy(fail_message, "Cannot read: ");
    strcat(fail_message, filename);
    return fail_message;
  }

  retbuff[flen] = NULL;

  close(fd);
  return retbuff;
}

/* Buffered read is MUCH faster than going after each character.
   No idea what the ideal buffer size would be. */

#define FILE_BUFF_LEN 2000
static char   file_buff[FILE_BUFF_LEN];

static int    cxm_file_fd, cxm_file_nfilled, cxm_file_next;

static int
cxm_next_file_char(char *put)
{
  if (cxm_file_next >= cxm_file_nfilled) {
    cxm_file_nfilled = read(cxm_file_fd, file_buff, FILE_BUFF_LEN);
    cxm_file_next = 0;
  }

  if (cxm_file_next < cxm_file_nfilled) {
    *put = file_buff[cxm_file_next++];
    return 1;
  }
  return cxm_file_nfilled;
}

/* SCCS version info,
   same as running "what" on file found by "which" tools. */

static char  *
cxm_What_Which(Boolean long_form)
{
  int       flen, blen, ii;
  int       scan;
  char      next[2];

  struct stat   fstat_buff;
  static char   time_stamp[40];

/* Release prior buffer allocation.
   Caller could have sooner but at least prevents build-up.
   Be sure not to release it twice! */

  if (retbuff) {
    free(retbuff);
    retbuff = 0;
  }

/* Find the executable file (this program) somewhere along search path,
   which was used by the shell to find and execute this program,
   so we should find the same file now. */

  if ((cxm_file_fd = cxm_opener(app_name, getenv("PATH"))) < 0) {
    if (retbuff = (char *) malloc(strlen(app_name) + 30)) {
      strcpy(retbuff, "Cannot open: ");
      strcat(retbuff, app_name);
    }
    return retbuff;
  }

  cxm_file_nfilled = 0;
  cxm_file_next = 0;

  flen = cxm_GetFileLen(cxm_file_fd);

/* Should be enough -- if not leave some off the end! */

  blen = flen / 200;

  while (blen && !(retbuff = (char *) malloc(blen + 1))) {
    printf("cxm: %s cannot alloc buffer size %d\n",
         app_name, blen);
    blen = blen / 2;
  }

  if (!blen)
    return ((char *) NULL);

  ii = 0;
  retbuff[ii] = NULL;

/* recreate the time stamp */

  fstat(cxm_file_fd, &fstat_buff);

  ascftime(time_stamp, " %d %b %Y %T",
       localtime(&fstat_buff.st_mtime));

  sprintf(retbuff,
      "file %s\n\
%s\n\
Xm Ver %d Rev %d Rel %d XProto Ver %d Rev %d\n\
%s\n\
%s\n\
Debug info: %s\n",
      cxm_file_name,
      time_stamp,
      XmVERSION, XmREVISION,
      VendorRelease(cx_display),
      XProtocolVersion(cx_display),
      XProtocolRevision(cx_display),
  DoesBackingStore(cx_screen) ? "Does Backing Store" : "No Backing Store",
      DoesSaveUnders(cx_screen) ? "Does Save Unders" : "No Save Unders",
      getenv("GUI_DEBUG") ? debugfile : "No setenv GUI_DEBUG");

/* Also try extern int xmUseVersion (note little x) for runtime info. */

#ifdef _SYSTYPE_SYSV
  strcat(retbuff, "cxm compiled with _SYSTYPE_SYSV - regcmp & regex\n");
#else
  strcat(retbuff, "cxm compiled w/out _SYSTYPE_SYSV - re_comp & re_exec\n");
#endif

#if defined (FUNCPROTO) || defined (__STDC__) || defined (__cplusplus) || defined(c_plusplus)
  strcat(retbuff, "cxm compiled with FUNCPROTO or __STDC__ or C++\n");
#else
  strcat(retbuff, "cxm compiled w/out FUNCPROTO or __STDC__ or C++\n");
#endif

#if defined (NeedFunctionPrototypes)
  strcat(retbuff, "cxm compiled with X11/NeedFunctionPrototypes\n");
#else
  strcat(retbuff, "cxm compiled w/out X11/NeedFunctionPrototypes\n");
#endif

/* SCCS info will follow... */

  if (long_form) {

    ii = strlen(retbuff);

/* A little state-machine:
   Scan the executable for the "@(#)" pattern that begins an info line.
   Then copy everything until a NULL or '\n' or '~' or '>' char,
   replace any of them by a new-line and temporary null terminator. */

#define scan_at 0
#define scan_lp 1
#define scan_pd 2
#define scan_rp 3
#define scan_tx 4

    scan = scan_at;

    while ((ii < blen)
         && (cxm_next_file_char(next) == 1)) {

      switch (scan) {
      case scan_at:
        if (next[0] == '@')
          scan = scan_lp;
        break;

      case scan_lp:
        if (next[0] == '(')
          scan = scan_pd;
        else
          scan = scan_at;
        break;

      case scan_pd:
        if (next[0] == '#')
          scan = scan_rp;
        else
          scan = scan_at;
        break;

      case scan_rp:
        if (next[0] == ')')
          scan = scan_tx;
        else
          scan = scan_at;
        break;

      case scan_tx:
        if ((next[0] != '\n')
          && (next[0] != '~')
          && (next[0] != '>')
          && (next[0] != NULL))
          retbuff[ii++] = next[0];
        else {
          scan = scan_at;
          retbuff[ii++] = '\n';
        }
        break;
      }
    }

    retbuff[ii++] = NULL;
  }

  close(cxm_file_fd);
  return retbuff;
}

static char  *cxm_latest_help = NULL;

static void
cxm_zap_Help(void)
{
  if (Help_Dialog) {
    XtUnmanageChild(Help_Dialog);
    XtDestroyWidget(Help_Dialog);
    Help_Dialog = NULL;
  }
}

static void
cxm_Help_OK_CB(Widget w,
         XtPointer client_data,
         XtPointer call_data)
{
  cxm_zap_Help();
}

/* Forward reference for the CB. */

static void 
cxm_Help_CB(Widget w,
      XtPointer client_data, XtPointer call_data);

/* Still making a new one each time... */

static      Widget
cxm_make_Help_popup(Widget parent)
{
  int       nn = 0;
  Arg       args[10];
  Widget      FD, TW, button;

/* The popup form.
   Simple border w/out any controls or title.
   Otherwise we would set XmNdialogTitle.

   Until we change to use the dialog popper,
   this DOES use default positioning so leave it True. */

  nn = 0;
  XtSetArg(args[nn], XmNnoResize, True);
  nn++;
  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;

/* We have our own dismissal methods. */

  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;

  FD = XmCreateFormDialog(parent, "help_form", args, nn);

/* Recognize F1 in the popup and use it with NULL to dismiss the popup. */

  XtAddCallback(FD, XmNhelpCallback, cxm_Help_CB, NULL);

/* The button to dismiss the popup form. */

  XtManageChild(button =
          cxm_make_button(FD, "Ok",
                  NULL, NULL, cxm_MAKE_DEFAULT,
                  cxm_Help_OK_CB,
                  NULL));

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(button, args, nn);

/* The read-only text viewer. */

  nn = 0;
  XtSetArg(args[nn], XmNeditMode, XmMULTI_LINE_EDIT);
  nn++;
  XtSetArg(args[nn], XmNeditable, False);
  nn++;
  XtSetArg(args[nn], XmNcursorPositionVisible, False);
  nn++;

/* Should not have V Scroller unless needed. */

  XtSetArg(args[nn], XmNrows, 12);
  nn++;
  XtSetArg(args[nn], XmNresizeHeight, False);
  nn++;

/* Should not have H Scroller ever.
   Allow for 80 cols and wrap instead of clip if any wider. */

  XtSetArg(args[nn], XmNcolumns, 80);
  nn++;
  XtSetArg(args[nn], XmNscrollHorizontal, False);
  nn++;
  XtSetArg(args[nn], XmNwordWrap, True);
  nn++;

/* Prevent disaster if bad call. */

  XtSetArg(args[nn], XmNmaxLength, 4000);
  nn++;

  XtManageChild(TW =
          XmCreateScrolledText(FD, "help", args, nn));

/* Attach the Scroller parent of TW to the Form. */

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNtopWidget, button);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(XtParent(TW), args, nn);

  return FD;
}

/* This will become type void with a permanent Help dialog. */

static      Widget
cxm_fill_Help_popup(Widget parent, char *text)
{
  int       nn = 0;
  Arg       args[10];
  Widget      FD, TW, button;

  int       rows = 0, cols = 0, cc = 0;
  char       *scan = text;

  if (!text || !strlen(text))
    return NULL;

/* Find rows and cols required by given text. */

  while (*scan) {
    for (cc = 0; *scan && *scan != '\n'; scan++)
      cc++;
    scan++;
    rows++;
    if (cols < cc)
      cols = cc;

/* Comment line (beyond any misplaced header) is early stop. */

    if ((rows > 2) && (*scan == '#'))
      *scan = NULL;
  }

  if (cols > 80)
    cols = 80;

  if (rows > 24)
    rows = 24;

/* This will already exist with a permanent Help dialog. */

  FD = cxm_make_Help_popup(parent);
  if (TW = cx_find_named_child(FD, "help", NULL)) {
    nn = 0;
    XtSetArg(args[nn], XmNrows, rows);
    nn++;
    XtSetArg(args[nn], XmNcolumns, cols);
    nn++;
    XtSetValues(TW, args, nn);
    XmTextSetString(TW, text);
  }
  return FD;
}

/* FUTURES! See Heller p. 479-482 example 15-4,
   expand this to a pop-up error log dialog,
   called from any internal errors or gui alarms.
   Provide an Ok button to pop down,
   and a Cancel button that each caller may show or hide,
   useful from some gui-reported failure conditions. */

/* Either a Help button or F1 key comes here.

   If one is currently showing we just clear it and leave.
   This lets the user mouse along the menubar while tapping F1.

   We formerly used (w) to parent and thus position the popup.

   But this coredumps if (w) is the button part of a cxm_summary_button.
   So just use cx_toplevel and be done with it.
   That works fine but always comes up in the middle!
   New way of making summary button should fix this.

   The client_data is a filename to show.
   Zero means called from Error popup so show help for Error node,
   or the nearest ancestral node with a help topic.

   Zero call_data means called via context-help.
   Better pass some event if we care to know a position. */

/* Remember that F1 does helpCallback for current focus - not under cursor!
   This is confusing when not the the balloon topic you just read.
   If a balloon topic was showing we use it regardless of focus.
   Tangled! */

/* Seems we pop up Help even if no file and then take it down again? */

static void
cxm_Help_CB(Widget w,
      XtPointer client_data,
      XtPointer call_data)
{
  char       *text;
  NODEID      anode;

/* Save coordinates and time of latest event. */

  cxm_save_event_coords(call_data);


  if (Balloon_Dialog)
    XtUnmanageChild(Balloon_Dialog);

/* In case we care (w == Help_Dialog) means F1 in Help to dismiss it.
   We now compare topic instead and only show a new one if it IS new.
   If the dismissal comes too soon after the request ignore it.
   We could update the base-time but that ignores too many. */

  if (Help_Dialog) {
    if (cxm_event_time - cxm_help_time < 1000)
      return;
    cxm_zap_Help();
    if (cxm_latest_help == (char *) client_data)
      return;
  }

/* Show full text of current balloon topic if any... */

  if (Balloon_Node);

  else if (client_data)
    cxm_latest_help = (char *) client_data;

  else if (Error_Node) {
    anode = Error_Node;
    while (!Node_Help(anode))
      anode = Node_Back(anode);
    cxm_latest_help = Node_Help(anode);
  }

  else
    return;

/* Recognize magic name "about" or "version" as not a help file. */

  if (!strcasecmp(cxm_latest_help, "about"))
    text = cxm_What_Which(False);

  else if (!strcasecmp(cxm_latest_help, "version"))
    text = cxm_What_Which(True);

/* Should name a help file. */

  else
    text = cxm_GetSource(cxm_latest_help);

/* We will fill it and pop it up at cursor position like the others. */

  if (text && strlen(text))
    XtManageChild(Help_Dialog =
            cxm_fill_Help_popup(cx_toplevel, text));

  cxm_help_time = cxm_event_time;
}

/* To begin modal-context-sensitive-help rooted in named widget.
   Special cursor is confined to widget until a choice is made. */

static void
cxm_Context_CB(Widget w,
         XtPointer client_data,
         XtPointer call_data)
{
  Widget      hit;
  static Cursor   question_arrow = NULL;

/* Get an ID for alternate cursor for in-context-help.
   Lots of other neat shapes to choose from! */

  if (!question_arrow)
    question_arrow =
      XCreateFontCursor(XtDisplay(w), XC_question_arrow);

/* Chosen Widget. */

  hit = XmTrackingLocate((Widget) client_data,
               question_arrow,
               True);

/* Show help if any,
   else fall back until help or top of tree. */

  while (hit) {
    if (XtHasCallbacks(hit, XmNhelpCallback) == XtCallbackHasSome) {
      XtCallCallbacks(hit, XmNhelpCallback, 0);
      return;
    }
    hit = XtParent(hit);
  }
}

/* If we ever want to set cursor for other windows here is how...
   Create as above from one of cursorfont.h shapes.
   Or see O'Reilly Vol 1 Ch 6 example to make custom shapes.
   Remember to use depth of 1 rather than default depth.
   Then do what XmTrackingLocate above does internally:
   Assign cursor to window by XDefineCursor(display, window, cursor);
   Revert to parent cursor by XUndefineCursor(display, window); */

/* Different enough to warrant a separate positioning function. */

static void
cxm_Balloon_Map_CB(Widget form,
           XtPointer client_data,
           XtPointer call_data)
{
  Position    x;
  Position    y;
  Dimension     Pwidth, Pheight;
  Arg       args[10];
  int       nn = 0;

  Widget      dialogshell;

/* Use the cursor coordinates that were set for us. */

  x = cxm_cursor_x;
  y = cxm_cursor_y;

/* Find the shell. */

  dialogshell = form;
  while (!XtIsShell(dialogshell))
    dialogshell = XtParent(dialogshell);

  nn = 0;
  XtSetArg(args[nn], XtNwidth, &Pwidth);
  nn++;
  XtSetArg(args[nn], XtNheight, &Pheight);
  nn++;
  XtGetValues(form, args, nn);

/* Set dialog shell position to leave subject widget visible.
   Offset to right of button if in left half of screen and so forth.
   Remember that origin is top left corner.
   This will keep popup away from the edges. */

  if (x < (cx_screen->width) / 2)
    x += 20;
  else
    x = x - 20 - Pwidth;

  if (y < (cx_screen->height) / 2)
    y += 30;
  else
    y = y - 30 - Pheight;

/* Position the shell that parents the form.
   Use the "safe" SetValues method not XtMoveWidget. */

  cxm_move_widget(dialogshell, x, y);
}

static      Widget
cxm_make_Balloon_popup(Widget parent)
{
  int       nn = 0;
  Arg       args[10];
  Widget      FD, TW;

/* The popup form.
   Simple border w/out any controls or title.
   Otherwise we would set XmNdialogTitle. */

  nn = 0;
  XtSetArg(args[nn], XmNnoResize, True);
  nn++;
  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;
  XtSetArg(args[nn], XmNmwmDecorations, MWM_DECOR_BORDER);
  nn++;

/* We will position it ourselves when mapped. */

  XtSetArg(args[nn], XmNdefaultPosition, False);
  nn++;

/* We have our own dismissal methods. */

  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;

/* This returns the form rather than the shell. */

  FD = XmCreateFormDialog(parent, "balloon_form", args, nn);

/* This will position it. */

  XtAddCallback(FD, XmNmapCallback, cxm_Balloon_Map_CB, NULL);

/* No attachments needed -- label will fill the form.
   Give it a special name for easy resource setting. */

  XtManageChild(TW = cxm_make_label(FD, "balloon", NULL, 0, 0));

/* The default _CENTER alignment is not what we want here. */

  nn = 0;
  XtSetArg(args[nn], XmNalignment, XmALIGNMENT_BEGINNING);
  nn++;
  XtSetValues(TW, args, nn);

  return FD;
}

static void
cxm_fill_Balloon_popup(char *text)
{
  int       nn = 0;
  Arg       args[10];
  Widget      TW = cx_find_named_child(Balloon_Dialog, "balloon", NULL);
  XmString    tcs = XmStringLtoRCreate(text, XmSTRING_DEFAULT_CHARSET);

  if (tcs) {
    XtSetArg(args[nn], XmNlabelString, tcs);
    nn++;
    XtSetValues(TW, args, nn);

    XmStringFree(tcs);
  }
}

/* Balloon covering subject button generates a Leave event!
   Then removing the Balloon generates another Enter event!
   We offset to prevent this but should test here anyway.
   Could check for no-change of event-coordinates. */

static void
cxm_Enter_Leave_EH (Widget button,
         XtPointer client_data,
         XEvent * event,
         Boolean *continue_to_dispatch) {
  char       *text;
  NODEID      anode = (NODEID) client_data;
  int       ii;
  XEvent      later_event;
  int       inside;

  char      topic[40];

/* Bill suggests also using these events for audible feedback,
   again only when the feature is turned on,
   and only for nodes that want it,
   maybe specifying their sound.
   Who would need this? */

/* Leaving this widget to Enter a child is not really leaving.
   Entering this widget from a child is not really entering either.
   This test covers both cases,
   but does not catch separate handlers (with same topic) parent and child.
   We would like to ignore this transition too,
   better yet should not have such handlers installed. */

  if (event->xcrossing.detail == NotifyInferior)
    return;

  if (Balloon_Dialog && XtIsManaged(Balloon_Dialog))
    XtUnmanageChild(Balloon_Dialog);

  Balloon_Node = NULL;

/* Nothing more to do if balloon help is not wanted. */

  if (!want_Balloon)
    return;

/* Create the Balloon popup at first need and keep for later use. */

  if (!Balloon_Dialog)
    Balloon_Dialog = cxm_make_Balloon_popup(cx_toplevel);

/* Post help for visited widget or nearest ancestor with a topic. */

  if (event->type == EnterNotify) {

/* Ignore visit if just quickly passing through.
   (These may already be "compressed" away w/out our doing this.) */

    inside = 1;
    while (XCheckWindowEvent(cx_display, XtWindow(button),
             EnterWindowMask | LeaveWindowMask, &later_event)) {
      if (later_event.xcrossing.detail != NotifyInferior)
        inside = (later_event.type == EnterNotify);
    }

    if (!inside)
      return;

/* This is my NEW effort to avoid trouble.  Seems to work. */

    if (Help_Dialog)
      return;

/* BUG? This is my OLD effort to avoid trouble.  Didn't work. */

    cxm_zap_Help();

/* Wrong member of the union but seems to work alright.
   The mapping CB will use the coordinates. */

    cxm_cursor_x = event->xkey.x_root;
    cxm_cursor_y = event->xkey.y_root;
    cxm_event_time = event->xkey.time;

/* We could adjust from actual event position,
   for constant offset from the best corner of the widget.
   Right and down offsets would need button dimensions. */

/* Needed a special way to get topics for anything under Help menu,
   because they are not part of application node tree.
   We indicate this by using Node Zero. */

    if (anode) {
      while (!Node_Help(anode))
        anode = Node_Back(anode);
      cxm_latest_help = Node_Help(anode);
    }

/* One of the built-in ones so no topic.
   Instead use the name of the visited widget.
   But convert any embedded space to underline for file name.
   (We could just name them with underlines but it looks bad.) */

    else {
      strcpy(topic, XtName(button));
      for (ii = 0; topic[ii]; ii++)
        if (topic[ii] == ' ')
          topic[ii] = '_';
      cxm_latest_help = topic;
    }

    if (text = cxm_GetSource(cxm_latest_help)) {

/* To show only the intro portion of a topic,
   truncate at special "\n\n" or "\n#" marker,
   which means a blank line or comment line,
   but not on a first-line that is blank or comment. */

      ii = 0;
      while (text[ii])
        if (ii
          && (text[ii + 1] == '\n')
          && ((text[ii + 2] == '\n')
            || (text[ii + 2] == '\#'))) {
          text[ii + 1] = NULL;
          break;
        }
        else
          ii++;

/* Fill it and show it.
   The mapping CB will use the cursor coordinates we saved. */

      if (text && strlen(text)) {
        cxm_fill_Balloon_popup(text);
        XtManageChild(Balloon_Dialog);
        Balloon_Node = anode;
      }
    }
  }
}

/* The showBalloon and hideBalloon buttons both come here.
   So does property change but w/out either button. */

static void
cxm_want_Balloon_CB(Widget either_button,
          XtPointer new_state,
          XtPointer unused_call_data)
{
  if (want_Balloon == (int) new_state)
    return;

  want_Balloon = (int) new_state;

  if (want_Balloon) {
    XtManageChild(hideBalloon);
    XtUnmanageChild(showBalloon);
  }
  else {
    XtManageChild(showBalloon);
    XtUnmanageChild(hideBalloon);
  }

/* Post our new state only if caused by a button.
   I am posting to rootwindow,
   but really only one designated "manager" job should do so.
   Maybe decoupled from the pulldown menu as own call,
   from some control panel?

   This will cause a Change event but we will ignore it.
   And remember to pass properly cast ->address<- of the value! */

  if (either_button)
    XChangeProperty(cx_display, cx_rootwindow,
            _GUI_BALLOON_HELP, XA_INTEGER, 32, PropModeReplace,
            (unsigned char *) &want_Balloon, 1);
}

/* Want Enter and Leave events but cannot OR the masks together.
   The (client_data) arg can pass whatever is handy in a long.
   We pass the node for which to show help text.
   The False concerns "unmaskable" events;
   O'Reilly Vol 4 says ALWAYS FALSE when we spec any other event. */

/* Calling this on some widgets causes a crash!
   The incr and decr buttons of cycle and value composites crashed.
   Maybe they were gadgets for which we now branch around it.
   Works fine on the whole composite so I didn't pursue it... */

static Widget
cxm_set_Enter_Leave(Widget w, NODEID anode)
{
  if (XtIsWidget(w)) {
    XtAddEventHandler(w,
            EnterWindowMask, False,
            cxm_Enter_Leave_EH, (XtPointer)anode);
    XtAddEventHandler(w,
            LeaveWindowMask, False,
            cxm_Enter_Leave_EH, (XtPointer)anode);
  }
  return w;
}

/* --- Node Update Support --- */

/* Report current dict stack. */

static void
cxm_uidump(char *from)
{
  UIDATA     *ii;
  int       level;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG, "dump from %s\n", from);
    for (level = Actives; level > 0; level--) {
      fprintf(DEBUG,
          "level %d %s\n", level, Node_Name(Active_Nodes[level]));
      for (ii = Data[level];
         ii;
         ii = Data_Sibling(ii)) {
        fprintf(DEBUG,
            "%s ", Data_Name(ii));
        switch (Data_Kind(ii)) {
        case LONGVAL:
          fprintf(DEBUG, "L=%d\n", Data_LValue(ii));
          break;
        case FLOATVAL:
          fprintf(DEBUG, "F=%f\n", Data_FValue(ii));
          break;
        case DOUBLEVAL:
          fprintf(DEBUG, "D=%f\n", Data_DValue(ii));
          break;
        case STRINGVAL:
          fprintf(DEBUG, "S=%s\n", Data_SValue(ii));
          break;
        default:
          fprintf(DEBUG, "U=%d\n", Data_SValue(ii));
        }
      }
    }
    fflush(DEBUG);
  }
#endif
}

#define cxm_MAX_NODES 500

static Widget   NodeTypeIn[cxm_MAX_NODES];
static Boolean  NodeReversed[cxm_MAX_NODES];
static Widget   NodeButton[cxm_MAX_NODES];
static Widget   NodeBox[cxm_MAX_NODES];
static Widget   NodeValue[cxm_MAX_NODES];
static Widget   NodePopupMenu[cxm_MAX_NODES];

static char  *NodeChoiceSet[cxm_MAX_NODES];
static char  *NodeChoiceInit[cxm_MAX_NODES];
static Boolean  NodeChoiceChange[cxm_MAX_NODES];

/* Show a button needing confirmation in reverse video.
   This is the "normal" appearance before the first click.
   Not great looking but workable. */

static void
cxm_set_button_confirm(NODEID node, Boolean confirm)
{

/* c y a */

  if (!NodeButton[node])
    return;

  if (NodeReversed[node] != confirm)
    cx_reverse(NodeButton[node]);

  NodeReversed[node] = confirm;
}

/* Forward definition! */

static void
choose_one_CB(Widget w,
        XtPointer client_data,
        XtPointer call_data);

/* Called only by cxm_set_terminal,
   which is called only by cxm_revise_node,
   which is called by several.

   Single choice via option menu.
   Disabled when nothing to choose from,
   or when the latest value does not match any of the choices.
   Neither "ALL" or "NONE" are acceptable here. */

static void
cxm_set_option_menu(char *choice_set, char *latest, NODEID anode)
{
  Arg       args[10];
  int       nn = 0;

  Cardinal    numchildren;
  WidgetList    children;
  Widget      child;
  int       ii, nb;

  Widget      history;

  if (!NodeBox[anode]) {
    printf("cxm: %s set_option_menu ERROR no menu for %s\n",
         app_name, Node_Name(anode));
    return;
  }

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s set optmenu %s to %s from %s\n",

        app_name, Node_Name(anode), latest, choice_set);
    fflush(DEBUG);
  }
#endif

/* Learn current button (gadget) children of the pulldown Box;
   destroy any button gadget not on current list,
   note if we happen to destroy history. */

  XtVaGetValues(NodeBox[anode],
          XtNchildren, &children,
          XtNnumChildren, &numchildren,
          XmNmenuHistory, &history,
          NULL);

  for (ii = 0; ii < numchildren; ii++)
    if (!wordcount(listops(choice_set, '*', XtName(children[ii])))) {
      if (history == children[ii])
        history = NULL;
      XtDestroyWidget(children[ii]);
    }

/* Create any named on current list but not yet in pulldown Box. */

  nb = wordcount(choice_set);
  for (ii = 0; ii < nb; ii++)
    if (!cx_find_named_child(NodeBox[anode],
                  wordx(ii, choice_set), NULL))
      XtManageChild(
              cxm_make_button(NodeBox[anode],
                      wordx(ii, choice_set),
                      NULL, NULL,
                      cxm_MAKE_GADGET,
                      choose_one_CB,
                      (void *) anode));

/* Learn numchildren of the pulldown Box again.
   If none at all create "None" button and make it the history setting.
   Bad news if empty menu. */

  XtVaGetValues(NodeBox[anode],
          XtNnumChildren, &numchildren,
          NULL);

  if (!numchildren)
    XtManageChild(history =
            cxm_make_button(NodeBox[anode],
                    "None",
                    NULL, NULL,
                    cxm_MAKE_GADGET,
                    NULL,
                    (void *) anode));

/* Set history to latest if any specified and found. */

  else if (wordcount(listops(choice_set, '*', latest)))
    history = cx_find_named_child(NodeBox[anode],
                     latest,
                     NULL);

/* Prevent very long single columns. */

  if (numchildren > 8)
    XtVaSetValues(NodeBox[anode],
            XmNnumColumns, 1 + (numchildren / 8),
            XmNpacking, XmPACK_COLUMN,
            NULL);
  else
    XtVaSetValues(NodeBox[anode],
            XmNnumColumns, 1,
            XmNpacking, XmPACK_TIGHT,
            NULL);

/* Old (but valid) history if no latest or could not match.
   Default to first choice if no old one. */

/* NOTE!
   Without this (first choice) some work but some crash,
   and doing it does not make anything crash. */

  if (!history)
    history =
      cx_find_named_child(NodeBox[anode],
                 wordx(0, choice_set),
                 NULL);

  if (history) {
    XtVaSetValues(NodeButton[anode],
            XmNmenuHistory, history,
            NULL);

/* This may not be best place to do this... */

    if (!HaveValue(Node_Name(anode))
      || strcmp(GetString(Node_Name(anode)), XtName(history)))
      DefString(Node_Name(anode), XtName(history));
  }
}

/* Called only by cxm_set_terminal,
   which is called only by cxm_revise_node,
   which is called by several.

   Make list selections agree with wants.
   Disabled when nothing to choose from.
   Widget list is the List so All and None buttons are siblings.
   The extra level of parent is the scrolled window holding the list. */

/* A couple of not-serious problems:

   Adding new wider item to a List should adjust width as it needs,
   or else provide a horizontal scroller.
   Does neither but does the vertical size properly.

   We call here if either the set or init has changed.
   We do a lot of wasted string work if the set has not changed.
   Maybe we could call here with a what-changed-flag. */

static void
cxm_set_choices(Widget list, char *choice_set, char *choice_init)
{
  int       nn = 0;
  Arg       args[10];
  int       itemx, itemcount, selecteditemcount;
  int      *pos_list = NULL;
  int       pos_count;

  Widget      all_button =
  cx_find_named_child(XtParent(XtParent(list)), "All", NULL);
  Widget      none_button =
  cx_find_named_child(XtParent(XtParent(list)), "None", NULL);

  int       ii, nst, valid, wanted, selected, want_all;

  char       *wants_working = NULL;

/* This will point to actual instance data and should NOT be freed. */

  XmString     *items;

/* This is our own and SHOULD be freed. */

  XmString     *xmnewstr;

  char       *text = NULL;

  unsigned char   policy;

/* c y a */

  if (!list)
    return;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm_set_choices %s %s %s\n",
        XtName(list), choice_set, choice_init);
    fflush(DEBUG);
  }
#endif

/* Maybe a problem with this "keeping" one item? Ok but see O'Reilly Six. */

  if (!choice_set || !wordcount(choice_set)) {
    XmListDeleteAllItems(list);
    return;
  }

/* Convert the new choice_set to array of compound strings.
   NOTE wordx returns address of a static buffer so use it right away. */

  nst = wordcount(choice_set);
  xmnewstr = (XmString *) XtMalloc(sizeof(XmString) * nst);
  for (ii = 0; ii < nst; ii++)
    xmnewstr[ii] = XmStringCreate(wordx(ii, choice_set),
                    XmSTRING_DEFAULT_CHARSET);

/* Learn items currently in widget. */

  XtVaGetValues(list,
    XmNselectionPolicy, &policy,
    XmNitemCount, &itemcount,
    XmNitems, &items,
    NULL);

/* Delete any item currently in widget but not in new choice_set.
   NOTE we count down rather than up to stay in "good" part of list;
   remember we have a pointer to the instance data and it is changing.
   Better to get a fresh version after every delete but this works.
   No guarantee that it will always work! */

  for (itemx = itemcount; itemx; itemx--) {
    for (nn = 0; nn < nst; nn++)
      if (XmStringCompare(items[itemx - 1], xmnewstr[nn]))
        break;
    if (nn == nst) {
      XmListDeleteItem(list, items[itemx - 1]);
    }
  }

/* Add any item in new choice_set but not currently in widget.
   A 1 thru N insert position makes new item first through Nth.
   Zero means last position until someone else claims it.
   Free all the strings (and their pointer array) when done with them. */

  for (nn = 0; nn < nst; nn++) {
    if (!XmListItemExists(list, xmnewstr[nn]))
      XmListAddItemUnselected(list, xmnewstr[nn], nn + 1);
    XtFree((char *)xmnewstr[nn]);
  }
  XtFree((char *)xmnewstr);

/* Learn items currently in widget again. */

  XtVaGetValues(list, 
    XmNitemCount, &itemcount,
    XmNitems, &items,
    XmNselectedItemCount, &selecteditemcount,
    NULL);

/* Adjust (but limit) the visible size. */

  if (itemcount > 10)
    nst = 10;
  else
    nst = itemcount;

  XtVaSetValues(list, 
    XmNvisibleItemCount, nst,
   NULL);

/* Get list and count of selected item positions.
   NOTE position 1 appearing in list means items[0] is selected etc. */

/* Correct for apparent BUG in XmLGSP when none selected... */

  if (selecteditemcount > 0)
    XmListGetSelectedPos(list, &pos_list, &pos_count);

  pos_count = selecteditemcount;

  if (!choice_init
    || !strlen(choice_init)
    || !strcasecmp(choice_init, "NONE")) {
    XmListDeselectAllItems(list);
    selecteditemcount = 0;

    if (all_button)
      XtSetSensitive(all_button, True);

    if (none_button)
      XtSetSensitive(none_button, False);

    return;
  }

  want_all = (!strcasecmp(choice_init, "ALL"));

/* no idea why we needed to make a copy but we did! */

  wants_working = strdup(choice_init);

/* Select actually reverses each item,
   so we should call it for any not selected but wanted,
   or already selected but not wanted.  */

  for (itemx = 1; itemx <= itemcount; itemx++) {

    XmStringGetLtoR(items[itemx - 1], XmSTRING_DEFAULT_CHARSET, &text);

    wanted = want_all || wordcount(listops(wants_working, '*', text));

    for (nn = 0; nn < pos_count; nn++)
      if (pos_list[nn] == itemx)
        break;
    selected = (nn < pos_count);

/* Notice!
   Making a new selection in SINGLE_SELECT mode turns off the old one,
   so DO NOT also explicitly turn it off or it comes back on!
   Harmless if you turn the old one off BEFORE setting new one,
   but causes a problem if it happens to come AFTER. */

    if ((wanted && !selected)
     || ((!wanted && selected)
      && (policy != XmSINGLE_SELECT)))
      XmListSelectPos(list, itemx, False);

    free(text);
  }

  free(wants_working);

/* To adjust the all_button and the none_button,
   learn item and selection count again. */

  if (all_button || none_button) {
    XtVaGetValues(list,
      XmNitemCount, &itemcount,
      XmNselectedItemCount, &selecteditemcount,
      NULL);

    if (all_button)
      XtSetSensitive(all_button, (selecteditemcount < itemcount));

    if (none_button)
      XtSetSensitive(none_button, (selecteditemcount > 0));
  }
}

static void
cxm_set_sensitive(Widget parent, char *name, Boolean sensitive)
{
  Widget      thing = cx_find_named_child(parent, name, NULL);
  if (thing)
    XtSetSensitive(thing, sensitive);
}

/* Called only from cxm_set_terminal,
   for CHOICE_TERM and SELECT_TERM.
   CAUTION!
   Both N_C_Set and NC_Init may ultimately call same "xxxquery" routine,
   these often fill a static buffer with their reply and return a pointer,
   so a static result of first call is trashed by the second.
   We make copies and return True if either is new. */

static      Boolean
cxm_update_choices(NODEID anode)
{
  char       *nch;
  Boolean     changed = False;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm_update_choices %s changed:%d\n",
        Node_Name(anode), NodeChoiceChange[anode]);
    fflush(DEBUG);
  }
#endif

  if (NodeChoiceChange[anode])
    return True;

/* Node_Choice_Set is always specified for CHOICE,
   but may not be for SELECT,
   and anyway may return NULL. */

  if ((nch = Cond(Node_Choice_Set(anode), anode))) {

#ifdef DEBUG
    if (DEBUG) {
      fprintf(DEBUG,
          "node %s choice_set %s\n",
          Node_Name(anode), nch);
      fflush(DEBUG);
    }
#endif

    if (NodeChoiceSet[anode]) {
      if (strcmp(NodeChoiceSet[anode], nch)) {
        changed = True;
        XtFree(NodeChoiceSet[anode]);
        NodeChoiceSet[anode] = strdup(nch);
      }
    }
    else {
      changed = True;
      NodeChoiceSet[anode] = strdup(nch);
    }
  }

  else if (NodeChoiceSet[anode]) {
    changed = True;
    XtFree(NodeChoiceSet[anode]);
    NodeChoiceSet[anode] = NULL;
  }

/* Node_Choice_Init specification is optional.

   Note! We should MAYBE default it to GetString(Node_Name(anode))
   to avoid exactly this construct appearing in application code,
   where it ensures showing changes made by other actions.
   But do it carefully and test it thoroughly;
   there have been problems here before! */

  if ((nch = Cond(Node_Choice_Init(anode), anode))) {

#ifdef DEBUG
    if (DEBUG) {
      fprintf(DEBUG,
          "node %s choice_init %s\n",
          Node_Name(anode), nch);
      fflush(DEBUG);
    }
#endif

    if (!strcasecmp(nch, "ALL"))
      nch = NodeChoiceSet[anode];
    else if (!strcasecmp(nch, "NONE"))
      nch = "";

    if (NodeChoiceInit[anode]) {
      if (strcmp(NodeChoiceInit[anode], nch)) {
        changed = True;
        DefString(Node_Name(anode), nch);
        XtFree(NodeChoiceInit[anode]);
        NodeChoiceInit[anode] = strdup(nch);
      }
    }
    else {
      changed = True;
      DefString(Node_Name(anode), nch);
      NodeChoiceInit[anode] = strdup(nch);
    }
  }

/* KLUDGE!
   Lack of the default mentioned above finally nails us in Combo Box!
   The extra test here prevents a "second update" to a null selection. */

  else if (NodeChoiceInit[anode] && !NodeTypeIn[anode]) {
    changed = True;
    DefString(Node_Name(anode), "");
    XtFree(NodeChoiceInit[anode]);
    NodeChoiceInit[anode] = NULL;
  }

  NodeChoiceChange[anode] = changed;
  return changed;
}

/* Only first-show needs call this because incr/decr already checks. */

static void
cxm_set_term_limits(NODEID anode)
{
  long      temp_long, lim_long;
  float       temp_float, lim_float;
  double      temp_double, lim_double;

  switch (Node_Term_Kind(anode)) {

  case INT_TERM:
    temp_long = GetLong(Node_Name(anode));

    if (Node_Long_Min(anode)
      && (temp_long < (lim_long = Node_Long_Min(anode) (anode))))
      DefLong(Node_Name(anode), lim_long);

    else if (Node_Long_Max(anode)
         && (temp_long > (lim_long = Node_Long_Max(anode) (anode))))
      DefLong(Node_Name(anode), lim_long);

    break;

  case FLOAT_TERM:
    temp_float = GetFloat(Node_Name(anode));

    if (Node_Float_Min(anode)
      && (temp_float < (lim_float = Node_Float_Min(anode) (anode))))
      DefFloat(Node_Name(anode), lim_float);

    else if (Node_Float_Max(anode)
        && (temp_float > (lim_float = Node_Float_Max(anode) (anode))))
      DefFloat(Node_Name(anode), lim_float);

    break;

  case DOUBLE_TERM:
    temp_double = GetDouble(Node_Name(anode));

    if (Node_Double_Min(anode)
      && (temp_double < (lim_double = Node_Double_Min(anode) (anode))))
      DefDouble(Node_Name(anode), lim_double);

    else if (Node_Double_Max(anode)
       && (temp_double > (lim_double = Node_Double_Max(anode) (anode))))
      DefDouble(Node_Name(anode), lim_double);

    break;

  }
}

/* Call to set each terminal when a node is mapped or changed.
   The widget parentage is not accurate for popups,
   so we keep track of associated Widgets to update them.

   We should compare old and new values and only do what is needed.
   This is part of the larger issue of dependencies,
   but worth doing even a partial job. */

static void
cxm_set_terminal(int parent_kind, NODEID anode, Boolean first)
{
  Widget      term;
  int       cols;
  char       *show;

  XmString    tcs = NULL;
  Boolean     able;

/* Omit attribute is evaluated ONLY at gui creation.  Flag later. */

  if (Node_Omitted(anode))
    return;

  if (first && Node_On_Entry(anode))
    Node_On_Entry(anode) (anode);

  if (first)
    cxm_set_term_limits(anode);

/* Summary is not supported by all terminals -- should test here. */

  if (Node_Summary(anode))
    cxm_set_button_summary(NodeButton[anode],
                 Cond(Node_Term_Width(anode), anode),
                 Node_Summary(anode) (anode));

  if (Node_Label_Color(anode))
    cxm_set_widget_color(NodeButton[anode],
               Node_Label_Color(anode) (anode), NULL, True);

  else if (Node_Body_Color(anode))
    cxm_set_widget_color(NodeButton[anode],
               Node_Body_Color(anode) (anode), NULL, False);

/* We could find a popbutton of the name but not the popup for a list.
   The dialog is not a child of the parent even if we create it as such.
   So we help the search a bit by starting with the popup.
   Other special cases for numeric and cyclic compound widgets. */

  switch (Node_Term_Kind(anode)) {

  case BOOLEAN_TERM:
    cx_set_on_off(NodeButton[anode], GetLong(Node_Name(anode)), False);
    break;

/* Using several styles for choices so update accordingly.
   Safer to test what this IS rather than deduce what it SHOULD BE!
   And the situation keeps getting worse...

   NOTICE!
   The presence of a Node_Enable_Ok(anode) attribute for a choose-one,
   if the parent is a Dialog rather than a menu,
   means a Combo Box instead of an Option Menu.
   The updates required are different;
   both the List and type-in Field.

   There should always be a N_C_Set attribute even if null or empty,
   but the N_C_Init attribute is optional,
   and may be spec'd "ALL" or "NONE" if known always so. */

  case CHOICE_TERM:
    if (cxm_update_choices(anode)) {
      if ((parent_kind == AndNode)
       && !Node_Enable_Ok(anode)
       && (Cond(Node_Choice_Max(anode), anode) == 1))
        cxm_set_option_menu(NodeChoiceSet[anode],
                  NodeChoiceInit[anode],
                  anode);
      else {
        cxm_set_choices(NodeBox[anode], NodeChoiceSet[anode], NodeChoiceInit[anode]);
/* If this is a Combo Box,
   must also update the type-in TextField. */

        if (NodeTypeIn[anode]) {
          cx_set_string(NodeTypeIn[anode], GetString(Node_Name(anode)));

          if (NodeReversed[anode])
            cx_reverse(NodeTypeIn[anode]);

          NodeReversed[anode] = False;
        }
      }
    }
    NodeChoiceChange[anode] = False;
    break;

/* There may be a memory leak when setting a new string.
   Some discussion on netmail but no resolution. */

  case INT_TERM:
    cx_set_string(NodeValue[anode],
             Node_Term_Encode(anode) (GetLong(Node_Name(anode)),
                    Cond(Node_Term_Width(anode), anode)));
    break;

  case FLOAT_TERM:
    cx_set_string(NodeValue[anode],
             Node_Term_Encode(anode) (GetFloat(Node_Name(anode)),
                    Cond(Node_Term_Width(anode), anode)));
    break;

  case DOUBLE_TERM:
    cx_set_string(NodeValue[anode],
             Node_Term_Encode(anode) (GetDouble(Node_Name(anode)),
                    Cond(Node_Term_Width(anode), anode)));
    break;

/* The next cyclic word to show is copied to a static buffer. */

  case CYCLE_TERM:
    show = wordx(GetLong(Node_Name(anode)),
           Node_Choice_Set(anode) (anode));

/* Ok to work in the static buffer to adjust appearance?
   Maybe not anymore!
   Could be a BUG here!
   Better see how wordx provides it. */

    cols = Cond(Node_Term_Width(anode), anode);
    while (strlen(show) < cols)
      strcat(show, " ");

    if (cols)
      *(show + cols) = NULL;

    cx_set_string(NodeValue[anode], show);
    break;

  case STRING_TERM:
    cx_set_string(NodeValue[anode], GetString(Node_Name(anode)));
    break;

  case SELECT_TERM:
    if (cxm_update_choices(anode)) {
      tcs = XmStringLtoRCreate(NodeChoiceSet[anode],
                   XmSTRING_DEFAULT_CHARSET);
      XmFileSelectionDoSearch(NodeBox[anode], tcs);
      XmStringFree(tcs);
    }
    NodeChoiceChange[anode] = False;
    break;

  case STRUCT_TERM:

    if (!HaveValue(Node_Name(anode)))
      uiinitval(Node_Name(anode), STRUCT_TERM);

    cx_set_string(NodeValue[anode],
        Node_Term_Encode(anode) ((void *) GetStruct(Node_Name(anode)),
                     Cond(Node_Term_Width(anode), anode)));
    break;
  }

/* Sensitivity is not always the same as Widget that gets the value. */

  able = True;

  switch (Node_Term_Kind(anode)) {

  case BOOLEAN_TERM:
    term = NodeButton[anode];
    break;

/* Disable if no or empty choice_set. */

  case CHOICE_TERM:
    term = NodeButton[anode];
    able = (NodeChoiceSet[anode] && (wordcount(NodeChoiceSet[anode]) > 0));
    break;

  case INT_TERM:
    term = NodeBox[anode];
    break;

  case FLOAT_TERM:
    term = NodeBox[anode];
    break;

  case DOUBLE_TERM:
    term = NodeBox[anode];
    break;

  case CYCLE_TERM:
  case STRING_TERM:
  case SELECT_TERM:
  case STRUCT_TERM:
    if (NodeButton[anode])
      term = NodeButton[anode];
    else
      term = NodeBox[anode];
    break;

/* SELECT
  term = NodeBox[anode];
  break;
*/

/* STRUCT
  term = NodeBox[anode];
  break;
*/
  }

  if (term && XtIsWidget(term)) {
    if (able && Node_Enable_Choice(anode))
      XtSetSensitive(term, Node_Enable_Choice(anode) (anode));
    else
      XtSetSensitive(term, able);
  }
}

/* --- Node State Stuff --- */

/* This could be in the uilib but it isn't.  Just as well for now. */

static void
cxm_uipush(NODEID anode)
{
  Active_Nodes[++Actives] = anode;
  Data[Actives] = 0;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: push %d %s as level %d\n",
        anode, Node_Name(anode), Actives);
    fflush(DEBUG);
  }
#endif

}

/* WE NEED TO USE NODE_DISCARD ATTRIBUTE! */

static void
cxm_uiappend(void)
{

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: uiappend %s %d into level %d\n",
        Node_Name(UITOP), UITOP, Actives - 1);
    fflush(DEBUG);
  }
#endif

  uiappend();
}

static void
cxm_uidiscard(void)
{

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: uidiscard %s %d at level %d\n",
        Node_Name(UITOP), UITOP, Actives);
    fflush(DEBUG);
  }
#endif

  uidiscard();
}

static void
cxm_zap_Error(void)
{
  cxm_popdown_dialog(Error_Dialog);
  Error_Node = NULL;
}

/* Callback for the Error buttons.
   Just the OK for now.
   This may grow to check which button and provide retry.

   The "classic example" is failing to write a save-file,
   going outside the dialog to correct a permission problem,
   then coming back in to ask for the retry. */

static void
cxm_Error_CB(Widget button,
       XtPointer client_data,
       XtPointer call_data)
{
  cxm_zap_Error();
}

static      Widget
cxm_make_Error_popup(Widget parent)
{
  int       nn = 0;
  Arg       args[10];
  Widget      dialog;

/* The popup form.
   Simple border w/out any controls or title.
   Otherwise we would set XmNdialogTitle.
   Size to fit contents;
   they change from one appearance to the next. */

  nn = 0;
  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;
  XtSetArg(args[nn], XmNmwmDecorations, MWM_DECOR_BORDER);
  nn++;

/* We have our own dismissal methods. */

  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;

/* We will position it ourselves when mapped. */

  XtSetArg(args[nn], XmNdefaultPosition, False);
  nn++;

/* Dialog is not managed yet or it would be shown too soon.
   Special name so resources can be set. */

  dialog = XmCreateErrorDialog(parent, "error", args, nn);

  XtAddCallback(dialog, XmNokCallback, cxm_Error_CB, NULL);

  XtAddCallback(dialog, XmNmapCallback, cxm_Dialog_Map_CB, NULL);

/* This will show help for the node posting the error. */

  XtAddCallback(dialog, XmNhelpCallback, cxm_Help_CB, NULL);

  XtUnmanageChild(
          XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON));

  return dialog;
}

static void
cxm_zap_Yes_No(void)
{
  Yes_No_Node = NULL;
  cxm_popdown_dialog(Yes_No_Dialog);
}

/* Called from a callback but not a callback itself. */

static void
cxm_show_Yes_No_CB(NODEID anode)
{
  if (!Yes_No_Dialog)
    return;

  Yes_No_Node = anode;

  if (!Yes_No_Node)
    return;

  cxm_popup_dialog(Yes_No_Dialog);
}

/* Show an Error message for a failed Action.
   Accept either a "direct string" or (better!) a "@file" name.
   The file name lookup allows for language flexibility.
   It uses the same search path as for help files. */

static void
cxm_show_Error(NODEID anode, char *message)
{
  XmString    tcs = NULL;

  Error_Node = anode;

  if (!Error_Node)
    return;

/* Leading '@' means the rest is a file name. */

  if (message[0] == '@')
    message = cxm_GetSource(message + 1);

  tcs = XmStringLtoRCreate(message, XmSTRING_DEFAULT_CHARSET);

  XtVaSetValues(Error_Dialog,
          XmNmessageString, tcs,
          NULL);
  XtFree((char *)tcs);

  cxm_popup_dialog(Error_Dialog);

/* A user can set the bell volume off if they want to... */

  cx_ring_bell(cx_display);
}

/* The dialogs proper as returned by Create -- not their shells. */

static Widget   Dialog_Stack[10];

/* We only allow one open at any time. */

static Widget   Terminal_Dialog = NULL;

/* Should not be called if no Action but return False if so.
   Attempt Node_Action for (terminal or inner) node.
   Post message and return False if action fails.
   Otherwise True. */

static      Boolean
cxm_do_node_action(NODEID anode)
{
  char       *node_reply = NULL;

  if (!Node_Action(anode))
    return False;

  node_reply = Node_Action(anode) (anode);

  if (node_reply && strlen(node_reply)) {
    cxm_show_Error(anode, node_reply);
    return False;
  }

/* Calls exit(0) to terminate the Application after any final action.
   Any button named "Exit" will do this.
   There should probably be only one. */

  if (!strcmp(Node_Name(anode), "Exit"))
    exit(0);

  return True;
}

/* Called by cxm_showing_node when a Menu is pulled or a Dialog is popped,
   or by cxm_Dialog_Complete(NODEID anode)
   which is called by cxm_do_term_action
   when a child (terminal) action also completes the parent,
   or directly by cxm_do_term_action(NODEID anode, Boolean remain)
   following any terminal input in a Dialog,
   or by cxm_Dialog_OK_CB following OK completion of a child of Dialog,
   or by cxm_Dialog_Reset_CB which is similar to terminal input.

   Chance to set value and sensitivity of terminals and built-ins.

   When a node is revised the summary in the parent is done first,
   even though it is probably hidden by the expanded node,
   then each child summary in the same order they are declared.
   Values set by the parent summary may be used by the others,
   to avoid repeated evaluation that would have the same result.  */

static void   cxm_showing_node(NODEID anode);

static void
cxm_revise_node(NODEID anode, Boolean first)
{
  NODEID      child;

  Boolean     show_ok;
  Widget      Ok_button, Apply_button;

/* c y a */

  if (!anode)
    return;

/* We enable the toolbar (and its children) only at this time,
   since otherwise using it would close whatever was open,
   which probably is not what the user wants. */

  if (toolbar)
    XtSetSensitive(toolbar, (anode == Toolbar_Node));

  cxm_uidump("revise_node");

/* Omit attribute is evaluated ONLY at gui creation.
   We create widgets at start or not at all.
   We test this Flag later. */

  if (Node_Omitted(anode))
    return;

/* Actually no way for a Menu to get second use,
   except for the permanent root level menubar,
   because others exit after any click in Motif.
   So we can save the effort of updating it. */

  if (first
    || (Node_Kind(anode) != OrNode)
    || (anode == ROOTNODE)) {

/* Summary is not supported by all terminals -- should test here. */

    if (Node_Summary(anode))
      cxm_set_button_summary(NodeButton[anode],
                   Cond(Node_Term_Width(anode), anode),
                   Node_Summary(anode) (anode));

    if (Node_Label_Color(anode))
      cxm_set_widget_color(NodeButton[anode],
                 Node_Label_Color(anode) (anode), NULL, True);

    else if (Node_Body_Color(anode))
      cxm_set_widget_color(NodeButton[anode],
                 Node_Body_Color(anode) (anode), NULL, False);

/* Let all terminals show current values.
   (But some may have nothing to show or wait until expanded.)
   Some may set sensitivity per own N_Enable_Choice attributes. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (Node_Kind(child) == TermNode)
        cxm_set_terminal(Node_Kind(anode), child, first);

/* Also update sensitivity / confirm / summary attributes of
   buttons for Immediate and further internal (And/Or) children. */

      else {
        if (Node_Enable_Choice(child) && NodeButton[child])
          XtSetSensitive(NodeButton[child],
                   Node_Enable_Choice(child) (child));

/* Change appearance as clue that double-click would be required.
   The special appearance is BEFORE the first click. */

        if (Node_Confirm(child))
          cxm_set_button_confirm(child,
                       Node_Confirm(child) (child));

        if (Node_Label_Color(child))
          cxm_set_widget_color(NodeButton[child],
                 Node_Label_Color(child) (child), NULL, True);

        else if (Node_Body_Color(child))
          cxm_set_widget_color(NodeButton[child],
                 Node_Body_Color(child) (child), NULL, False);

/* Summary is not supported by all terminals -- should test here. */

        if (Node_Summary(child))
          cxm_set_button_summary(NodeButton[child],
                    Cond(Node_Term_Width(child), child),
                       Node_Summary(child) (child));
      }
    }

/* Set sensitivity of Ok and/or Apply buttons if there is a test.
   Need extra parent level because NBox is the parent of any terminals,
   but sibling of the action panel holding these buttons. */

/* Should disable Reset until something has changed that can be reset.
   Too much trouble for now. */

    if ((Node_Kind(anode) == AndNode)
      && Node_Enable_Ok(anode)) {
      show_ok = Node_Enable_Ok(anode) (anode);

      if (Ok_button = cx_find_named_child(XtParent(NodeBox[anode]),
                         "Ok",
                         NULL))
        XtSetSensitive(Ok_button, show_ok);

      if (Apply_button = cx_find_named_child(XtParent(NodeBox[anode]),
                          "Apply",
                          NULL))
        XtSetSensitive(Apply_button, show_ok);
    }
  }

/* If revision rather than first show see about Auto action.
   Then remember to check Remain after an Action. */

  if (!first
    && !By_Gui_Ext
    && Node_Action(anode)
    && Node_Auto_Ok(anode)
    && cxm_do_node_action(anode))
    Node_Acted(anode) = 1;

/* If there is a toolbar,
   make it "default active" if nothing else is on the stack. */

  if (Toolbar_Node && (UITOP == ROOTNODE))
    cxm_showing_node(Toolbar_Node);
}

static void
cxm_cancel_node(anode)
{

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: cancel_node %s level %d Actives %d\n",
        Node_Name(anode), Node_Level(anode), Actives);
    fflush(DEBUG);
  }
#endif

  if (Dialog_Stack[Node_Level(anode)]) {
    cxm_popdown_dialog(Dialog_Stack[Node_Level(anode)]);
    Dialog_Stack[Node_Level(anode)] = NULL;
  }

  if (Terminal_Dialog) {
    cxm_popdown_dialog(Terminal_Dialog);
    Terminal_Dialog = NULL;
  }

  if (Node_On_Exit(anode))
    Node_On_Exit(anode) (anode);

  cxm_uidiscard();
  cxm_zap_Yes_No();
  cxm_zap_Error();
}

/* Called by cxm_do_term_action(NODEID anode, Boolean remain)
   when a child (terminal) action also completes the parent. */

static void
cxm_Dialog_Complete(NODEID anode)
{

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s Dialog_Complete %s %d\n",
        app_name, Node_Name(anode), anode);
    fflush(DEBUG);
  }
#endif

/* Finish the dialog.
   If any dialogs ABOVE this are still open close them first,
   being sure to pop them down too. */

  while (Actives > Node_Level(anode))
    cxm_cancel_node(UITOP);

/* Close this dialog too. */

  if (Dialog_Stack[Node_Level(anode)]) {
    cxm_popdown_dialog(Dialog_Stack[Node_Level(anode)]);
    Dialog_Stack[Node_Level(anode)] = NULL;
  }

/* Close any open terminal (eg. List) box. */

  if (Terminal_Dialog) {
    cxm_popdown_dialog(Terminal_Dialog);
    Terminal_Dialog = NULL;
  }

/* Skip the node Action,
   since one of the children has done enough,
   but commit any changes and leave as if we did. */

  if (Node_On_Exit(anode))
    Node_On_Exit(anode) (anode);

  cxm_uiappend();

/* If the dialog was popped from an Or node,
   it is already unmapped but the stack still needs adjustment. */

  while ((UITOP > ROOTNODE) && (Node_Kind(UITOP) == OrNode)) {
    if (Node_On_Exit(UITOP))
      Node_On_Exit(UITOP) (UITOP);
    cxm_uiappend();
  }

/* Update an open parent Dialog on completion of this Dialog. */

  cxm_revise_node(UITOP, False);
}

/* Called from lots of terminal CBs:
   cxm_Yes_No_CB(Widget button,
   cxm_FSB_CB(Widget fsbd, XtPointer client_data, XtPointer call_data)
   cxm_Imm_CB(Widget push,
   cxm_Bool_CB(Widget toggle,
   cxm_list_multi_CB(Widget w,
   cxm_list_single_CB(
   cxm_cycle_CB(Widget w,
   cxm_value_ID_CB(Widget w,
   etc etc

   If in a menu it will popdown now,
   and append or discard (per attribute) adjusts the dictionary stack.

   But a dialog will stay open so we append dicts to not lose result,
   then make the new dict level again for later activity in box.

   Motif style guide says no Actions in a dialog except via Ok or Apply,
   but we have Immediates and Terminals with Actions anyway. */

/* THIS MUST GET MORE COMPLICATED FOR DISCARD!
   Time for the state machine model! */

static void
cxm_do_term_action(NODEID anode, Boolean remain)
{
  NODEID      back = Node_Back(anode);

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: do_term_action %s %d remain %d\n",
        Node_Name(anode), anode, remain);
    fflush(DEBUG);
  }
#endif

  cxm_zap_Help();
  cxm_zap_Yes_No();
  cxm_zap_Error();

/* Do the action unless we are here for an Application-caused update,
   in which case doing it could lead to an endless loop.

   Actions may return a failure report string or zero if Ok.
   Report the failure in a popup Error dialog.
   The popup is not modal so it is cleared by any next action.

   We could provide a choice of Retry / Cancel and loop on action.
   One way is to test the last character of message for question mark!

   Use Question rather than Error just for the big question mark pixmap.
   This would not be modal either so also cleared by any next action,
   but "come back around to here" if the Retry is chosen.

   See how Yes_No defers the action until a Yes choice.

   The Action did not "really" happen so try to stay as if not.
   An Or node menu will pop down regardless of outcome. */

  if (!By_Gui_Ext && Node_Action(anode)) {

    if (!cxm_do_node_action(anode))
      return;

    Node_Acted(back) = 1;

/* A terminal action may also complete the parent dialog,
   for example by choosing a "packaged" setup to execute,
   rather than making individual settings.

   Node_Auto_Ok(terminal) means to cxm_Dialog_Complete(parent)
   w/out waiting for the Ok button,
   w/out doing the normal Node_Action(parent). */

    if (Cond(Node_Auto_Ok(anode), anode)) {
      cxm_Dialog_Complete(back);
      return;
    }

    cxm_uiappend();

    if (remain || (Node_Kind(back) == AndNode))
      cxm_uipush(back);
  }

  cxm_revise_node(back, False);
}

/* Callback for the Yes or No buttons.
   Also may call directly with NULL button to reset. */

static void
cxm_Yes_No_CB(Widget button,
        XtPointer client_data,
        XtPointer call_data)
{
  if (button
    && !strcasecmp(XtName(button), "Yes")
    && Yes_No_Node
    && !By_Gui_Ext && Node_Action(Yes_No_Node)) {

/* We defer any On_Entry code until it is needed for the Action. */

    if (Node_On_Entry(Yes_No_Node))
      Node_On_Entry(Yes_No_Node) (Yes_No_Node);

    cxm_do_term_action(Yes_No_Node, False);
  }
  cxm_zap_Yes_No();
  cxm_zap_Error();
}

/* Called when a Menu is pulled down or a Dialog is popped up. */

static void
cxm_showing_node(NODEID anode)
{
  NODEID      child;

/* Node zero means Help menu rather than part of application.
   We could (but do not) cancel any-in-progress in the usual way. */

  if (!anode)
    return;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s showing node %s as level %d\n",
        app_name, Node_Name(anode), Actives);
    fflush(DEBUG);
  }
#endif

  if ((Node_Kind(anode) == AndNode)
    || (Node_Kind(anode) == OrNode)) {

/* Before pushing the selected node onto the active stack,
   we check current stack and get rid of any alternate sibling,
   and anything descended from it. */

    while (Actives >= Node_Level(anode))
      cxm_cancel_node(UITOP);

    cxm_uipush(anode);

/* The new node has not yet issued an action. */

    Node_Acted(anode) = 0;

/* Do any entry code unless we already have. */

    if (Node_On_Entry(anode) && !DOUBLE_CLICK)
      Node_On_Entry(anode) (anode);

/* True for newly visible node. */

    cxm_revise_node(anode, True);
  }
}

static      Widget
cxm_make_Yes_No_popup(Widget parent)
{
  int       nn = 0;
  Arg       args[10];
  Widget      FD, Yesbutton, Nobutton;

/* The popup form.
   Simple border w/out any controls or title.
   Otherwise we would set XmNdialogTitle.
   Size to fit contents, */

  nn = 0;
  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;
  XtSetArg(args[nn], XmNmwmDecorations, MWM_DECOR_BORDER);
  nn++;

/* We have our own dismissal methods. */

  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;

/* We will position it ourselves when mapped. */

  XtSetArg(args[nn], XmNdefaultPosition, False);
  nn++;

/* Dialog is not managed yet or it would be shown too soon.
   Special name so resources can be set. */

  FD = XmCreateFormDialog(parent, "yes_no", args, nn);

/* We will position it when mapped. */

  XtAddCallback(FD, XmNmapCallback, cxm_Dialog_Map_CB, NULL);

/* Some button (later) will show it instead of doing action */

  XtManageChild(Yesbutton =
          cxm_make_button(FD, "Yes",
                  NULL, NULL, NULL, cxm_Yes_No_CB, NULL));

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(Yesbutton, args, nn);

  XtManageChild(Nobutton =
          cxm_make_button(FD, "No",
                  NULL, NULL, NULL, cxm_Yes_No_CB, NULL));

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNleftWidget, Yesbutton);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(Nobutton, args, nn);

  return FD;
}

/* Timers for detecting double-clicked buttons.
   If the timeout matures no double click came so popup the dialog. */

static XtIntervalId cxm_TimeOut_Id = NULL;
static NODEID cxm_TimeOut_node = NULL;

static XtTimerCallbackProc
cxm_TimeOut(XtPointer client_data, XtIntervalId iid)
{ 
  cxm_popup_dialog((Widget) client_data);

  cxm_TimeOut_node = NULL;
  cxm_TimeOut_Id = NULL;
}

/* Clear a pending timer if any.
   Set a new one if wanted. */

static void
cxm_set_TimeOut(Widget dialog, NODEID anode)
{ 

  if (cxm_TimeOut_Id)
    XtRemoveTimeOut(cxm_TimeOut_Id);
  cxm_TimeOut_Id = NULL;

  cxm_TimeOut_node = anode;

/* Should not have to (cast) these arguments! */

  if (dialog && anode)
    cxm_TimeOut_Id =
      XtAppAddTimeOut(appcontext,
        cx_TimeOut_Time,
      (XtTimerCallbackProc) cxm_TimeOut,
      (XtPointer) dialog);
}

/* Forward reference. */

static void
cxm_Dialog_OK_CB(Widget button, XtPointer client_data, XtPointer call_data);

/* This CB is called when the show Dialog button is clicked.
   Widget client_data is the dialog proper to be shown.
   It has the node as userData.

   We provide short-cut activation here.
   If the node has an Action and either no-or-True Enable_Ok,
   a user can do it and leave w/out bothering to show the panel.
   The action will use existing (possibly default) settings.

   Short-cut is taken either for double Click or Shift+Click.

   Leave any further management to the popped callback. */

static void
cxm_show_Dialog_CB(Widget button,
           XtPointer client_data, XtPointer call_data)
{
  Arg       args[10];
  int       nn = 0;
  NODEID      anode;

  static int short_cut_ok;

  XmPushButtonCallbackStruct *PBCS =
  (XmPushButtonCallbackStruct *) call_data;

  XEvent     *XE =
  (XEvent *) PBCS->event;

  cxm_save_event_coords(call_data);

  cxm_zap_Help();
  cxm_zap_Error();

  XtVaGetValues((Widget) client_data,
    XmNuserData, &anode,
    NULL);

/* At first click,
   recognized by this node not having a timeout pending,
   decide if a short-cut is possible for this Dialog node.
   We must do N_On_Entry before N_Enable_Ok test,
   since the test often depends on values that are initialized. */

  if (cxm_TimeOut_node != anode) {

   if (Node_Action(anode)) {
      if (Node_Enable_Ok(anode) && Node_On_Entry(anode))
        Node_On_Entry(anode) (anode);

      short_cut_ok = (!Node_Enable_Ok(anode)
        || Node_Enable_Ok(anode) (anode));
    }

/* Not the first click,
   or no short-cut possible here.
   Details follow. */

    else
      short_cut_ok = FALSE;
  }

/* A second click on the same node before the timeout matures,
   or a shift modified first click,
   cancels the timeout and takes the short-cut. */

  if (DOUBLE_CLICK =
       ((cxm_TimeOut_node == anode)
     || (short_cut_ok
      && (XE->xbutton.state & ShiftMask != 0)))) {

    cxm_set_TimeOut(NULL, NULL);

    cxm_showing_node(anode);
    Dialog_Stack[Node_Level(anode)] = NULL;
    cxm_Dialog_OK_CB(NULL,
                 (XtPointer) anode,
                 (XtPointer) NULL);
  }

/* if short-cut activation is possible,
   establish a timeout with this node pending. */

  else if (short_cut_ok) {
    cxm_set_TimeOut((Widget) client_data, anode);
  }

/* otherwise cancel pending timer and show the dialog. */

  else {
    cxm_set_TimeOut(NULL, NULL);
    cxm_popup_dialog((Widget) client_data);
  }
}

/* This CB is called when the Terminal open button is clicked,
   or possibly activated by a memonic if the button is in a menu.
   Some Terminal nodes have an expanded popup view for data entry.

   We provide short-cut activation here.
   If the node has an Action and either no-or-True Enable_Ok,
   a user can do it and leave w/out bothering to show the panel.
   The action will use the existing (possibly default) value.

   Positioning works properly for mnemonic but not for menu button click.

   Widget client_data is the dialog proper to be shown.
   Both the dialog and its parent shell must be managed if not already.

   Close any other we may find open.

   Leave any further management to the popped callback. */

static void
cxm_show_Terminal_CB(Widget w,
           XtPointer client_data, XtPointer call_data)
{

  XmPushButtonCallbackStruct *PBCS =
  (XmPushButtonCallbackStruct *) call_data;

  XEvent     *XE =
  (XEvent *) PBCS->event;

  NODEID      anode;
  static int short_cut_ok;

  char *current_string;

  cxm_save_event_coords(call_data);

  cxm_zap_Help();
  cxm_zap_Error();

  if (Terminal_Dialog) {
    cxm_popdown_dialog(Terminal_Dialog);
    Terminal_Dialog = NULL;
  }

  XtVaGetValues((Widget) client_data,
    XmNuserData, &anode,
    NULL);

/* At first click,
   recognized by this node not having a timeout pending,
   decide if a short-cut is possible for this Terminal node.
   So far only useful for Lists with or w/out Combo Box Type In. */

  if ((cxm_TimeOut_node != anode)
   && (Node_Term_Kind(anode) == CHOICE_TERM)
   && Node_Action(anode)) {

/* Chance to establish a default value. */

    if (Node_Enable_Ok(anode) && Node_On_Entry(anode))
      Node_On_Entry(anode) (anode);

/* Chance to invoke initialization if no prior value. */

    current_string = GetString(Node_Name(anode));

/* No short-cut possible w/out a value to use. */

    if (!current_string || !strlen(current_string))
      short_cut_ok = FALSE;

/* Acceptable prior value allows short-cut to action. */

    else {
      strcpy(test_type_in, current_string);

      if (short_cut_ok = (!Node_Enable_Ok(anode)
                     || Node_Enable_Ok(anode) (anode))) {
        if (CHOICE_ADD)
          XtFree(CHOICE_ADD);
        CHOICE_ADD = strdup(GetString(Node_Name(anode)));

        if (CHOICE_LIST)
          XtFree(CHOICE_LIST);
        CHOICE_LIST = strdup(GetString(Node_Name(anode)));
      }
    }
  }

/* Not the first click,
   or no short-cut possible here.
   Details follow. */

  else
    short_cut_ok = FALSE;

/* A second click on the same node before the timeout matures,
   or a shift modified first click,
   cancels the timeout and takes the short-cut. */

  if (DOUBLE_CLICK =
       ((cxm_TimeOut_node == anode)
     || (short_cut_ok
      && (XE->xbutton.state & ShiftMask != 0)))) {

    cxm_set_TimeOut(NULL, NULL);

    cxm_do_term_action(anode, False);
  }

/* if short-cut activation is possible,
   establish a timeout with this node pending. */

  else if (short_cut_ok) {
    cxm_set_TimeOut((Widget) client_data, anode);
  }

/* otherwise cancel pending timer and show the expanded terminal. */

  else {
    cxm_set_TimeOut(NULL, NULL);
    cxm_popup_dialog((Widget) client_data);
  }
}

/* NOTICE!
   Either we need separate "cxm_Terminal_Xx_CB" versions of these,
   or some flag or arg to modify their behavior for Terminals.
   Or let them check what kind of node they are passed. */

/* This is called when the Dialog Ok button is clicked,
   Ok means do the action and leave.
   Use Apply to do the action and Remain.
   Both may be available. */

static void
cxm_Dialog_OK_CB(Widget button,
         XtPointer client_data, XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

  cxm_zap_Help();
  cxm_zap_Yes_No();
  cxm_zap_Error();

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s Dialog_OK %s %d\n",
        app_name, Node_Name(anode), anode);
    fflush(DEBUG);
  }
#endif

/* Finish the dialog.
   If any dialogs ABOVE this are still open close them first,
   being sure to pop them down too. */

  while (Actives > Node_Level(anode))
    cxm_cancel_node(UITOP);

/* The user can click this twice before it pops down.
   The second click should be ignored! */

  if (anode != UITOP)
    return;

/* Close this dialog too. */

  if (Dialog_Stack[Node_Level(anode)]) {
    cxm_popdown_dialog(Dialog_Stack[Node_Level(anode)]);
    Dialog_Stack[Node_Level(anode)] = NULL;
  }

/* Close any open terminal (eg. List) box. */

  if (Terminal_Dialog) {
    cxm_popdown_dialog(Terminal_Dialog);
    Terminal_Dialog = NULL;
  }

/* Do the Action and commit any changes and leave.
   A failed Action could either stay or leave. */

  if (!By_Gui_Ext && Node_Action(anode))
    if (!cxm_do_node_action(anode))
      return;

  if (Node_On_Exit(anode))
    Node_On_Exit(anode) (anode);

  cxm_uiappend();

/* If the dialog was popped from an Or node,
   it is already unmapped but the stack still needs adjustment. */

  while ((UITOP > ROOTNODE) && (Node_Kind(UITOP) == OrNode)) {
    if (Node_On_Exit(UITOP))
      Node_On_Exit(UITOP) (UITOP);
    cxm_uiappend();
  }

/* Update an open Dialog on Ok completion of child Dialog. */

  cxm_revise_node(UITOP, False);
}

/* This is called when the dialog Apply button is clicked.
   Do the action and Remain. */

static void
cxm_Dialog_Apply_CB(Widget button,
          XtPointer client_data, XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

  cxm_zap_Help();
  cxm_zap_Yes_No();
  cxm_zap_Error();

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s Dialog_Apply %s %d\n",
        app_name, Node_Name(anode), anode);
    fflush(DEBUG);
  }
#endif

/* Close any open terminal (List) box. */

  if (Terminal_Dialog) {
    cxm_popdown_dialog(Terminal_Dialog);
    Terminal_Dialog = NULL;
  }

/* Do the Action and commit any changes.
   A failed Action should leave us here w/out committing changes. */

  if (!By_Gui_Ext
    && Node_Action(anode)
    && cxm_do_node_action(anode)) {
    cxm_uiappend();
    cxm_uipush(anode);
  }
}

/* This is called when the dialog Reset button is clicked. */

static void
cxm_Dialog_Reset_CB(Widget button,
          XtPointer client_data, XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

  cxm_zap_Help();
  cxm_zap_Yes_No();
  cxm_zap_Error();

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s Dialog_Reset %s %d\n",
        app_name, Node_Name(anode), anode);
    fflush(DEBUG);
  }
#endif

/* Close any open terminal (eg. List or FSB or String) box. */

  if (Terminal_Dialog) {
    cxm_popdown_dialog(Terminal_Dialog);
    Terminal_Dialog = NULL;
  }

  cxm_uidiscard();
  cxm_uipush(anode);

  cxm_revise_node(anode, False);
}

/* This is called when the dialog Cancel button is clicked.
   Widget client_data is the dialog not the shell or the rowcolumn. */

/* So far Cancel is the only one useful from a Terminal. */

static void
cxm_Dialog_Cancel_CB(Widget button,
           XtPointer client_data, XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

  cxm_zap_Help();
  cxm_zap_Yes_No();
  cxm_zap_Error();

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s Dialog_Cancel %s %d\n",
        app_name, Node_Name(anode), anode);
    fflush(DEBUG);
  }
#endif

/* Just pop down the Terminal. */

  if (Node_Kind(anode) == TermNode) {
    cxm_popdown_dialog(Terminal_Dialog);
    Terminal_Dialog = NULL;
  }

/* Get rid of THIS dialog and any still open above it. */

  else {
    while (Actives >= Node_Level(anode))
      cxm_cancel_node(UITOP);
  }

/* If the dialog (And or Terminal) was popped from an Or node,
   the Or is already unmapped but the stack still needs adjustment. */

  if (Node_Kind(Node_Back(anode)) == OrNode)
    while ((UITOP > ROOTNODE) && (Node_Kind(UITOP) == OrNode)) {
      if (Node_On_Exit(UITOP))
        Node_On_Exit(UITOP) (UITOP);
      cxm_uidiscard();
    }
}

/* This is called when the Dialog is popped up to add it to the stack.
   We can position the dialog shell from w/in the map callback. */

static void
cxm_Dialog_Popup_CB(Widget dialog_shell,
          XtPointer client_data, XtPointer call_data)
{
  int       nn = 0;
  Arg       args[10];
  NODEID      anode;

  nn = 0;
  XtSetArg(args[nn], XmNuserData, &anode);
  nn++;
  XtGetValues((Widget) client_data, args, nn);

  if (Node_Kind(anode) == AndNode) {
    cxm_showing_node(anode);
    Dialog_Stack[Node_Level(anode)] = (Widget) client_data;
  }
}

/* This is called when any Terminal Dialog is popped up,
   to make note of open Terminal popup so we can remove it.
   No stack because only one of these at a time.
   We position the dialog shell from w/in the map callback. */

static void
cxm_Terminal_Popup_CB(Widget w_shell,
            XtPointer client_data, XtPointer call_data)
{
  Terminal_Dialog = (Widget) client_data;
}

/* Create the built-in Ok / Apply / Cancel / Help buttons.
   We can later find one by name,
   even if unknown intermediate levels for appearance.

   SEVERAL dialog built-ins are possible here,
   but not all of them in all dialogs.

   The CB functions they call depend if node is a Terminal or Dialog.

   Show in this order:
   Ok: do action and close
   Apply: do action and do not close
   Reset: restore to last action and do not close
   Cancel: restore to last action and close
   (Help: assigned topic) */

#define cxm_MAKE_OK   (1L <<  0)
#define cxm_MAKE_APPLY  (1L <<  1)
#define cxm_MAKE_RESET  (1L <<  2)
#define cxm_MAKE_CANCEL (1L <<  3)

static      Widget
cxm_make_action_panel(Widget parent, long bit_flag, NODEID node,
            char *help)
{
  int       nn = 0;
  Arg       args[10];
  Widget      RC, button, default_button = NULL;

/* Works but should use a form instead of rowcolumn,
   to better spread the buttons.
   See nice Heller/O'Reilly example. */

  nn = 0;
  XtSetArg(args[nn], XmNorientation, XmHORIZONTAL);
  nn++;

/* Prevent this being a tab group separate from the dialog body. */

  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;

  XtManageChild(RC =
          XmCreateRowColumn(parent, "actions", args, nn));

  if (bit_flag & cxm_MAKE_OK) {
    XtManageChild(button =
            cxm_make_button(RC, "Ok",
      NULL, NULL, cxm_MAKE_DEFAULT, cxm_Dialog_OK_CB, (void *) node));

    if (!default_button)
      default_button = button;
  }

  if (bit_flag & cxm_MAKE_APPLY) {
    XtManageChild(button =
            cxm_make_button(RC, "Apply",
           NULL, NULL, NULL, cxm_Dialog_Apply_CB, (void *) node));

    if (!default_button)
      default_button = button;
  }

  if (bit_flag & cxm_MAKE_RESET) {
    XtManageChild(button =
            cxm_make_button(RC, "Reset",
           NULL, NULL, NULL, cxm_Dialog_Reset_CB, (void *) node));

    if (!default_button)
      default_button = button;
  }

  if (bit_flag & cxm_MAKE_CANCEL) {
    XtManageChild(button =
            cxm_make_button(RC, "Cancel",
          NULL, NULL, NULL, cxm_Dialog_Cancel_CB, (void *) node));

    if (!default_button)
      default_button = button;
  }

  if (help && strlen(help)) {
    XtManageChild(button =
            cxm_make_button(RC, "Help",
                    NULL, NULL, 0, cxm_Help_CB, help));
    XtAddCallback(parent, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);

    if (!default_button)
      default_button = button;
  }

/* Force the defaultButton in the parent dialog.
   The intervening panel Widget will not prevent that. */

  if (default_button) {
    nn = 0;
    XtSetArg(args[nn], XmNdefaultButton, default_button);
    nn++;
    XtSetValues(RC, args, nn);
  }

  return RC;
}

/* Some recent changes to help resource setting!
   The Form now gets name instead of the rowcol as prev,
   so that action panel and any later rowcols can share resources.

   Some of our apps name cx_toplevel by app-family and menubar by indiv-app.
   Make the dialog a child of menubar rather than cx_toplevel,
   for both levels of resource access.

   Better still as child of parent to parallel the specification,
   we would like it to parallel the specification tree,
   but never from a menu because when it pops down all following go too. */

static      Widget
cxm_make_Dialog_popup(Widget parent,
            char *name,
            char mnemonic, char acc, char *help, int node)
{
  int       nn = 0;
  Arg       args[10];
  Widget      FD, RC, button, panel;

  long      act_flags;

/* The popup form.
   Simple border w/out any controls or title.
   Otherwise we would set XmNdialogTitle.
   Size to fit contents. */

  nn = 0;
  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;
  XtSetArg(args[nn], XmNmwmDecorations, MWM_DECOR_BORDER);
  nn++;

/* We have our own dismissal methods. */

  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;

/* We will position it ourselves when mapped. */

  XtSetArg(args[nn], XmNdefaultPosition, False);
  nn++;

  XtSetArg(args[nn], XmNuserData, node);
  nn++;

/* Dialog is not managed yet or it would be shown too soon. */

  FD = XmCreateFormDialog(menubar, name, args, nn);

/* The button to show it... */

  if (Node_Summary(node))
    XtManageChild(button =
            cxm_make_summary_button(parent, name,
                        mnemonic, NULL,
                        " ", 8,
                        NULL, NULL, NULL));
  else
    XtManageChild(button =
            cxm_make_button(parent, name,
                    mnemonic, NULL,
                    NULL, NULL, NULL));

  NodeButton[node] = button;

  XtAddCallback(button, XmNactivateCallback, cxm_show_Dialog_CB, (XtPointer)FD);

/* So we know a dialog is opened... */

  XtAddCallback(XtParent(FD), XtNpopupCallback, cxm_Dialog_Popup_CB, (XtPointer)FD);

/* We will position it when mapped. */

  XtAddCallback(FD, XmNmapCallback, cxm_Dialog_Map_CB, NULL);

  if (help && strlen(help)) {
    XtAddCallback(button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
    XtAddCallback(FD, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
  }

/* Several control buttons are available -- what do we need?
   May want to allow spec of full-Motif vs abbreviated style too. */

  act_flags = cxm_MAKE_OK;

/* This is NOT quite right! */

  if (Node_Enable_Ok(node))
    act_flags |= cxm_MAKE_CANCEL;

  if (Node_Action(node)
    && Node_Remain(node)
    && !Node_Auto_Ok(node)) {
    act_flags |= cxm_MAKE_APPLY;
    act_flags |= cxm_MAKE_RESET;
  }

  panel = cxm_make_action_panel(FD, act_flags, node, help);

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(panel, args, nn);

/* This manager Widget will be returned,
   to be parent for whatever the next level down specifies.
   It could be a Form instead of a RowColumn per option. */

  nn = 0;

  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNtopWidget, panel);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;

/* Prevent this being a tab group separate from the action panel. */

  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;

  XtManageChild(RC =
          XmCreateRowColumn(FD, "rowcol", args, nn));

  return RC;
}

/* NOTE!
   The use of the 'Filter' is not obvious.
   The trailing 'file' part is actually a regular expression.
   It can match ANY PART of a filename unless ^ or $ mark the ends.
   The leading part really is a path at face value.
   This should be EXPLAINED in a help file always provided. */

/* This is called when the FSB does 'most anything:
   Cancel button is clicked to leave w/out any Action.
   Apply button is clicked to do any Action and stay.
   Ok button is clicked to do any Action and leave.
   Widget fsbd is the dialog rather than any button. */

static void
cxm_FSB_CB(Widget fsbd, XtPointer client_data, XtPointer call_data)
{
  int       nn = 0;
  Arg       args[10];
  NODEID      anode;

  char       *ftext = NULL;
  char       *dir = NULL;
  char       *value = NULL;

  XmFileSelectionBoxCallbackStruct *FSBCS =
  (XmFileSelectionBoxCallbackStruct *) call_data;

  XEvent     *XE =
  (XEvent *) FSBCS->event;

  nn = 0;
  XtSetArg(args[nn], XmNuserData, &anode);
  nn++;
  XtGetValues(fsbd, args, nn);

  cxm_zap_Help();
  cxm_zap_Error();

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s FSB_OK_CB %s reason %d\n",
        app_name, Node_Name(anode), FSBCS->reason);
    fflush(DEBUG);
  }
#endif

/* Possible reasons are OK / APPLY / CANCEL / NO_MATCH */

  if (FSBCS->reason == XmCR_OK
    || FSBCS->reason == XmCR_APPLY) {

/* Convert the directory and value to C-strings.
   The conversions should never fail! */

    if (FSBCS->dir
      && !XmStringGetLtoR(FSBCS->dir, XmSTRING_DEFAULT_CHARSET, &dir)) {
      printf("cxm: %s internal string conversion ERROR\n", app_name);
      exit(-1);
    }

    if (FSBCS->value
      && !XmStringGetLtoR(FSBCS->value, XmSTRING_DEFAULT_CHARSET, &value)) {
      printf("cxm: %s internal string conversion ERROR\n", app_name);
      exit(-1);
    }

/* Make a combined full path name string and free the conversions.
   The directory part already ends with a slash.
   Free old one now and this one next time. */

    if (STRING_VAL)
      XtFree(STRING_VAL);

    if (dir && value) {
      STRING_VAL = (char *) malloc(strlen(dir) + strlen(value) + 2);

      strcpy(STRING_VAL, dir);
      strcat(STRING_VAL, value);

      XtFree(dir);
      XtFree(value);

/* Get rid of any open sibling so a result will store in this level. */

      while (Actives >= Node_Level(anode))
        cxm_cancel_node(UITOP);

      DefString(Node_Name(anode), STRING_VAL);

/* Stay for more after APPLY but leave after OK */

      cxm_do_term_action(anode, (FSBCS->reason == XmCR_APPLY));
    }
  }

  if (FSBCS->reason == XmCR_OK
    || FSBCS->reason == XmCR_NO_MATCH
    || FSBCS->reason == XmCR_CANCEL) {
    cxm_popdown_dialog(fsbd);
    Terminal_Dialog = NULL;

/* If the selector was popped from an Or node,
   it is already unmapped but stack still needs adjustment.
   Use a loop in case more than one such level. */

    while ((UITOP > ROOTNODE) && (Node_Kind(UITOP) == OrNode)) {
      if (Node_On_Exit(UITOP))
        Node_On_Exit(UITOP) (UITOP);
      cxm_uiappend();
    }
  }
}

/* The standard search procedure may be replaced via XmNfileSearchProc.
   A custom search proc could for example list only writable files,
   or only files with some "magic number" in the first few bytes.
   See O'Reilly X Vol 6 (Heller) Section 6.5.3 for more on this.

   Use the custom search with the FSB Node_Enable_Ok test specified,
   with the Boolean N_E_Ok function called as a test on each file name,
   so that ANY user requirement may be plugged in.

   Use the custom search even if Node_Enable_Ok test is specified,
   to be sure what version of regular expression testing we get.
   This was not the original plan but how it is.  */

/* We should now simply call this ---
char **cxm_dirscan(char *dir, char *pattern, int (*app_test) (char *))
   Extracted it from here as callable from outside.
   But be careful; the FSB lists local names not full pathnames. */

static void
cxm_FSB_search_proc(Widget fsbd, XmFileSelectionBoxCallbackStruct * FSBCS)
{
  NODEID      anode;
  char       *ftext = NULL;

  char       *dir = NULL;
  char       *pattern = NULL;
  char       *expr = NULL;

  int       fcount = 0;
  XmString    fnames[500];

  int       matched;
  int       badexp = 1;

#ifdef _SYSTYPE_SYSV
  struct dirent  *dp;
#else
  struct direct  *dp;
#endif

  DIR      *dirp;

/* Used to get at the custom file test procedure if any. */

  XtVaGetValues(fsbd, XmNuserData, &anode, NULL);

/* Convert the directory and pattern specs (if any) to C-strings.
   The conversions (if any) should never fail! */

  if (FSBCS->dir
    && !XmStringGetLtoR(FSBCS->dir, XmSTRING_DEFAULT_CHARSET, &dir)) {
    printf("cxm: %s internal string conversion ERROR\n", app_name);
    exit(-1);
  }

  if (FSBCS->pattern
    && !XmStringGetLtoR(FSBCS->pattern, XmSTRING_DEFAULT_CHARSET, &pattern)) {
    printf("cxm: %s internal string conversion ERROR\n", app_name);
    exit(-1);
  }

/* Default to 'dot' (current at program start) if no directory specified. */

  if (!dir)
    dir = strdup(".");

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "node %s dir %s pattern %s\n",
        Node_Name(anode), dir, pattern);
    fflush(DEBUG);
  }
#endif

/* Open the specified or default directory.
   Find "nothing" if unable to open the directory.
   Maybe this should be reported as an error? */

  dirp = opendir(dir);

/* Compile the regular expression if specified.

   See 'man regex' for both common versions,
   and 'man ed' for full discussion of regular expressions.
   Couldn't find any dot h file to include for either version.

   But also see 'man regexp' (note the 'p') for yet another version,
   this one prototyped by <regexp.h> include file,
   but I don't know how portable it is. */

#ifdef _SYSTYPE_SYSV
  if (pattern && strlen(pattern))
    expr = (char *) regcmp(pattern, NULL);
#else
  if (pattern && strlen(pattern))
    badexp = re_comp(pattern);
#endif

/* Check each file in the directory... */

  if (dirp) {
    while (dp = readdir(dirp)) {

/* Accept names matching regular expression or all if no expression. */

#ifdef _SYSTYPE_SYSV
      matched = !expr || (regex(expr, dp->d_name, NULL) != NULL);
#else
      matched = badexp || (re_exec(dp->d_name) > 0);
#endif

#ifdef DEBUG
      if (DEBUG) {
        fprintf(DEBUG,
            "name %s match %d\n",
            dp->d_name, matched);
        fflush(DEBUG);
      }
#endif

/* Accepted names must still pass custom file test to be listed.
   Pass the full path name,
   or at least start from dot,
   so the app-test can get at the file. */

      if (matched) {
        strcpy(test_file_name, dir);
        strcat(test_file_name, "/");
        strcat(test_file_name, dp->d_name);
        if (!Node_Enable_Ok(anode)
          || Node_Enable_Ok(anode) (anode))
          fnames[fcount++] = XmStringCreateSimple(dp->d_name);
      }
    }
    closedir(dirp);

#ifdef _SYSTYPE_SYSV
    free(expr);
#endif

    if (fcount) {
      XtVaSetValues(fsbd,
              XmNfileListItems, fnames,
              XmNfileListItemCount, fcount,
              XmNdirSpec, fnames[0],
              XmNlistUpdated, True,
              NULL);
      while (fcount)
        XmStringFree(fnames[--fcount]);
    }

    else {
      XtVaSetValues(fsbd,
              XmNfileListItems, NULL,
              XmNfileListItemCount, fcount,
              XmNlistUpdated, True,
              NULL);
    }
  }

  if (dir)
    XtFree(dir);
  if (pattern)
    XtFree(pattern);
}

static      Widget
cxm_make_FSB_popup(Widget parent,
           char *name,
           char mnemonic, char acc, char *help, int node)
{
  int       nn = 0;
  Arg       args[10];
  Widget      FSBD, button;

  XtSetArg(args[nn], XmNmwmDecorations, MWM_DECOR_BORDER);
  nn++;

/* We have our own dismissal methods. */

  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;

/* We will position it ourselves when mapped. */

  XtSetArg(args[nn], XmNdefaultPosition, False);
  nn++;

  XtSetArg(args[nn], XmNuserData, node);
  nn++;

/* If we have the good regex make sure we ALWAYS use it... */

#ifndef _SYSTYPE_SYSV
  if (Node_Enable_Ok(node))
#endif
  {
    XtSetArg(args[nn], XmNfileSearchProc, cxm_FSB_search_proc);
    nn++;
  }

/* FSB Dialog is not managed yet or it would be shown too soon. */

  FSBD = XmCreateFileSelectionDialog(menubar, name, args, nn);

/* The button to show it... */

  if (Node_Summary(node))
    XtManageChild(button =
            cxm_make_summary_button(parent, name,
                        mnemonic, NULL,
                        " ", 8,
                        NULL, NULL, NULL));
  else
    XtManageChild(button =
            cxm_make_button(parent, name,
                    mnemonic, NULL,
                    NULL, NULL, NULL));

  NodeButton[node] = button;

  XtAddCallback(button, XmNactivateCallback, cxm_show_Terminal_CB, (XtPointer)FSBD);

/* So we know a FSB terminal is popped up... */

  XtAddCallback(XtParent(FSBD), XtNpopupCallback, cxm_Terminal_Popup_CB, (XtPointer)FSBD);

  XtAddCallback(FSBD, XmNmapCallback, cxm_Dialog_Map_CB, NULL);

  XtAddCallback(FSBD, XmNcancelCallback, cxm_FSB_CB, NULL);
  XtAddCallback(FSBD, XmNnoMatchCallback, cxm_FSB_CB, NULL);
  XtAddCallback(FSBD, XmNokCallback, cxm_FSB_CB, NULL);

  if (help && strlen(help)) {
    XtAddCallback(button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
    XtAddCallback(FSBD, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
  }

  return FSBD;
}

/* We recognize either a (fast) double Click or a Shift+Click.

   Motif SG says double-click is a shortcut (only) to "larger" action,
   eg. shifting by a page instead of a line,
   we simply set a flag and let application decide how to use it.

   Motif SG says nothing about means of confirming a dangerous action.
   We popup a Yes/No box over the button,
   which may be avoided by either double Click or Shift+Click.
   But this may not be a compliant use. */

static void
cxm_Imm_CB(Widget push,
       XtPointer client_data,
       XtPointer call_data)
{
  NODEID      anode =
  (NODEID) client_data;

  XmPushButtonCallbackStruct *PBCS =
  (XmPushButtonCallbackStruct *) call_data;

  XEvent     *XE =
  (XEvent *) PBCS->event;

  cxm_zap_Help();
  cxm_zap_Yes_No();
  cxm_zap_Error();

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

/* I think the click_count is invalid when button is in a menu... */

  DOUBLE_CLICK = ((PBCS->reason == XmCR_ACTIVATE)
        && (((XE->type = ButtonRelease) && (PBCS->click_count == 2))
          || (XE->xbutton.state & ShiftMask)));

  if (!DOUBLE_CLICK) {
    if (Cond(Node_Confirm(anode), anode)) {
      cxm_save_event_coords(call_data);
      cxm_show_Yes_No_CB(anode);
      return;
    }
  }

/* We defer any On_Entry code until it is needed for the Action. */

  if (Node_On_Entry(anode))
    Node_On_Entry(anode) (anode);

  cxm_do_term_action(anode, False);
}

/* Tell app-code when button goes down and up.
   Use this when Node_Click_Action is specified instead of Node_Action.
   Leave all timing concerns to the app.
   BTW Enter/Return key causes a stream of events due to auto-repeat. */

static void
cxm_Momentary_CB(Widget push,
         XtPointer client_data,
         XtPointer call_data)
{
  NODEID      anode =
  (NODEID) client_data;

  XmPushButtonCallbackStruct *PBCS =
  (XmPushButtonCallbackStruct *) call_data;

  XEvent     *XE =
  (XEvent *) PBCS->event;

  if (PBCS->reason == XmCR_ARM) {
    CLICK_DOWN = 1;
    CLICK_TIME = XE->xbutton.time;
    Node_Click_Action(anode) (anode);
  }
  else if (PBCS->reason == XmCR_DISARM) {
    CLICK_DOWN = 0;
    CLICK_TIME = XE->xbutton.time;
    Node_Click_Action(anode) (anode);
  }
}

static void
cxm_Bool_CB(Widget toggle,
      XtPointer client_data,
      XtPointer call_data)
{
  NODEID      anode =
  (NODEID) client_data;
  XmToggleButtonCallbackStruct *TBCS =
  (XmToggleButtonCallbackStruct *) call_data;

  cxm_zap_Help();
  cxm_zap_Error();

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

  DefLong(Node_Name(anode), TBCS->set);
  BOOLEAN_ON = TBCS->set;

  cxm_do_term_action(anode, False);
}

/* About scrollers...
   The value ranges from min to max minus slider,
   and thus represents the bottom not center of slider.

   Resource values include {XmN...} all integer
   increment, pageIncrement,
   minimum, maximum,
   value, sliderSize.

  There is also this...

  XmScrollBarSetValues(w,
  value, slider_size, increment, page_increment,
  Boolean notify);

  The notify True calls any callbacks as if user made change.
  This is the valueChangedCallback.
  Will be available to application if wanted. */

static void
ScrollCB(Widget w,
     XtPointer client_data,
     XtPointer call_data)
{
  int       value;
  int       slider_size;
  int       increment;
  int       page_increment;

  XmScrollBarGetValues(w,
             &value, &slider_size, &increment, &page_increment);
  printf("cxm: %s Scroller %s %d %d %d\n",
       app_name, XtName(w),
       value, slider_size,
       client_data);
}

/* Provide ALL or NONE of a List as allowed.
   Invoke any notify CB repeatedly as if individual actions.
   These flags tell the CB that a series is in progress. */

static void
cxm_All_CB(Widget w,
       XtPointer client_data,
       XtPointer call_data)
{
  int       nn = 0;
  Arg       args[10];
  int       item, itemcount, selecteditemcount;
  int      *pos_list = NULL;
  int       pos_count;

  nn = 0;
  XtSetArg(args[nn], XmNitemCount, &itemcount);
  nn++;
  XtSetArg(args[nn], XmNselectedItemCount, &selecteditemcount);
  nn++;
  XtGetValues((Widget) client_data, args, nn);

/* Get our own copy of selected positions list.
   It is only valid until we make changes,
   but should be ok for single pass.
   Release it when done. */

  XmListGetSelectedPos((Widget) client_data, &pos_list, &pos_count);

/* Correct for apparent BUG in XmLGSP when none selected... */

  pos_count = selecteditemcount;

/* Select actually reverses each item,
   so we should only call for any not already selected. */

  if (itemcount > pos_count) {
    DOING_LIST_ALL = True;
    DOING_LIST_FIRST = True;
    for (item = 1; item <= itemcount; item++) {
      for (nn = 0; nn < pos_count; nn++)
        if (pos_list[nn] == item)
          break;

/* Not found selected so do it now. */

      if (nn == pos_count)
        XmListSelectPos((Widget) client_data, item, TRUE);
    }
    DOING_LIST_ALL = False;
    DOING_LIST_FIRST = False;
  }
  if (pos_list)
    free(pos_list);
}

static void
cxm_None_CB(Widget w,
      XtPointer client_data,
      XtPointer call_data)
{
  int       nn = 0;
  Arg       args[10];
  int       item, itemcount, selecteditemcount;
  int      *pos_list = NULL;
  int       pos_count;

  nn = 0;
  XtSetArg(args[nn], XmNitemCount, &itemcount);
  nn++;
  XtSetArg(args[nn], XmNselectedItemCount, &selecteditemcount);
  nn++;
  XtGetValues((Widget) client_data, args, nn);

/* Get our own copy of selected positions list.
   It is only valid until we make changes,
   but should be ok for single pass.
   Release it when done. */

  XmListGetSelectedPos((Widget) client_data, &pos_list, &pos_count);

/* Correct for apparent BUG in XmLGSP when none selected... */

  pos_count = selecteditemcount;

/* Select actually reverses each item,
   so we should only call for any already selected.
   There is an XmListDeselectPos call but it lacks the Notify arg. */

  if (pos_count) {
    DOING_LIST_NONE = True;
    DOING_LIST_FIRST = True;
    for (item = 1; item <= itemcount; item++) {
      for (nn = 0; nn < pos_count; nn++)
        if (pos_list[nn] == item)
          break;

/* Found selected so undo it now. */

      if (nn < pos_count)
        XmListSelectPos((Widget) client_data, item, TRUE);
    }
    DOING_LIST_NONE = False;
    DOING_LIST_FIRST = False;
  }
  if (pos_list)
    free(pos_list);
}

/* This is called when the List Ok button Widget w is clicked,
   and also following a Select or Deselect if no Remain or false Remain.
   Widget w is NULL for these direct calls.

   Widget client_data is the dialog not the shell or the rowcolumn.

   Also should be called for String Cancel and Done,
   not sure yet about FSBD.

   Any Action has already been done for each choice if any. */

static void
cxm_Terminal_Done_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
  int       nn = 0;
  Arg       args[10];
  NODEID      anode;

  nn = 0;
  XtSetArg(args[nn], XmNuserData, &anode);
  nn++;
  XtGetValues((Widget) client_data, args, nn);

  cxm_zap_Help();

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s Terminal_Done_CB %s\n",
        app_name, Node_Name(anode));
    fflush(DEBUG);
  }
#endif

  cxm_popdown_dialog((Widget) client_data);

/* If the Terminal was popped from an Or node,
   the Or menu is already unmapped but stack still needs adjustment.
   Use a loop in case more than one such level. */

  while ((UITOP > ROOTNODE) && (Node_Kind(UITOP) == OrNode)) {
    if (Node_On_Exit(UITOP))
      Node_On_Exit(UITOP) (UITOP);
    cxm_uiappend();
  }
}

/* Remember that item_length is for compound string!
   Do NOT free them but DO free the text conversion. */

static void
cxm_list_single_CB(Widget w,
           XtPointer client_data,
           XtPointer call_data)
{
  XmListCallbackStruct *LCS = (XmListCallbackStruct *) call_data;
  NODEID      anode = (NODEID) client_data;
  char       *text;

/* We get the same CB info either selecting or deleting an item!
   So we need further testing to know which happened. */

  int       selecteditemcount;

  XtVaGetValues(w,
                XmNselectedItemCount, &selecteditemcount,
                NULL);

  XmStringGetLtoR(LCS->item, XmSTRING_DEFAULT_CHARSET, &text);

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

/* Clear any prev CHOICE_ globals.
   These are always duplicate strings so we release them. */

  if (CHOICE_ADD)
    XtFree(CHOICE_ADD);
  CHOICE_ADD = NULL;

  if (CHOICE_DEL)
    XtFree(CHOICE_DEL);
  CHOICE_DEL = NULL;

  if (CHOICE_LIST)
    XtFree(CHOICE_LIST);
  CHOICE_LIST = NULL;

/* These will be released next time any CHOICE_ is set by anyone.
   They are only valid in the ACTION code immediately following. */

  if (selecteditemcount) {
    CHOICE_ADD = text;
    CHOICE_LIST = strdup(text);
    DefString(Node_Name(anode), CHOICE_ADD);
  }
  else {
    DefString(Node_Name(anode), "");
    CHOICE_DEL = text;
  }

/* If this List is part of a Combo Box,
   the new selection must also update the type-in TextField. */

  if (NodeTypeIn[anode]) {
    cx_set_string(NodeTypeIn[anode], text);

    if (NodeReversed[anode])
      cx_reverse(NodeTypeIn[anode]);

    NodeReversed[anode] = False;
  }

  cxm_do_term_action(anode, True);

/* If no Remain or false Remain close the List.
   Pass it the dialog to be popped down. */

  if (!Cond(Node_Remain(anode), anode))
    cxm_Terminal_Done_CB((Widget) NULL,
               (XtPointer) XtParent(XtParent(w)),
               (XtPointer) NULL);
}

/* The most recently changed was just selected or was just deselected.
   We could enforce Node_Choice_Min and N_C_Max selection counts here... */

static void
cxm_list_multi_CB(Widget w,
          XtPointer client_data,
          XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;
  XmListCallbackStruct *LCS = (XmListCallbackStruct *) call_data;

/* Get enough pointers for selected item strings. */

  char      **atext = (char **) XtMalloc(sizeof(char *)
                         * LCS->selected_item_count);

  int       nn = 0;
  int       ii, length, c_max, itemcount;
  char       *text;

/* Remember that "Widget w" is the List item proper,
   child of a scrolled window in turn child of the dialog.
   Better to loop back until we find the dialog for sure. */

  Widget      all_button =
  cx_find_named_child(XtParent(XtParent(w)), "All", NULL);
  Widget      none_button =
  cx_find_named_child(XtParent(XtParent(w)), "None", NULL);

/* This is the ONLY reason we expect because the only callback used.
   If we used the XmNdefaultActionCallback to respond to double-clicks,
   it would produce a reason of XmCR_DEFAULT_ACTION,
   and would also select the clicked item. */

  if (LCS->reason != XmCR_MULTIPLE_SELECT)
    return;

/* Clear any prev CHOICE_ADD or CHOICE_DEL globals.
   These are always duplicate strings so we release them. */

  if (CHOICE_ADD) {
    XtFree(CHOICE_ADD);
    CHOICE_ADD = NULL;
  }

  if (CHOICE_DEL) {
    XtFree(CHOICE_DEL);
    CHOICE_DEL = NULL;
  }

/* Enforce max selections.
   If there is a max limit and count exceeds it and latest was addition,
   turn latest back off with no effect on application. */

  c_max = Cond(Node_Choice_Max(anode), anode);
  if ((c_max > 0) && (c_max < LCS->selected_item_count)) {
    for (nn = 0; nn < LCS->selected_item_count; nn++)
      if (LCS->item_position == LCS->selected_item_positions[nn])
        break;

    if (nn < LCS->selected_item_count) {
      XmListDeselectPos((Widget) client_data, LCS->item_position);
      return;
    }
  }

/* Release any old one before allocating the new one. */

  if (CHOICE_LIST)
    XtFree(CHOICE_LIST);

/* Build string of all current selections w/ space delimiters.
   First convert and hold all the strings,
   total to find the needed length and allocate it. */

  length = 1;
  for (ii = 0; ii < LCS->selected_item_count; ii++) {
    XmStringGetLtoR(LCS->selected_items[ii],
            XmSTRING_DEFAULT_CHARSET,
            &atext[ii]);
    length = length + strlen(atext[ii]) + 1;
  }

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm_list_multi_CB %s selections:\n", Node_Name(anode));
    for (ii = 0; ii < LCS->selected_item_count; ii++)
      fprintf(DEBUG, "%d:%s\n", ii, atext[ii]);
    fflush(DEBUG);
  }
#endif

  CHOICE_LIST = (char *) XtMalloc(sizeof(char *) * length);
  CHOICE_LIST[0] = NULL;

/* Concat them all with space between each.
   Release all the temps and their pointer array when done. */

  for (ii = 0; ii < LCS->selected_item_count; ii++) {
    if (ii > 0)
      strcat(CHOICE_LIST, " ");
    strcat(CHOICE_LIST, atext[ii]);
    XtFree(atext[ii]);
  }
  XtFree((char *)atext);

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

/* Save CHOICE_LIST string as current value. */

  DefString(Node_Name(anode), CHOICE_LIST);

/* Latest change was either to ADD or DEL a selection.
   Post via CHOICE_ADD or CHOICE_DEL globals. */

  XmStringGetLtoR(LCS->item,
          XmSTRING_DEFAULT_CHARSET,
          &text);

  if (wordcount(listops(CHOICE_LIST, '*', text)))
    CHOICE_ADD = strdup(text);
  else
    CHOICE_DEL = strdup(text);
  free(text);

  XtVaGetValues(w, XmNitemCount, &itemcount, NULL);

  if (all_button)
    XtSetSensitive(all_button,
             (LCS->selected_item_count < itemcount));

  if (none_button)
    XtSetSensitive(none_button,
             (LCS->selected_item_count > 0));

  cxm_do_term_action(anode, True);

  DOING_LIST_FIRST = False;

/* If not in a series and no Remain or false Remain close the list popup.
   Pass it the dialog to be popped down. */

  if (!DOING_LIST_ALL
    && !DOING_LIST_NONE
    && !Cond(Node_Remain(anode), anode))
    cxm_Terminal_Done_CB((Widget) NULL,
               (XtPointer) XtParent(XtParent(w)),
               (XtPointer) NULL);
}

/* Like MS_Windows Combo Box.
   This CB is called when user types CR to complete a typed entry. */

static void
cxm_combo_CR_CB(Widget textfield,
        XtPointer client_data,
        XtPointer call_data)
{
  Widget LW = (Widget) client_data;

  int       nn = 0;
  Arg       args[10];
  NODEID      anode;

  int       cols;

/* This returns a malloc'd copy that we later free. */

  char       *vs = XmTextFieldGetString(textfield);

/* Get rid of trailing blanks.
   Could also get rid of leading blanks. */

  cols = strlen(vs);
  while (cols && vs[cols - 1] == ' ')
    vs[--cols] = NULL;

  XtVaGetValues(textfield,
    XmNuserData, &anode,
    NULL);

/* Use app-code for this node to validate the typed input,
   unless it is one of the currently available choices,
   in which case the Enable code need not be called.

   This attribute is REQUIRED as the clue to provide this feature;
   it may simply return a constant True to accept anything,
   check against the existing List set of values,
   or use some other validation method.

   Global TEST_TYPE_IN holds the proposed entry for validation.

   The app may also MODIFY the string in-place,
   for example by changing upper and lower case.
   A True reply will use whatever string is found. */

  strcpy(test_type_in, vs);
  XtFree(vs);

  if (!Node_Enable_Ok(anode)
   || (wordcount(listops(NodeChoiceSet[anode], '*', test_type_in)))
   || Node_Enable_Ok(anode) (anode)) {

/* Get rid of any open sibling so a result will store in this level. */

    while (Actives >= Node_Level(anode))
      cxm_cancel_node(UITOP);

    DefString(Node_Name(anode), test_type_in);

/* free old one now and free this next time. */

    if (CHOICE_LIST)
      XtFree(CHOICE_LIST);

    if (CHOICE_ADD)
      XtFree(CHOICE_ADD);

/* But never two pointers to the same alloc!  The free kills you! */

    CHOICE_LIST = strdup(test_type_in);

    CHOICE_ADD = strdup(test_type_in);

/* Restore normal appearance. */

    if (NodeReversed[anode])
      cx_reverse(textfield);

    NodeReversed[anode] = False;

/* Must also update the List Widget (LW) part of the Combo Box,
   but what if new entry is not a word on the List?
   We could add it or add a word like "other" instead.
   If we add "other" we risk user later selecting it. */

   NodeChoiceInit[anode] = strdup(test_type_in);
   cxm_set_choices(NodeBox[anode], NodeChoiceSet[anode], test_type_in);

    cxm_do_term_action(anode, False);

/* Advance the focus from here to some other terminal.
   Remember that text is a tab group of its own. */

    if (!client_data)
      XmProcessTraversal(textfield, XmTRAVERSE_NEXT_TAB_GROUP);
  }

/* Failed validation -- leave it visible for user correction. */

  else
    cx_ring_bell(cx_display);
}

/* First keystroke change to reverse-video to note entry-in-progress. */

static void
cxm_combo_key_CB(Widget textfield,
        XtPointer client_data,
        XtPointer call_data)
{
  Widget LW = (Widget) client_data;

  XmTextVerifyCallbackStruct *TVCS
  = (XmTextVerifyCallbackStruct *) call_data;

  int       nn = 0;
  Arg       args[10];
  NODEID      anode;

/* Considering program input as user input could cause an endless loop.
   According to Heller the event is NULL for a programmatic change,
   due to XmText[Field]SetString / Insert / Replace / whatever,
   but it does not say what using SetValues would do. */

  XtVaGetValues(textfield,
    XmNuserData, &anode,
    NULL);

  if (!TVCS->event)
    return;

  if (NodeReversed[anode])
    return;

/* Do nothing special for backspace -- looks fine w/out this. */

  cx_reverse(textfield);

  NodeReversed[anode] = True;
}

static      Widget
cxm_make_combo_button(Widget parent,
            char *name,
            char *initial, int cols,
            Widget LW,
            NODEID node)
{
  Widget      frame;
  Widget      form;
  Widget      button;
  Widget      textfield;

  unsigned char   rowcolumntype;
  XmString    tcs;
  Arg       args[10];
  int       nn = 0;

  char      showstr[62];

/* c y a */

  if (cols > 60)
    cols = 60;

  if (cols < 3)
    cols = 3;

  showstr[0] = NULL;

  if (initial)
    strncpy(showstr, initial, 60);

  while (strlen(showstr) < cols)
    strcat(showstr, "_");

  if (cols)
    showstr[cols] = NULL;

/* Group the textfield and button.
   But prevent the group from being a tab stop.
   Use a frame to make the grouping visible.
   Works w/out the frame too of course. */

  nn = 0;
  XtSetArg(args[nn], XmNshadowType, XmSHADOW_ETCHED_IN);
  nn++;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(frame =
          XmCreateFrame(parent, "combo_frame", args, nn));

  nn = 0;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(form =
          XmCreateForm(frame, "combo_form", args, nn));

/* The named button used to show the List.
   Caller will provide the activationCallback. */

  button =
    cxm_make_button(form, name,
            NULL, NULL,
            NULL,
            NULL, NULL);

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(button, args, nn);

/* The textfield for typed input.
   Must create it with some string to force a size,
   then we set it to empty. */

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNleftWidget, button);
  nn++;

  XtSetArg(args[nn], XmNvalue, showstr);
  nn++;
  XtSetArg(args[nn], XmNcolumns, cols);
  nn++;

  XtSetArg(args[nn], XmNuserData, node);
  nn++;

  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;

  XtSetArg(args[nn], XmNeditable, True);
  nn++;

  XtManageChild(textfield =
          XmCreateTextField(form, "textfield", args, nn));

  NodeReversed[node] = False;
  NodeTypeIn[node] = textfield;

  XmTextFieldSetString(textfield, "");

/* We will NOT validate every keystroke but need to see first one. */

  XtAddCallback(textfield, XmNmodifyVerifyCallback, cxm_combo_key_CB, NULL);

  XtAddCallback(textfield, XmNactivateCallback, cxm_combo_CR_CB, (XtPointer)LW);

  return button;
}

/* This returns the List Widget for later lookup to update values.

   Note!
   Books warn us to create the dialog as child of something
   surely visible even if the show-button is in a pulldown menu,
   because it will not be visible if the parent is not.
   But in spite of this it works when parent is a pulldown menu,
   with both the show-button and the dialog created as children. */

/* NOTE should better control when to offer All and None buttons. */

static      Widget
cxm_make_List_popup(Widget parent,
          char **strings, int nst, char *one_string,
          int cols,
          char *name,
          char mnemonic, char *help,
          Boolean all_OK, Boolean none_OK, Boolean only_one,
          int node)
{
  int       nn = 0;
  Arg       args[10];
  Widget      FD, LW, prev, button, Hbutton, popbutton;

/* We use SINGLE and MULTIPLE but other modes are also defined. */

  unsigned char   policy =
  (only_one) ? XmSINGLE_SELECT : XmMULTIPLE_SELECT;

  int       i, nvis;
  XmString     *xmstr = NULL;

  nn = 0;

  XtSetArg(args[nn], XmNmwmDecorations, MWM_DECOR_BORDER);
  nn++;
  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;
  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;
  XtSetArg(args[nn], XmNuserData, node);
  nn++;

/* We will position it ourselves when mapped. */

  XtSetArg(args[nn], XmNdefaultPosition, False);
  nn++;

/* Not managed yet or it would be shown too soon.
   Special name so resources can be set.
   See earlier discussion of effects of parent visibility. */

  FD = XmCreateFormDialog(parent, "list_box_form", args, nn);

/* So we know a List terminal is popped up... */

  XtAddCallback(XtParent(FD), XtNpopupCallback, cxm_Terminal_Popup_CB, (XtPointer)FD);

/* Either an array of strings with a count,
   or one string with spaces delimiting the items.
   Allow for no initial list at all. */

  if (nst > 0) {
    xmstr = (XmString *) XtMalloc(sizeof(XmString) * nst);
    for (i = 0; i < nst; i++)
      xmstr[i] = XmStringCreate(strings[i],
                    XmSTRING_DEFAULT_CHARSET);
  }

  else if (one_string && strlen(one_string)) {
    nst = wordcount(one_string);
    xmstr = (XmString *) XtMalloc(sizeof(XmString) * nst);
    for (i = 0; i < nst; i++)
      xmstr[i] = XmStringCreate(wordx(i, one_string),
                    XmSTRING_DEFAULT_CHARSET);
  }

  nn = 0;

  if (nst) {
    XtSetArg(args[nn], XmNitems, xmstr);
    nn++;
    XtSetArg(args[nn], XmNitemCount, nst);
    nn++;
  }

  XtSetArg(args[nn], XmNselectionPolicy, policy);
  nn++;

  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;

/* Limit the visible size */

  if (nst > 10)
    nvis = 10;
  else
    nvis = nst;

  XtSetArg(args[nn], XmNvisibleItemCount, nst);
  nn++;

/* The default policy is ok so nothing is set.
   Vertical scrolling only if unable to show all.
   XtSetArg(args[nn], XmNscrollBarDisplayPolicy, XmAS_NEEDED); nn++;
   Horizontal size adjusts to fit widest item w/out scrolling.
   XtSetArg(args[nn], XmNlistSizePolicy, XmVARIABLE); nn++; */

  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;

/* LW is the List Widget of class xmL'W'C' with given name.
   It is wrapped in a 'nameSW' ScrolledWindow.
   This parent also has an XmNclipWindow (Widget) resource. */

  XtManageChild(
          LW = XmCreateScrolledList(FD, name,
                      args, nn));

/* Free all the strings (and the pointer array) when done with them. */

  for (i = 1; i < nst; i++)
    XtFree((char *)xmstr[i]);
  if (xmstr)
    XtFree((char *)xmstr);

/* Callback according to selection policy at time of creation,
   there is also a CB defined for double-click on a list entry,
   but if we share the same CB it should test the reason.
  XtAddCallback(LW, XmNdefaultActionCallback, CB, node); */

  if (node) {
    if (policy == XmSINGLE_SELECT) {
      XtAddCallback(LW,
              XmNsingleSelectionCallback,
              cxm_list_single_CB,
              (XtPointer)node);
    }

    else if (policy == XmMULTIPLE_SELECT) {
      XtAddCallback(LW,
              XmNmultipleSelectionCallback,
              cxm_list_multi_CB,
              (XtPointer)node);
    }
  }

  prev = LW;

/* Create just an Ok to leave with no (or no further) action.
   Calling it "Done" would be more accurate here;
   user selections are applied as they are made w/out Ok.
   No Apply or Cancel buttons here,
   because already Applied and too late to Cancel.
   Pass the Done_CB the dialog to be popped down. */

  XtManageChild(button =
          cxm_make_button(FD, "Ok",
           NULL, NULL, cxm_MAKE_DEFAULT, cxm_Terminal_Done_CB, FD));
  nn = 0;

  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNtopWidget, prev);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;

  XtSetArg(args[nn], XmNdefaultButton, button);
  nn++;

  XtSetValues(button, args, nn);

  prev = button;

  if (all_OK) {
    XtManageChild(button =
        cxm_make_button(FD, "All", NULL, NULL, NULL, cxm_All_CB, LW));

    nn = 0;

    XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
    nn++;
    XtSetArg(args[nn], XmNtopWidget, prev);
    nn++;
    XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
    nn++;
    XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
    nn++;

    XtSetValues(button, args, nn);

    prev = button;
  }

  if (none_OK) {
    XtManageChild(button =
      cxm_make_button(FD, "None", NULL, NULL, NULL, cxm_None_CB, LW));

    nn = 0;

    XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
    nn++;
    XtSetArg(args[nn], XmNtopWidget, prev);
    nn++;
    XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
    nn++;
    XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
    nn++;

    XtSetValues(button, args, nn);

    prev = button;
  }

  if (help && strlen(help)) {
    XtManageChild(Hbutton =
            cxm_make_button(FD, "Help",
                    NULL, NULL, 0, cxm_Help_CB, help));

    nn = 0;

    XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
    nn++;
    XtSetArg(args[nn], XmNtopWidget, prev);
    nn++;
    XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
    nn++;
    XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
    nn++;
    XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
    nn++;

    XtSetValues(Hbutton, args, nn);

    XtAddCallback(FD, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);

    prev = button;
  }

/* The button to popup this dialog from the parent.
   Give it the node name to use as default button label.
   Give it help resource if a topic is named.
   Several button styles are provided: */

/* Like MS_Windows Combo Box.
   A TextField shows the current selection;
   the user can type in a new value or click to open a List.
   Possible only for single-choice entry,
   and requested by providing a validation routine. */

  if (only_one
   && (Node_Kind(Node_Back(node)) == AndNode)
   && Node_Enable_Ok(node))
    XtManageChild(button =
            cxm_make_combo_button(parent, name,
                        "", cols,
                        LW,
                        node));

/* A Label shows some app-provided information,
   perhaps the current or most recent selection or a count;
   the user must click to open a List. */

  else if (Node_Summary(node))
    XtManageChild(button =
            cxm_make_summary_button(parent, name,
                        mnemonic, NULL,
                        " ", cols,
                        NULL, NULL, NULL));

/* Simple named button;
   the user must click to open a List. */

  else
    XtManageChild(button =
            cxm_make_button(parent, name,
                    mnemonic, NULL,
                    NULL, NULL, NULL));

  NodeButton[node] = button;

  XtAddCallback(button, XmNactivateCallback, cxm_show_Terminal_CB, (XtPointer)FD);

  XtAddCallback(FD, XmNmapCallback, cxm_Dialog_Map_CB, NULL);

  if (help && strlen(help))
    XtAddCallback(button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);

  return LW;
}

/* Use for Long Float Cyclic Struct terminals.
   All particulars provided by app-code.
   The CB_data (via userData) tells what to do.

   InsertionPosition ranges from 0 at left of entire string,
   through LastPosition at right of entire string.

| A B C |
|^ ^ ^ ^|
|0 1 2 3|
*/

static void
cxm_value_ID_CB(Widget w,
        XtPointer client_data,
        XtPointer call_data)
{
  char       *pm = XtName(w);
  char       *vs = XmTextFieldGetString((Widget) client_data);
  int       ip = XmTextFieldGetInsertionPosition((Widget) client_data);
  int       lp = XmTextFieldGetLastPosition((Widget) client_data);

  int       ipp;
  long      sval;
  long      inc;
  char      buff[20];

  int       n;
  Arg       args[10];
  NODEID      anode;

  int       updown;

  long      temp_long;
  float       temp_float;
  double      temp_double;

  n = 0;
  XtSetArg(args[n], XmNuserData, &anode);
  n++;
  XtGetValues((Widget) client_data, args, n);

  updown = (strcmp(pm, "+") ? -1 : 1);

/* Could make failure to click a position mean right not left end. */

  if (!ip)
    ip = lp;

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

  switch (Node_Term_Kind(anode)) {

  case INT_TERM:
    (void) Node_Term_Decode(anode) (vs,
                    strlen(vs) - ip, updown,
                    &temp_long);

    if (Node_Long_Min(anode)
      && (temp_long < Node_Long_Min(anode) (anode)))
      temp_long = Node_Long_Min(anode) (anode);

    if (Node_Long_Max(anode)
      && (temp_long > Node_Long_Max(anode) (anode)))
      temp_long = Node_Long_Max(anode) (anode);

    strcpy(buff,
         Node_Term_Encode(anode) (temp_long,
                    Cond(Node_Term_Width(anode), anode)));

    DefLong(Node_Name(anode), temp_long);
    INT_VAL = temp_long;

    break;

  case FLOAT_TERM:
    (void) Node_Term_Decode(anode) (vs,
                    strlen(vs) - ip, updown,
                    &temp_float);

    if (Node_Float_Min(anode)
      && (temp_float < Node_Float_Min(anode) (anode)))
      temp_float = Node_Float_Min(anode) (anode);

    if (Node_Float_Max(anode)
      && (temp_float > Node_Float_Max(anode) (anode)))
      temp_float = Node_Float_Max(anode) (anode);

    strcpy(buff,
         Node_Term_Encode(anode) (temp_float,
                    Cond(Node_Term_Width(anode), anode)));

    DefFloat(Node_Name(anode), temp_float);
    FLOAT_VAL = temp_float;
    break;

  case DOUBLE_TERM:
    (void) Node_Term_Decode(anode) (vs,
                    strlen(vs) - ip, updown,
                    &temp_double);

    if (Node_Double_Min(anode)
      && (temp_double < Node_Double_Min(anode) (anode)))
      temp_double = Node_Double_Min(anode) (anode);

    if (Node_Double_Max(anode)
      && (temp_double > Node_Double_Max(anode) (anode)))
      temp_double = Node_Double_Max(anode) (anode);

    strcpy(buff,
         Node_Term_Encode(anode) (temp_double,
                    Cond(Node_Term_Width(anode), anode)));

    DefDouble(Node_Name(anode), temp_double);
    DOUBLE_VAL = temp_double;
    break;

  case CYCLE_TERM:
    (void) cycle_l(vs,
             Node_Choice_Set(anode) (anode),
             updown,
             &temp_long);

    strcpy(buff,
         Node_Term_Encode(anode) (temp_long,
                    Node_Choice_Set(anode) (anode)));

    DefLong(Node_Name(anode), temp_long);
    CYCLE_INDEX = temp_long;
    CYCLE_STRING = buff;
    break;

  case STRUCT_TERM:

/* Sets a pointer to a static block. */

    (void) Node_Term_Decode(anode) (vs,
                    strlen(vs) - ip, updown,
                    &temp_long);

    strcpy(buff,
         Node_Term_Encode(anode) (temp_long,
                    Cond(Node_Term_Width(anode), anode)));

    uidef(Node_Name(anode), STRUCTVAL, Node_StrucSize(anode), temp_long);

    break;
  }

/* Stay at same power of ten or whatever. */

  if (strlen(buff) > lp)
    ip++;

  XmTextFieldSetString((Widget) client_data, buff);
  XmTextFieldSetInsertionPosition((Widget) client_data, ip);

/* Make the updated string available too.
   Cannot just point at gotten "vs" string and free it next time,
   because it is the "old" value before incr or decr. */

  if (STRING_VAL)
    XtFree(STRING_VAL);

  STRING_VAL = strdup(buff);

/* So release this one now. */

  free(vs);

  cxm_do_term_action(anode, False);
}

static      Widget
cxm_make_value_button(Widget parent,
            char *name,
            char *initial, int cols, Boolean read_only,
            char *help,
            int node)
{
  Widget      frame;
  Widget      rc;
  Widget      incr_button;
  Widget      decr_button;
  Widget      value;

  Widget      label_widget;
  XmString    tcs;
  Arg       args[10];
  int       nn = 0;

/* c y a */

  if ((cols > 20) || (cols < 1))
    cols = 20;

/* Group the value and label and inc/dec buttons in a form.
   Make the grouping visible by a frame.
   But prevent the group from being a tab stop. */

  nn = 0;
  XtSetArg(args[nn], XmNshadowType, XmSHADOW_ETCHED_IN);
  nn++;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(frame =
          XmCreateFrame(parent, "frame", args, nn));

  nn = 0;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(rc =
          XmCreateForm(frame, "form", args, nn));

  nn = 0;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNvalue, initial);
  nn++;
  XtSetArg(args[nn], XmNcolumns, cols);
  nn++;
  XtSetArg(args[nn], XmNmaxLength, cols);
  nn++;

  XtSetArg(args[nn], XmNuserData, node);
  nn++;

  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;

/* False to prevent type-ins,
   still let user set click position.
   Name it 'name' for later lookup to update. */

  XtSetArg(args[nn], XmNeditable, False);
  nn++;
  XtManageChild(value =
          XmCreateTextField(rc, name, args, nn));

  NodeValue[node] = value;

  nn = 0;
  tcs = XmStringLtoRCreate(name, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[nn], XmNlabelString, tcs);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNtopWidget, value);
  nn++;
  XtManageChild(label_widget =
          XmCreateLabel(rc, "label", args, nn));
  XmStringFree(tcs);

  if (!read_only) {
    nn = 0;
    XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
    nn++;
    XtSetArg(args[nn], XmNleftWidget, value);
    nn++;
    XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
    nn++;
    XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
    nn++;
    XtManageChild(incr_button =
            XmCreatePushButtonGadget(rc, "+", args, nn));

    XtAddCallback(incr_button, XmNactivateCallback, cxm_value_ID_CB, (XtPointer)value);

    nn = 0;
    XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
    nn++;
    XtSetArg(args[nn], XmNleftWidget, value);
    nn++;
    XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
    nn++;
    XtSetArg(args[nn], XmNtopWidget, incr_button);
    nn++;
    XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
    nn++;
    XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
    nn++;
    XtManageChild(decr_button =
            XmCreatePushButtonGadget(rc, "-", args, nn));

    XtAddCallback(decr_button, XmNactivateCallback, cxm_value_ID_CB, (XtPointer)value);

/* The help CB can only apply to input items like buttons,
   but the E_L can apply to the whole composite. */

    if (help && strlen(help)) {
      XtAddCallback(incr_button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
      XtAddCallback(decr_button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
      (void) cxm_set_Enter_Leave(rc, node);
    }
  }

  return frame;
}

/* Use only for Cyclic terminals. */

static void
cxm_cycle_CB(Widget w,
       XtPointer client_data,
       XtPointer call_data)
{
  char       *ncs;
  char       *show;

  int       nn = 0;
  Arg       args[10];
  NODEID      anode;

  long      temp_long;

  int       cols;

  nn = 0;
  XtSetArg(args[nn], XmNuserData, &anode);
  nn++;
  XtGetValues((Widget) client_data, args, nn);

  cols = Cond(Node_Term_Width(anode), anode);
  ncs = Node_Choice_Set(anode) (anode);
  temp_long = 1 + GetLong(Node_Name(anode));

  if (temp_long >= wordcount(ncs))
    temp_long = 0;

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

  DefLong(Node_Name(anode), temp_long);
  CYCLE_INDEX = temp_long;

/* The next cyclic word to show is copied to a static buffer. */

  show = wordx(temp_long, ncs);

/* Ok to work in the static buffer to adjust appearance?
   Maybe not anymore!
   Look at wordx. */

  while (strlen(show) < cols)
    strcat(show, " ");

  if (cols)
    *(show + cols) = NULL;

  CYCLE_STRING = show;
  cx_set_string((Widget) client_data, show);

  cxm_do_term_action(anode, False);
}

static      Widget
cxm_make_cycle_button(Widget parent,
            char *name,
            char *initial, int cols, Boolean read_only,
            char *help,
            int node)
{
  Widget      frame;
  Widget      rc;
  Widget      incr_button = NULL;
  Widget      cycle;
  Widget      prev_w;
  Widget      label_widget;
  XmString    tcs;
  char      showstr[24];
  Arg       args[10];
  int       nn = 0;

/* c y a */

  if (!initial)
    return;

  strncpy(showstr, initial, 20);

  if (cols > 20)
    cols = 20;

  while (strlen(showstr) < cols)
    strcat(showstr, " ");

  if (cols)
    showstr[cols] = NULL;

/* Group the cycle and label and inc button.
   But prevent the group from being a tab stop.
   Make the grouping visible. */

  nn = 0;
  XtSetArg(args[nn], XmNshadowType, XmSHADOW_ETCHED_IN);
  nn++;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(frame =
          XmCreateFrame(parent, "frame", args, nn));

  nn = 0;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(rc =
          XmCreateForm(frame, "form", args, nn));

/* The constant label. */

  nn = 0;
  tcs = XmStringLtoRCreate(name, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[nn], XmNlabelString, tcs);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtManageChild(label_widget =
          XmCreateLabel(rc, "label", args, nn));
  XmStringFree(tcs);

  prev_w = label_widget;

/* The advancing button if wanted. */

  if (!read_only) {
    nn = 0;

    XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
    nn++;
    XtSetArg(args[nn], XmNleftWidget, prev_w);
    nn++;
/*
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;
*/
    XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
    nn++;
    XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
    nn++;
    XtManageChild(incr_button =
            XmCreatePushButtonGadget(rc, "+", args, nn));

    prev_w = incr_button;
  }

/* The cyclic value display. */

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;

  XtSetArg(args[nn], XmNuserData, node);
  nn++;

  tcs = XmStringLtoRCreate(showstr, XmSTRING_DEFAULT_CHARSET);

  XtSetArg(args[nn], XmNlabelString, tcs);
  nn++;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;

  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNleftWidget, prev_w);
  nn++;
  XtManageChild(cycle =
          XmCreateLabel(rc, name, args, nn));
  XmStringFree(tcs);

  if (incr_button) {
    XtAddCallback(incr_button, XmNactivateCallback, cxm_cycle_CB, (XtPointer)cycle);

/* The help CB can only apply to input items like buttons,
   but the E_L can apply to the whole composite. */

    if (help && strlen(help)) {
      XtAddCallback(incr_button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
      (void) cxm_set_Enter_Leave(rc, node);
    }
  }

  NodeValue[node] = cycle;

  return frame;
}

/* For free-form string entry.
   This CB is used with the popup and constant versions.
   Called for user-input CR (no longer called for application updates)
   but not called at all if read-only. */

static void
cxm_string_CB(Widget text,
        XtPointer client_data,
        XtPointer call_data)
{
  char       *ncs;
  char       *show;

  int       nn = 0;
  Arg       args[10];
  NODEID      anode;

  int       cols;

/* This returns a malloc'd copy that we later free. */

  char       *vs = XmTextFieldGetString(text);

/* Get rid of trailing blanks. */

  cols = strlen(vs);
  while (cols && vs[cols - 1] == ' ')
    vs[--cols] = NULL;

  nn = 0;
  XtSetArg(args[nn], XmNuserData, &anode);
  nn++;
  XtGetValues(text, args, nn);

/* Clipping may not be such a good idea.
   The Widget doesn't care about overflows.

   What we should use is a Verify callback.
   Support a few pre-defined attributes;
   upper and lower case and no-echo. */

  cols = Cond(Node_Term_Width(anode), anode);

  if ((cols > 0) && strlen(vs) > cols)
    vs[cols] = NULL;

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

  DefString(Node_Name(anode), vs);

/* Kinda sleazy -- just point at gotten string and free it next time. */

  if (STRING_VAL)
    XtFree(STRING_VAL);

  STRING_VAL = vs;

  cxm_do_term_action(anode, False);

/* If visible in a dialog rather than popped up,
   advance the focus from here to some other terminal.
   Remember that text is a tab group of its own. */

  if (!client_data)
    XmProcessTraversal(text, XmTRAVERSE_NEXT_TAB_GROUP);

/* If a popup we have the dialog as client_data.
   If it has no Remain or false Remain,
   directly call another CB to close the popup.
   Pass it the dialog to be popped down. */

  if (client_data && !Cond(Node_Remain(anode), anode))
    cxm_Terminal_Done_CB((Widget) NULL,
               client_data,
               (XtPointer) NULL);
}

static      Widget
cxm_make_String(Widget parent,
        char *name,
        char *initial, int cols, Boolean read_only,
        char *help,
        int node)
{
  Widget      frame;
  Widget      rc;
  Widget      value;

  Widget      label_widget;
  XmString    tcs;
  Arg       args[10];
  int       nn = 0;

/* c y a */

  if (cols > 80)
    cols = 80;

  if (cols < 1)
    cols = 2;

/* Group the value field and name label in a framed form.
   Make the grouping visible. */

  nn = 0;
  XtSetArg(args[nn], XmNshadowType, XmSHADOW_ETCHED_IN);
  nn++;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(frame =
          XmCreateFrame(parent, "frame", args, nn));

  nn = 0;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;
  XtManageChild(rc =
          XmCreateForm(frame, "form", args, nn));

/* The name label. */

  nn = 0;

  if (name && strlen(name)) {
    tcs = XmStringLtoRCreate(name, XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[nn], XmNlabelString, tcs);
    nn++;
  }
  else
    tcs = NULL;

  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNnavigationType, XmNONE);
  nn++;

  XtManageChild(label_widget =
          XmCreateLabel(rc, "label", args, nn));

  if (tcs)
    XmStringFree(tcs);

/* Now the value field. */

  nn = 0;

  XtSetArg(args[nn], XmNuserData, node);
  nn++;

  if (initial && strlen(initial)) {
    XtSetArg(args[nn], XmNvalue, initial);
    nn++;
  }

  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNleftWidget, label_widget);
  nn++;

  XtSetArg(args[nn], XmNcolumns, cols);
  nn++;

/* SINGLE is default anyway... */

  XtSetArg(args[nn], XmNeditMode, XmSINGLE_LINE_EDIT);
  nn++;
  XtSetArg(args[nn], XmNeditable, !read_only);
  nn++;
  XtSetArg(args[nn], XmNcursorPositionVisible, !read_only);
  nn++;

  XtManageChild(value =
          XmCreateTextField(rc, name, args, nn));

  NodeValue[node] = value;

/* Not a separate Terminal dialog needing to be closed so pass NULL. */

  if (!read_only) {

/* Do NOT want response to every keystroke ...
  XtAddCallback(value, XmNvalueChangedCallback, cxm_string_CB, NULL);
 ... but hopefully no problem re app-provided changes and updates */

    XtAddCallback(value, XmNactivateCallback, cxm_string_CB, NULL);
  }

  if (help && strlen(help))
    (void) cxm_set_Enter_Leave(rc, node);

  return frame;
}

/* Think about what control buttons we need...
   Ok to act and leave -- same as CR in the Text so not really needed.
   Cancel to just leave is needed.
   Apply to act and stay is needed if Remain is set.
   Help.
   Looks like a full dialog panel.
   But be careful what CB calls we use -- NOT the same as And node. */

static      Widget
cxm_make_String_popup(Widget parent,
            char *name,
            char *initial, int cols, Boolean read_only,
            char *help,
            int node)
{
  Widget      FD;
  Widget      TW;
  Widget      button;
  Widget      panel;

  Arg       args[10];
  int       nn = 0;

  int       act_flags = 0;

/* The popup form.
   Simple border w/out any controls or title.
   Otherwise we would set XmNdialogTitle.
   Size to fit contents. */

  XtSetArg(args[nn], XmNmwmDecorations, MWM_DECOR_BORDER);
  nn++;
  XtSetArg(args[nn], XmNresizePolicy, XmRESIZE_ANY);
  nn++;

/* We have our own dismissal methods. */

  XtSetArg(args[nn], XmNdeleteResponse, XmDO_NOTHING);
  nn++;
  XtSetArg(args[nn], XmNautoUnmanage, False);
  nn++;
  XtSetArg(args[nn], XmNuserData, node);
  nn++;

/* We will position it ourselves when mapped. */

  XtSetArg(args[nn], XmNdefaultPosition, False);
  nn++;

/* Not managed yet or it would be shown too soon... */

  FD = XmCreateFormDialog(parent, "string_form", args, nn);

/* The button to popup this dialog from the parent.
   Give it the node name to use as default button label.
   Give it help resource if a topic is named. */

  if (Node_Summary(node))
    XtManageChild(button =
            cxm_make_summary_button(parent, name,
                        NULL, NULL,
                        " ", 8,
                        NULL, NULL, NULL));
  else
    XtManageChild(button =
            cxm_make_button(parent, name,
                    NULL, NULL,
                    NULL, NULL, NULL));

  NodeButton[node] = button;

  XtAddCallback(button, XmNactivateCallback, cxm_show_Terminal_CB, (XtPointer)FD);

  if (help && strlen(help))
    XtAddCallback(button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);

/* So we know a Text terminal is popped up... */

  XtAddCallback(XtParent(FD), XtNpopupCallback, cxm_Terminal_Popup_CB, (XtPointer)FD);

/* Several control buttons are available -- what do we need?
   May want to allow spec of full-Motif vs abbreviated style too. */

/* This is NOT quite right! */

  act_flags = cxm_MAKE_OK + cxm_MAKE_CANCEL;

  if (Node_Action(node)
    && Node_Remain(node)
    && !Node_Auto_Ok(node)) {
    act_flags |= cxm_MAKE_APPLY;
    act_flags |= cxm_MAKE_RESET;
  }

/* Just this for now... */

  act_flags = cxm_MAKE_CANCEL;

/* Still using the And node CB calls! Wrong! */

  panel = cxm_make_action_panel(FD, act_flags, node, help);

  nn = 0;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;
  XtSetValues(panel, args, nn);

/* This Widget will be returned. */

  nn = 0;

  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
  nn++;
  XtSetArg(args[nn], XmNtopWidget, panel);
  nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
  nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
  nn++;

/* c y a */

  if (cols > 80)
    cols = 80;

  if (cols < 1)
    cols = 2;

  XtSetArg(args[nn], XmNuserData, node);
  nn++;

  if (initial && strlen(initial)) {
    XtSetArg(args[nn], XmNvalue, initial);
    nn++;
  }

  XtSetArg(args[nn], XmNcolumns, cols);
  nn++;

/* SINGLE is default anyway... */

  XtSetArg(args[nn], XmNeditMode, XmSINGLE_LINE_EDIT);
  nn++;
  XtSetArg(args[nn], XmNeditable, !read_only);
  nn++;
  XtSetArg(args[nn], XmNcursorPositionVisible, !read_only);
  nn++;

  XtManageChild(TW =
          XmCreateTextField(FD, name, args, nn));

  NodeValue[node] = TW;

  if (!read_only)
    XtAddCallback(TW, XmNactivateCallback, cxm_string_CB, (XtPointer)FD);

  if (help && strlen(help))
    XtAddCallback(FD, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);

/* Want focus at the TW when popped up.
   The best we can do here is position it over the cursor;
   setting the focus in the CB didn't work. */

  XtAddCallback(FD, XmNmapCallback, cxm_Dialog_Map_CB, (XtPointer)TW);

/* This CB is called when FD gains focus so it traversal works.
   But it also is called when traversal shifts the focus,
   so we must be careful to avoid endless loop. */

  XtAddCallback(FD, XmNfocusCallback, cxm_Dialog_Focus_CB, (XtPointer)TW);

  return TW;
}

/* Some pulldown or popup OrNode menu is mapped. */

static void
cxm_Menu_Map_CB(Widget w,
        XtPointer client_data,
        XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: node %s %d is Mapped\n",
        Node_Name(anode), anode);
    fflush(DEBUG);
  }
#endif

  cxm_zap_Help();
  cxm_zap_Error();

/* Put only the OrNode onto the active stack. */

  if (Node_Kind(anode) == OrNode)
    cxm_showing_node(anode);
}

/* Some menu is unmapped,
   either when a selection is made or the menu is dismissed.
   Should remove node from activation stack only if dismissed.
   Problem is we come here before the selection callback,
   so it is too soon to know which.

   We gray-out the toolbar when anything else is pulled or popped down,
   and should restore it when the other thing is done with.

   KLUDGE enables toolbar WHENEVER a level two menu is dismissed.
   Level one is the menubar; each pulldown menu is at level two.
   See if this is less annoying than leaving it disabled. */

static void
cxm_Menu_Unmap_CB(Widget w,
        XtPointer client_data,
        XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: node %s %d is Unmapped at Level %d\n",
        Node_Name(anode), anode, Node_Level(anode));
    fflush(DEBUG);
  }
#endif

  if (toolbar && (Node_Level(anode) == 2))
    XtSetSensitive(toolbar, TRUE);
}

/* Some pulldown optionmenu is mapped.
   Nothing left to do here;
   menuHistory was needed when the panel was shown. */

static void
cxm_OptionMenu_Map_CB(Widget w,
            XtPointer client_data,
            XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: %s optionmenu value %s node %s is Mapped\n",
        app_name, GetString(Node_Name(anode)), Node_Name(anode));
    fflush(DEBUG);
  }
#endif

  cxm_zap_Help();
  cxm_zap_Error();
}

/* Menu and the cascade button to show it. */

static      Widget
cxm_make_pulldown_menu(Widget parent,
             char *name,
             char mnemonic, char acc, char *help, int node)
{
  Arg       args[10];
  int       nn = 0;

  Widget      button;

  Widget      pulldown = NULL;

/* Find a pre-defined managed button else create it now.
   If found but w/out submenu create that now. */

  if ((button = cx_find_named_child(parent, name, NULL))) {
    nn = 0;
    XtSetArg(args[nn], XmNsubMenuId, &pulldown);
    nn++;
    XtGetValues(button, args, nn);

    nn = 0;
    if (!pulldown) {
      pulldown = XmCreatePulldownMenu(parent, "pulldown", NULL, 0);

      XtAddCallback(pulldown, XmNmapCallback, cxm_Menu_Map_CB, (XtPointer)node);
      XtAddCallback(pulldown, XmNunmapCallback, cxm_Menu_Unmap_CB, (XtPointer)node);

      if (help && strlen(help))
        XtAddCallback(pulldown, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
      XtSetArg(args[nn], XmNsubMenuId, pulldown);
      nn++;
    }
    if (mnemonic) {
      XtSetArg(args[nn], XmNmnemonic, mnemonic);
      nn++;
    }
    XtSetValues(button, args, nn);
  }

/* Create button now also the submenu. */

  else {
    if (!pulldown) {
      pulldown = XmCreatePulldownMenu(parent, "pulldown", NULL, 0);

      XtAddCallback(pulldown, XmNmapCallback, cxm_Menu_Map_CB, (XtPointer)node);
      XtAddCallback(pulldown, XmNunmapCallback, cxm_Menu_Unmap_CB, (XtPointer)node);

      if (help && strlen(help))
        XtAddCallback(pulldown, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
    }
    XtManageChild(button =
            cxm_make_button(parent, name,
              mnemonic, acc, cxm_MAKE_CASCADE, NULL, pulldown));

    if (!strcasecmp(name,
            "Help")) {
      nn = 0;
      XtSetArg(args[nn], XmNmenuHelpWidget, button);
      nn++;
      XtSetValues(parent, args, nn);
    }
  }

/* Save this regardless if we found it or created it. */

  NodeButton[node] = button;

  if (help && strlen(help))
    XtAddCallback(button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);

  return pulldown;
}

/* Handle mouse button clicks in the drawing widget.
   Set global MOUSE_X and MOUSE_Y coordinates,
   as well as MOUSE_Y_COMP from the bottom for those used to it.

   Button 1 clicks to be passed to application code.

   Button 3 shows popup menu at mouse location.
   Discussion in Heller 16.3.3 "Using Popup Menus" warns
   that use of other buttons for popup may cause toolkit bugs! */

static void
cxm_MButton_EH(Widget where,
         XtPointer client_data,
         XEvent * event,
         Boolean *continue_to_dispatch)
{
  Widget      should = (Widget) client_data;
  XButtonPressedEvent *XBPE = (XButtonPressedEvent *) event;

  NODEID      test_node;

  Dimension     Pheight;
  Dimension     xoffset, xfudge = 0, yoffset, yfudge = 0;

/* If we had to get event on ancestor instead of proper widget,
   accumulate fudge factors for the coordinates. */

  while (should != where) {
    XtVaGetValues(should,
            XtNx, &xoffset,
            XtNy, &yoffset,
            NULL);
    xfudge += xoffset;
    yfudge += yoffset;
    should = XtParent(should);
  }

  XtVaGetValues(where,
          XtNheight, &Pheight,
          NULL);

/* Strictly need both XBPE and XBRE casts... */

  MOUSE_X = XBPE->x - xfudge;
  MOUSE_Y = XBPE->y - yfudge;

/* This one is not affected by yfudge. */

  MOUSE_Y_COMP = Pheight - XBPE->y;

/*
printf("x %d y %d ycomp %d\n", MOUSE_X, MOUSE_Y, MOUSE_Y_COMP);
*/

/* Find the highest active node with interest in a click.
   This call has no effect on activation stack. */

  if ((event->type == ButtonRelease)
    && (XBPE->button == Button1)) {

    test_node = UITOP;
    while (test_node) {
      if (Node_Pick(test_node)) {
        Node_Pick(test_node) (test_node);
        break;
      }
      else
        test_node = Node_Back(test_node);
    }
  }

/* Find the highest active node with a popup menu and show it.
   Showing the popup menu will close any higher nodes on the stack. */

  else if ((event->type == ButtonPress)
       && (XBPE->button == Button3)) {

    test_node = UITOP;
    while (test_node) {
      if (NodePopupMenu[test_node]) {
        XmMenuPosition(NodePopupMenu[test_node], XBPE);
        XtManageChild(NodePopupMenu[test_node]);
        break;
      }
      else
        test_node = Node_Back(test_node);
    }
  }
}

/* Keyboard accelerators work if focus is in the parent.
   Mnemonics work while menu is popped up.
   No accelerator or mnemonic for the menu itself. */

static      Widget
cxm_make_popup_menu(Widget parent,
          char *name,
          char *help, int node)
{
  Arg       args[10];
  int       nn = 0;

  Widget      popup_menu =
  XmCreatePopupMenu(parent, name, NULL, 0);

/* This will cancel any open sibling and its descendants,
   just like opening any other menu or dialog. */

  XtAddCallback(popup_menu, XmNmapCallback, cxm_Menu_Map_CB, (XtPointer)node);
  XtAddCallback(popup_menu, XmNunmapCallback, cxm_Menu_Unmap_CB, (XtPointer)node);

  if (help && strlen(help))
    XtAddCallback(popup_menu, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);

/* Menu choices will be added as children of this widget.
   They should only be push or toggle or cascade buttons. */

  return popup_menu;
}

/* Not a menu to Motif so no mnemonics or accelerators! */

static      Widget
cxm_make_toolbar(Widget parent,
         char *help, int node)
{
  Arg       args[10];
  int       nn = 0;

  Toolbar_Node = node;

  XtSetArg(args[nn], XmNorientation, XmHORIZONTAL);
  nn++;

  XtManageChild(toolbar =
          XmCreateRowColumn(parent, "toolbar", args, nn));

/* Install toolbar as "XmNcommandWindow" of the mainwindow. */

  XtVaSetValues(parent,
          XmNcommandWindow, toolbar,
          NULL);

  if (help && strlen(help)) {
    XtAddCallback(toolbar, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
    (void) cxm_set_Enter_Leave(toolbar, node);
  }

/* Choices will be added as children of this widget.
   They should only be push or toggle or cycle buttons. */

  return toolbar;
}

/* Menu and the special optionmenu button to show it.
   This may be child of a dialog but not of a menu. */

static      Widget
cxm_make_option_menu(Widget parent,
           char *name,
           char mnemonic, char acc, char *help, int node)
{
  Arg       args[10];
  int       nn = 0;

  XmString    tcs;

  Widget      button;

  Widget      pulldown =
  XmCreatePulldownMenu(parent, "pulldown", NULL, 0);

  nn = 0;

/* Allow mnemonic but not accelerator. */

  if (mnemonic) {
    XtSetArg(args[nn], XmNmnemonic, mnemonic);
    nn++;
  }

/* This must be pre-existing for use as creation arg. */

  XtSetArg(args[nn], XmNsubMenuId, pulldown);
  nn++;

/* We must SET a label to HAVE a label! */

  tcs = XmStringLtoRCreate(name, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[nn], XmNlabelString, tcs);
  nn++;

  XtManageChild(button =
          XmCreateOptionMenu(parent, name, args, nn));

  XmStringFree(tcs);

/* Not exactly a button but it is what we want later... */

  NodeButton[node] = button;

  if (help && strlen(help)) {
    XtAddCallback(pulldown, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
    XtAddCallback(button, XmNhelpCallback, cxm_Help_CB, (XtPointer)help);
  }

/* So we know an optionmenu is opened... */

  XtAddCallback(pulldown, XmNmapCallback, cxm_OptionMenu_Map_CB, (XtPointer)node);

  return pulldown;
}

/* This CB for 'ordinary' or 'option' choose_one pulldown menu. */

static void
choose_one_CB(
        Widget w,
        XtPointer client_data,
        XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "node %s choose_one_CB %s\n",
        Node_Name(anode), XtName(w));
    fflush(DEBUG);
  }
#endif

  if (CHOICE_ADD)
    XtFree(CHOICE_ADD);
  CHOICE_ADD = NULL;

  if (CHOICE_DEL)
    XtFree(CHOICE_DEL);
  CHOICE_DEL = NULL;

  if (CHOICE_LIST)
    XtFree(CHOICE_LIST);
  CHOICE_LIST = NULL;

/* Get rid of any open sibling so a result will store in this level. */

  while (Actives >= Node_Level(anode))
    cxm_cancel_node(UITOP);

  DefString(Node_Name(anode), XtName(w));

/* Beware!
   These must point to separate copies because each will be released!
   Freeing the same pointer twice is VERY bad. */

  CHOICE_ADD = strdup(XtName(w));
  CHOICE_LIST = strdup(XtName(w));

  cxm_do_term_action(anode, False);
}

/* This CB for 'radio' choose_one menu. */

static void
radio_box_CB(
       Widget w,
       XtPointer * client_data,
       XtPointer * call_data)
{
  NODEID      anode = (NODEID) client_data;
  XmToggleButtonCallbackStruct *TBCS =
  (XmToggleButtonCallbackStruct *) call_data;

  if (TBCS->set) {

    if (CHOICE_ADD)
      XtFree(CHOICE_ADD);
    CHOICE_ADD = NULL;

    if (CHOICE_DEL)
      XtFree(CHOICE_DEL);
    CHOICE_DEL = NULL;

    if (CHOICE_LIST)
      XtFree(CHOICE_LIST);
    CHOICE_LIST = NULL;

/* Get rid of any open sibling so a result will store in this level. */

    while (Actives >= Node_Level(anode))
      cxm_cancel_node(UITOP);

    DefString(Node_Name(anode), XtName(w));

    CHOICE_ADD = strdup(XtName(w));
    CHOICE_LIST = strdup(XtName(w));

    cxm_do_term_action(anode, False);
  }
}

/* Support optionmenu where it can be used.
   Special optionmenu button allowed in a dialog but not in a menu.
   The pulldown will hold pushbuttons. */

static      Widget
cxm_make_choose_one_menu(Widget parent,
             char *name,
             char mnemonic, char acc, char *help,
             char **idlist, int nst,
             char *one_string,
             int node)
{
  int       ii = 0;
  Arg       args[10];
  int       nn = 0;

  int       button_style = 0;
  void       *callback;

  Widget      pulldown;

/* Create the menu and the button to show it.

   Call returns only the created manager widget,
   but also posts the controlling NodeButton.

   Sorry but an OptionMenu in a menu is not allowed.
   IMO this is a bug called a feature.
   Correctly has most recent one showing,
   but causes various runtime complaints.
   The actual pulldown it would pop is exactly the same. */

  pulldown = cxm_make_option_menu(parent, name,
                    mnemonic, NULL, help, node);

  callback = choose_one_CB;

/* Either an array of strings with a count,
   or one string with spaces delimiting the items. */

  if (nst > 0)
    for (ii = 0; ii < nst; ii++)
      XtManageChild(
              cxm_make_button(pulldown,
                      idlist[ii],
                      NULL, NULL, button_style,
                      callback, (void *) node));

  else {
    nst = wordcount(one_string);
    for (ii = 0; ii < nst; ii++)
      XtManageChild(
              cxm_make_button(pulldown,
                      wordx(ii, one_string),
                      NULL, NULL, button_style,
                      callback, (void *) node));
  }

  return pulldown;
}

/* Standard Help pulldown per Motif Style Guide.
   Some influence from MS-Windows Style Guide.

   Create pulldown menu and a button to pop it,
   and because of the "Help" name,
   tell parent menubar of special button usage,
   so it will be placed at far right,
   regardless of order of creation. */

static void
cxm_make_Help_pulldown(Widget parent,
             char *help_help,
             char *window_help,
             char *keys_help,
             char *gui_help,
             char **topics)
{
  Widget      pulldown =
  cxm_make_pulldown_menu(parent, "Help", 'H', NULL, help_help, 0);

  Widget      index_menu;
  Widget      button;
  int       ii;

/* Use Node Zero for all of these,
   and button names for what help to show. */

  Node_Help(0) = help_help;

  (void) cxm_set_Enter_Leave(NodeButton[0], 0);

/* Balloon-help borrowed from MS-W style.

   To be REALLY MS-W style we shouldn't use a Toggle here;
   instead we use two buttons called show and hide Balloons,
   and alternately manage and unmanage them in a shared callback.
   They can both use 'B' if only one is managed. */

  cx_set_mnemonic(showBalloon =
           cxm_make_button(pulldown,
                   "show Balloons", NULL, NULL,
                 NULL, cxm_want_Balloon_CB, (XtPointer) 1));

  (void) cxm_set_Enter_Leave(showBalloon, 0);

  cx_set_mnemonic(hideBalloon =
           cxm_make_button(pulldown,
                   "hide Balloons", NULL, NULL,
                 NULL, cxm_want_Balloon_CB, (XtPointer) 0));

  (void) cxm_set_Enter_Leave(hideBalloon, 0);

  if (want_Balloon)
    XtManageChild(hideBalloon);
  else
    XtManageChild(showBalloon);

/* This shows a special "question-mark-arrow" cursor,
   which will be locked into the menubar,
   passed as the 'parent' widget ident as the callback value,
   but could allow more freedom of what to click.
   Clicking somewhere pops a help topic and reverts to normal cursor.

   It conflicts with MS-Windows "Contents" list of major topics,
   but these topics are probably equivalent to the menubar buttons.

   I like the Balloon style better and no need for both of them.
   We could make it an option somewhere but just commented out for now. */

/* ----
  XtManageChild(cx_set_mnemonic(cxm_make_button(pulldown,
            "on Context", NULL, NULL, 0,
               cxm_Context_CB, parent)));
 ---- */

/* Known in MS-W as "How to use help" but with same letter. */

  if (help_help) {
    XtManageChild(cx_set_mnemonic(button = cxm_make_button(pulldown,
                           "on Help", NULL, NULL, 0,
                          cxm_Help_CB, help_help)));
    (void) cxm_set_Enter_Leave(button, 0);
  }

/* Simply the root help topic. */

  if (window_help) {
    XtManageChild(cx_set_mnemonic(button = cxm_make_button(pulldown,
                         "on Window", NULL, NULL, 0,
                        cxm_Help_CB, window_help)));
    (void) cxm_set_Enter_Leave(button, 0);
  }

/* This keyboard info should be automated.
   Passing a NULL until we do so. */

  if (keys_help) {
    XtManageChild(cx_set_mnemonic(button = cxm_make_button(pulldown,
                           "on Keys", NULL, NULL, 0,
                          cxm_Help_CB, keys_help)));
    (void) cxm_set_Enter_Leave(button, 0);
  }

/* General information on using the GUI. */

  if (gui_help) {
    XtManageChild(cx_set_mnemonic(button = cxm_make_button(pulldown,
                           "on GUI", NULL, NULL, 0,
                          cxm_Help_CB, gui_help)));
    (void) cxm_set_Enter_Leave(button, 0);
  }

/* Known in MS-W as "About" but we give "on_Version" with more info. */

  XtManageChild(cx_set_mnemonic(button = cxm_make_button(pulldown,
                           "About", NULL, NULL, 0,
                          cxm_Help_CB, "about")));
  (void) cxm_set_Enter_Leave(button, 0);

  XtManageChild(cx_set_mnemonic(button = cxm_make_button(pulldown,
                        "on Version", NULL, NULL, 0,
                          cxm_Help_CB, "version")));
  (void) cxm_set_Enter_Leave(button, 0);

/* Cascade menu.
   Known as "Index" here and in MS-W.
   Could provide the same list other ways,
   for example a dialog box with a topic List and Text viewer. */

  if (topics) {
    index_menu = cxm_make_pulldown_menu(pulldown, "Index", 'I',
                      NULL, NULL, 0);

    (void) cxm_set_Enter_Leave(NodeButton[0], 0);

/* To provide balloon help on EACH topic,
   they must be widgets rather than gadgets,
   so say NULL instead of cxm_MAKE_GADGET,
   otherwise the outer call does nothing.
   Saves user from opening the "wrong" help topic.
   Probably not worth doing this. */

    for (ii = 0; topics[ii]; ii++) {
      XtManageChild(
         cxm_set_Enter_Leave(
              cxm_make_button(index_menu,
                      topics[ii], NULL, NULL,
                 cxm_MAKE_GADGET,
                 cxm_Help_CB, topics[ii]), 0));
    }
  }
}

/* Callback for File / Exit button or Window Menu / Quit button.
   Calls exit(0) to terminate the Application as default,
   if Application does not specify ON_EXIT code in UI spec. */

static void
cxm_Exit_CB(Widget w,
      XtPointer client_data,
      XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;

  if (Node_On_Exit(anode))
    Node_On_Exit(anode) (anode);

  else if (Node_Action(anode))
    (void) cxm_do_node_action(anode);

  exit(0);
}

/* Callback for Session Manager Save Yourself Protocol.

   O'Reilly Vol 1 Sec 10.2.x says a client should do this:

   1. Save any work-in-progress to a suitably named file,
   also save current program state somewhere in some format if needed,
   and return a command that will restart the program.
   The command may be either completely self-contained,
   or it may refer to a save-format file.

   2. Post (or replace) an XA_WM_COMMAND / XA_STRING property,
   consisting of one or more NULL-terminated words and total length.
   The session manager waits for this response so we must do it.

   If there is nothing new to say, just do a zero-length append.
   The session manager will be satisfied by this response.

   If there is never anything new to say, should not register for this!
   This should mean any applications that do not "edit" data files.
   The session manager will simply use the existing command line.

   Applications that change from their initial command line configuration
   to a configuration that could be described by some new command line,
   should post such a new command line as often as it changes.

   3. Wait to either get zapped by the session manager,
   or resume normal user input as if nothing happened.

   Normally a returned Action string is taken as an error message,
   but here it is the restart command for the Session Manager. */

static void
cxm_Save_Yourself_CB(Widget w,
           XtPointer client_data,
           XtPointer call_data)
{
  NODEID      anode = (NODEID) client_data;
  char       *node_reply = Node_Action(anode) (anode);

  if (node_reply && strlen(node_reply))
    cx_postcmd(1, &node_reply);
  else
    cx_postcmd(0, NULL);
}

static Boolean  cx_need_clicks = FALSE;

/* Recursive call to make the command tree.
   (Good place to start reading if you are studying this code!)

   In principle this could be called ONCE to create the Widget tree,
   but we actually start with a menubar and call this for each entry.
   Later activity will manage and unmanage parts of the tree.
   We attach code at these points to revise resources and do things. */

/* We note each Widget ident (both iconic and expanded)
   as NodeButton[node] and NodeBox[node] for later access.
   The internal parent-child structure is not adequate. */

static      Widget
cxm_make_tree(Widget parent, int parent_kind, NODEID anode)
{
  Widget      ww, RC, PD;
  Arg       args[10];
  int       nn = 0;
  int       ival;
  int       ii, nwords, wcols, ncols;

  NODEID      child;

#ifdef DEBUG
  if (DEBUG) {
    fprintf(DEBUG,
        "cxm: make_tree node %d %s\n", anode, Node_Name(anode));
    fflush(DEBUG);
  }
#endif

/* Omit attribute is evaluated (and sets flag) ONLY at gui creation. */

  if ((Node_Omitted(anode) = Cond(Node_Omit(anode), anode)))
    return NULL;

  if (Node_Pick(anode))
    cx_need_clicks = TRUE;

  switch (Node_Kind(anode)) {

/* AndNode may contain any kind of terminal and further internals.

   Dialog is not managed yet or it would be shown too soon,
   but the RowColumn (and any additional one) is managed.

   We make permanent note of the first RC but not any later ones.
   Harmless because we only use it as way back to parent dialog shell. */

  case AndNode:
    cxm_uipush(anode);

/* Install toolbar as sibling of menubar Widget,
   although it will be used as if a pulldown from menubar. */

    if (!strcasecmp(Node_Name(anode), "toolbar"))
      ww = NodeBox[anode] = RC = cxm_make_toolbar(XtParent(menubar),
                            Node_Help(anode),
                            anode);

    else
      ww =
        NodeBox[anode] =
        RC = cxm_make_Dialog_popup(parent,
                       Node_Name(anode),
                       NULL,
                       NULL,
                       Node_Help(anode),
                       anode);

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {

/* About layout resources in RowColumn:

  XmNorientation adds children
   XmVERTICAL (default) vertically
   XmHORIZONTAL horizontally

  XmNpacking
   XmPACK_TIGHT (default) try for single row or column per orientation,
  wrapping to next row or column if unable to fit,
  but we always fit because container may grow.
   XmPACK_COLUMN gridded

  XmNnumColumns is used only with XmPACK_COLUMN and either orientation.
   The same resource means cols if XmV'l but rows if XmH'l.

   Here Tab and VTab to spec rows or columns. */

      if (Node_Kind(child) == LayoutNode) {
        if (child != Node_Child(anode)) {
          nn = 0;

          XtSetArg(args[nn], XmNtopAttachment, XmATTACH_WIDGET);
          nn++;
          XtSetArg(args[nn], XmNtopWidget, RC);
          nn++;
          XtSetArg(args[nn], XmNleftAttachment, XmATTACH_FORM);
          nn++;
          XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM);
          nn++;

/* Prevent this being a tab group separate from earlier dialog part. */

          XtSetArg(args[nn], XmNnavigationType, XmNONE);
          nn++;

          XtManageChild(RC =
                  XmCreateRowColumn(XtParent(RC), Node_Name(child), args, nn));
        }

/* One or more equally spaced columns or single tight column if zero. */

        if (Node_Layout_Tab(child)) {
          ival = Node_Layout_Tab(child) (child);
          nn = 0;
          XtSetArg(args[nn], XmNorientation, XmVERTICAL);
          nn++;
          if (ival > 0) {
            XtSetArg(args[nn], XmNpacking, XmPACK_COLUMN);
            nn++;
            XtSetArg(args[nn], XmNnumColumns, ival);
            nn++;
            XtSetArg(args[nn], XmNadjustLast, False);
            nn++;
          }
          XtSetValues(RC, args, nn);
        }

/* One or more equally spaced rows or single tight row if zero. */

        else if (Node_Layout_VTab(child)) {
          ival = Node_Layout_VTab(child) (child);
          nn = 0;
          XtSetArg(args[nn], XmNorientation, XmHORIZONTAL);
          nn++;
          if (ival > 0) {
            XtSetArg(args[nn], XmNpacking, XmPACK_COLUMN);
            nn++;
            XtSetArg(args[nn], XmNnumColumns, ival);
            nn++;
            XtSetArg(args[nn], XmNadjustLast, False);
            nn++;
          }
          XtSetValues(RC, args, nn);
        }
      }

      else
        cxm_make_tree(RC, AndNode, child);
    }
    cxm_uiappend();
    break;

/* BUG NOTE! We still do not cover all possible hierarchies:
   The cascade for a pulldown must have menu (or menubar) parent.
   Need something else when parent is a dialog box. */

  case OrNode:
    cxm_uipush(anode);

/* Install any popup menu as child of toplevel,
   not child of the drawing widget that will show it.
   (We crashed using the SGI GL drawing widget as a parent.)
   Any internal node may have a popup menu as one of its children.
   Several such nodes may be on the activation stack;
   the topmost active popup menu is the one to be shown. */

    if (!strcasecmp(Node_Name(anode), "popup_menu")) {
      NodePopupMenu[Node_Back(anode)] =
        ww = NodeBox[anode] = PD = cxm_make_popup_menu(cx_toplevel,
                               Node_Name(anode),
                               Node_Help(anode),
                                 anode);
      cx_need_clicks = TRUE;
    }

    else
      ww = NodeBox[anode] = PD = cxm_make_pulldown_menu(parent,
                               Node_Name(anode),
                                NULL,
                                NULL,
                               Node_Help(anode),
                                anode);

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child))
      switch (Node_Kind(child)) {
      case AndNode:
      case OrNode:
      case ImmNode:
      case LabelNode:
        cxm_make_tree(PD, OrNode, child);
        break;
      case TermNode:
        switch (Node_Term_Kind(child)) {
        case BOOLEAN_TERM:
        case CHOICE_TERM:
        case SELECT_TERM:
        case STRING_TERM:
          cxm_make_tree(PD, OrNode, child);
          break;

        default:
          printf("cxm: %s Or %s cannot hold type %d Term %s\n",
               app_name, Node_Name(anode), Node_Term_Kind(child), Node_Name(child));
          break;
        }
        break;
      default:
        printf("cxm: %s Or %s cannot hold type %d Node %s\n",
             app_name, Node_Name(anode), Node_Kind(child), Node_Name(child));
        break;
      }
    cxm_uiappend();
    break;

/* The rest are all "terminal" nodes,
   although only some are sub-typed to TermNode. */

  case LabelNode:
    XtManageChild(
            NodeButton[anode] = ww =
            cxm_make_label(parent, NULL,
                   Node_Name(anode), 0, 0));
    break;

/* Momentary should really be separate from Immediate but... */

  case ImmNode:
    if (Node_Summary(anode))
      XtManageChild(
              NodeButton[anode] = ww =
              cxm_make_summary_button(parent,
                          Node_Name(anode),
                          NULL, NULL,
                          NULL, 0,
                         ((Node_Click_Action(anode)) ?
                        cxm_MAKE_ARM_CB : NULL),
                         ((Node_Click_Action(anode)) ?
                       cxm_Momentary_CB : cxm_Imm_CB),
                          (void *) anode));
    else
      XtManageChild(
              NodeButton[anode] = ww =
              cxm_make_button(parent,
                      Node_Name(anode),
                      NULL,
                      NULL,
                      ((Node_Click_Action(anode)) ?
                       cxm_MAKE_ARM_CB : NULL),
                      ((Node_Click_Action(anode)) ?
                       cxm_Momentary_CB : cxm_Imm_CB),
                      (void *) anode));
    break;

  case TermNode:
    switch (Node_Term_Kind(anode)) {

    case BOOLEAN_TERM:
      XtManageChild(
              NodeButton[anode] = ww =
              cxm_make_button(parent,
                      Node_Name(anode),
                      NULL,
                      NULL,
                      cxm_MAKE_TOGGLE,
                      cxm_Bool_CB,
                      (void *) anode));
      break;

/* Choose-one or choose-any-number.
   We implement choose-one as an OptionMenu if parent is a Dialog,
   otherwise as a List in a popup Dialog due to Menu restrictions,
   and choose-any-number always as a List in a popup Dialog.

   The button to popup a choose-one List Dialog
   can optionally be grouped with a TextField for type-in,
   to be validated by an app-provided Boolean function.
   This compound button will only work if the parent is a Dialog.  */

    case CHOICE_TERM:

/* Save the pulldown RowColumn Widget as NBox. */

      if ((Cond(Node_Choice_Max(anode), anode) == 1)

       && !Node_Enable_Ok(anode)

       && (parent_kind == AndNode))
        NodeBox[anode] = ww =
          cxm_make_choose_one_menu(parent, Node_Name(anode),
                       NULL,
                       NULL,
                       Node_Help(anode),
                       NULL, 0,
                       "no",
                       anode);

/* Save the actual List Widget as NBox. */

      else
        NodeBox[anode] = ww =
          cxm_make_List_popup(parent,
                    NULL, 0,
                    "no",
                    Cond(Node_Term_Width(anode), anode),
                    Node_Name(anode),
                    NULL,
                    Node_Help(anode),
                 (Cond(Node_Choice_Max(anode), anode) != 1),
                    TRUE,
                 (Cond(Node_Choice_Max(anode), anode) == 1),
                    anode);
      break;

    case INT_TERM:
      if (parent_kind == OrNode)
        return NULL;

      NodeBox[anode] = ww =
        cxm_make_value_button(parent,
                    Node_Name(anode),
                    " ",
                    Cond(Node_Term_Width(anode), anode),
                    Cond(Node_Read_Only(anode), anode),
                    Node_Help(anode),
                    anode);
      break;

    case FLOAT_TERM:
      if (parent_kind == OrNode)
        return NULL;

      NodeBox[anode] = ww =
        cxm_make_value_button(parent,
                    Node_Name(anode),
                    " ",
                    Cond(Node_Term_Width(anode), anode),
                    Cond(Node_Read_Only(anode), anode),
                    Node_Help(anode),
                    anode);
      break;

    case DOUBLE_TERM:
      if (parent_kind == OrNode)
        return NULL;

      NodeBox[anode] = ww =
        cxm_make_value_button(parent,
                    Node_Name(anode),
                    " ",
                    Cond(Node_Term_Width(anode), anode),
                    Cond(Node_Read_Only(anode), anode),
                    Node_Help(anode),
                    anode);
      break;

/* Size cycle to greater of declared width or widest possible word. */

    case CYCLE_TERM:
      if (parent_kind == OrNode)
        return NULL;

      ncols = Cond(Node_Term_Width(anode), anode);
      nwords = wordcount(Node_Choice_Set(anode) (anode));
      for (ii = 0; ii < nwords; ii++) {
        wcols = strlen(wordx(ii, Node_Choice_Set(anode) (anode)));
        if (ncols < wcols)
          ncols = wcols;
      }

      NodeBox[anode] = ww =
        cxm_make_cycle_button(parent,
                    Node_Name(anode),
                   wordx(0, Node_Choice_Set(anode) (anode)),
                    ncols,
                    Cond(Node_Read_Only(anode), anode),
                    Node_Help(anode),
                    anode);
      break;

/* Popup version callable from an OR menu,
   direct version for use in an AND box. */

    case STRING_TERM:
      if (parent_kind == OrNode)
        NodeBox[anode] = ww =
          cxm_make_String_popup(parent,
                      Node_Name(anode),
                      " ",
                    Cond(Node_Term_Width(anode), anode),
                      Cond(Node_Read_Only(anode), anode),
                      Node_Help(anode),
                      anode);
      else
        NodeBox[anode] = ww =
          cxm_make_String(parent,
                  Node_Name(anode),
                  " ",
                  Cond(Node_Term_Width(anode), anode),
                  Cond(Node_Read_Only(anode), anode),
                  Node_Help(anode),
                  anode);
      break;

    case SELECT_TERM:
      NodeBox[anode] = ww =
        cxm_make_FSB_popup(parent,
                   Node_Name(anode),
                   NULL,
                   NULL,
                   Node_Help(anode),
                   anode);
      break;

    case STRUCT_TERM:
      if (parent_kind == OrNode)
        return NULL;

      NodeBox[anode] = ww =
        cxm_make_value_button(parent,
                    Node_Name(anode),
                    " ",
                    Cond(Node_Term_Width(anode), anode),
                    Cond(Node_Read_Only(anode), anode),
                    Node_Help(anode),
                    anode);
      break;

    default:
      printf("cxm: %s ? %d TERM %s\n",
           app_name, Node_Term_Kind(anode), Node_Name(anode));
      break;
    }
    break;

  case ForNode:
    printf("cxm: %s does not support ForNode %s\n",
         app_name, Node_Name(anode));
    break;

  case SwitchNode:
    printf("cxm: %s does not support SwitchNode %s\n",
         app_name, Node_Name(anode));
    break;

  default:
    printf("cxm: %s ? %d NODE %s\n",
         app_name, Node_Kind(anode), Node_Name(anode));
    break;
  }

/* Provide button mnemonics based on labels or names. */

  if ((parent_kind == OrNode)
   && NodeButton[anode]
   && (Node_Kind(anode) != LabelNode))
    (void) cx_set_mnemonic(NodeButton[anode]);

/* Support for Balloon Help. */

  if (Node_Help(anode) && NodeButton[anode]
   && (Node_Kind(anode) != LabelNode))
    (void) cxm_set_Enter_Leave(NodeButton[anode], anode);

  return ww;
}

/* Standard File pulldown menu and a button to pop it.
   We provide a default help topic if none specified.
   This is always the first element of the menubar.
   It always provides Exit last. */

static void
cxm_make_File_pulldown(Widget parent, NODEID anode)
{
  NODEID      child;
  NODEID      File_Save_Yourself = NULL;
  NODEID      File_Exit = NULL;

  Widget      pulldown =
  cxm_make_pulldown_menu(parent, "File", 'F',
               NULL,
           (anode && Node_Help(anode) && strlen(Node_Help(anode)))
               ? Node_Help(anode) : "file_help",
               anode);

/* Support for Balloon Help. */

  if (Node_Help(anode) && NodeButton[anode])
    (void) cxm_set_Enter_Leave(NodeButton[anode], anode);

/* First we look for New / Open / Save / saveAs in order.
   We expect these to be certain types but do not require it.
   Also we do not provide interlocks warning user to save changes. */

  if (anode) {

/* Should be Immediate or Choice. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "New")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

/* Should be File Selection. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "Open")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

/* Should be Immediate. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "Save")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

/* This will not appear in the File menu;
   used only for Save_Yourself for a later Restart. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "Restart")) {
        File_Save_Yourself = child;
        break;
      }
    }

/* Most Recently Used 1 - 2 - 3 - 4 should be Immediate. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "_1")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "_2")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "_3")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "_4")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

/* Should be String or File Selection. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "saveAs")
        || !strcasecmp(Node_Name(child), "save As")) {
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }

/* Anything except the above ones. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (strcasecmp(Node_Name(child), "New")
        && strcasecmp(Node_Name(child), "Open")
        && strcasecmp(Node_Name(child), "_1")
        && strcasecmp(Node_Name(child), "_2")
        && strcasecmp(Node_Name(child), "_3")
        && strcasecmp(Node_Name(child), "_4")
        && strcasecmp(Node_Name(child), "Restart")
        && strcasecmp(Node_Name(child), "Save")
        && strcasecmp(Node_Name(child), "saveAs")
        && strcasecmp(Node_Name(child), "save As")
        && strcasecmp(Node_Name(child), "Exit"))
        cxm_make_tree(pulldown, OrNode, child);
    }

/* Exit as the last choice.  Should be Immediate. */

    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child)) {
      if (!strcasecmp(Node_Name(child), "Exit")) {
        File_Exit = child;
        cxm_make_tree(pulldown, OrNode, child);
        break;
      }
    }
  }

/* Exit is always needed even if no spec or not in spec. */

  if (!File_Exit)
    XtManageChild(
            cxm_make_button(pulldown, "Exit", 'E',
                    NULL, NULL, cxm_Exit_CB, 0));

/* Respond to Session Save_Yourself.
   Use the File / Restart node action if the application has one.
   This node DOES NOT appear as a choice in the File menu.

   We pass this node to the callback as client_data.
   Note that we must register to get this protocol.
   See Heller Section 17.4 and example 17-5.

   The XmAddWMProtocolCallback is supposed to do an automatic
   XmAddWMProtocols if not already present,
   but some claim that this is broken. */

  if (File_Save_Yourself) {
    XmAddWMProtocols(cx_toplevel,
             &WM_SAVE_YOURSELF, 1);

    XmAddWMProtocolCallback(cx_toplevel,
                WM_SAVE_YOURSELF,
                cxm_Save_Yourself_CB,
                (XtPointer) File_Save_Yourself);
  }

/* Respond to Window Menu / Quit as if File / Exit was chosen.
   Note that we would get this protocol anyway,
   but we disabled the built-in Quit response. */

  XmAddWMProtocolCallback(cx_toplevel,
              WM_DELETE_WINDOW,
              cxm_Exit_CB,
              (XtPointer) File_Exit);
}

#define MAX_HELP_TOPICS 35
static char  *topic_list[MAX_HELP_TOPICS];
static int    topic_count = 0;

/* Learn all help topics in the tree.
   Avoid duplicates for the menu. */

static void
cxm_learn_helps(NODEID anode)
{
  NODEID      child;
  int       ii;

  if (topic_count < MAX_HELP_TOPICS) {
    if (Node_Help(anode) && strlen(Node_Help(anode))) {
      for (ii = 0; ii < topic_count; ii++)
        if (!strcmp(topic_list[ii], Node_Help(anode)))
          break;
      if (ii == topic_count)
        topic_list[topic_count++] = Node_Help(anode);
    }

    switch (Node_Kind(anode)) {
    case AndNode:
    case OrNode:
      for (child = Node_Child(anode);
         child;
         child = Node_Sibling(child))
        cxm_learn_helps(child);
    }
  }
}

/* ANOTHER HELP FEATURE TO ADD:
   Use saved NodeWidget arrays to get at dialogs.
   Get all the XtNames and XmNlabelStrings,
   and mnemonics and accelerators,
   and use them to build an indented text graphic.
   Show it as Help/Tree as feedback and guide for user-set resources.

   More generally,
   generate a report to help a user to correctly specify resources.
   Easiest to get those we know are valid and of interest,
   such as labelString, fore and background, fontList.

   Could use this to report everything:
   void XtGetResourceList(XtClass(Widget), XtResourceList *, Cardinal);
   Each list entry is a struct _XtResource with these useful members:
   { String resource_name;
   String resource_class;
   String resource_type;
   Cardinal resource_size; }
   Use XtFree(resourcelist) when done.  */

static void
cxm_learn_abbrevs(NODEID anode)
{
  NODEID      child;
  int       ii;

  switch (Node_Kind(anode)) {
  case AndNode:
  case OrNode:
    for (child = Node_Child(anode);
       child;
       child = Node_Sibling(child))
      cxm_learn_abbrevs(child);
  }
}

/* We can set a local flag on exposure events on the app portion.
   This call returns the state of the flag and also resets it.
   Thus it tells if any exposure events since the last call.
   Properly written app code should not need this call.
   Need this only if app should have callback and does not.
   Note!  The first call will register the handler and return True. */

static long   cxm_exposure_flag = NULL;
static long   cxm_check_app_exp = NULL;

static void
cxm_app_Expose_EH(Widget where,
         XtPointer client_data,
         XEvent * event,
         Boolean *continue_to_dispatch)
{ cxm_exposure_flag = True; }

static void
cx_app_expose(void)
{
  Cardinal    numchildren;
  WidgetList    children;
  Widget      child;
  int       ii;

  XtVaGetValues(XtParent(menubar), 
                XtNchildren, &children,
                XtNnumChildren, &numchildren,
                NULL);

  for (ii = 0; ii < numchildren; ii++) {
/* printf("child=%s\n", XtName(children[ii])); */
    if (children[ii] != menubar
     && children[ii] != toolbar) {
      XtAddEventHandler(children[ii],
                        ExposureMask,
                        False,
                        cxm_app_Expose_EH,
                        NULL);
    }
  }
}

long
gui_expose(void)
{
  long      hold = cxm_exposure_flag;
  cxm_exposure_flag = NULL;

/* c y a */

  if (!menubar)
    return False;

  if (!cxm_check_app_exp) {
    cxm_check_app_exp = True;
    cx_app_expose();
    return True;
  }
  else
    return hold;
}

static int    built_gui = 0;
static void
cxm_Build_gui(void)
{
  NODEID      child;
  int       ii;

/* Try to open a debug file iff tag named in environment.

   We should document GUI_DEBUG in some standard on-line help file!
   Here we just mention it in the report.

   Try to name it by given debug tag or default tag plus program name,
   but if main forgot to copy args just use tag or default.

   Use just the final part if program name was a pathname.

   Set DEBUG to NULL if not wanted or unable to open file. */

#ifdef DEBUG

  if (getenv("GUI_DEBUG")) {
    if (strlen(getenv("GUI_DEBUG")))
      strcpy(debugfile, getenv("GUI_DEBUG"));
    else
      strcpy(debugfile, "GUI_DEBUG");

    strcat(debugfile, "_");
    for (ii = strlen(app_name); ii; ii--)
      if (app_name[ii - 1] == DIRSLASH)
        break;
    strcat(debugfile, app_name + ii);

    if (DEBUG = fopen(debugfile, "w")) {
      fprintf(DEBUG, "%s\n", debugfile);
      fflush(DEBUG);
    }
  }

  else
    DEBUG = (FILE *) 0;
#endif

  if (Node_Help(ROOTNODE) && strlen(Node_Help(ROOTNODE))
    && (XtHasCallbacks(XtParent(menubar), XmNhelpCallback) != XtCallbackNoList))
    XtAddCallback(XtParent(menubar), XmNhelpCallback,
            cxm_Help_CB, (XtPointer)Node_Help(ROOTNODE));

  cxm_learn_helps(ROOTNODE);

/* Create a Yes_No popup for later use. */

  Yes_No_Dialog = cxm_make_Yes_No_popup(cx_toplevel);

/* Create an Error popup for later use.
   Maybe offer additional help here? */

  Error_Dialog = cxm_make_Error_popup(cx_toplevel);

/* Custom or standard File pulldown and button to pop it.
   Use the File menu spec if one is provided,
   making it the first pulldown regardless of when spec'd.
   Pass NULL and it will provide a default if none spec'd. */

  for (child = Node_Child(ROOTNODE);
     child;
     child = Node_Sibling(child))
    if (!strcasecmp(Node_Name(child), "File"))
      break;
  cxm_make_File_pulldown(menubar, child);

/* The application part.
   We already have a root level menubar,
   so install all first-level children in it,
   rather than installing root of the whole tree.
   Skip over "File" because it is already done. */

  cxm_uipush(ROOTNODE);
  for (child = Node_Child(ROOTNODE);
     child;
     child = Node_Sibling(child))
    if (strcasecmp(Node_Name(child), "File"))
      cxm_make_tree(menubar, OrNode, child);

/* Get rid of dicts from creation phase.
   They may confuse us later. */

  while (Actives)
    cxm_cancel_node(UITOP);

/* Standard Help pulldown menu and a button to pop it.
   Pass NULL for any standard file or string we do not provide.
   (We need an automated listing of Alt & Ctr keyboard abbreviations.)
   That omits it from the menu where it would only fail.

   The "help_help" and "gui_help" should not be hard-coded-in;
   better to first check "usual places" for existence of files.

   Help will always appear LAST in menubar even if declared earlier. */

  cxm_make_Help_pulldown(menubar,
               "help_help",
               Node_Help(1),
               NULL,
               "gui_help",
               topic_list);

/* Support two uses of mouse clicking in the drawing_widget.
   Button1 (release) calls application-code for mouse clicks.
   Button3 (press) shows a popup.  A grab gets the release. */

/* A problem adding the event handler;
   We need b3 down to popup a menu.

   draw_widget can get b1 or b2 down and up but only gets b3 up.
   I don't know what intercepts the b3 down events,
   assuming it is some hidden Motif feature.
   Others have also complained of this.

   You cannot have same handler on a parent and descendant,
   only the parent handler will be called,
   but we can have separate ones.

   toplevel can get b3 down but not up and no b1 events.
   So we reluctantly use it to popup a menu,
   first correcting the coordinates.

   Also tried using the XmNinputCallback.
   Not all widgets support it but drawing does.
   Was just the same -- got b1 down and up but only b3 up. */

  if (cx_draw_widget && cx_need_clicks) {
    XtAddEventHandler(cx_toplevel,
              ButtonPressMask,
              False,
              cxm_MButton_EH,
              (XtPointer)cx_draw_widget);
    XtAddEventHandler(cx_draw_widget,
              ButtonPressMask | ButtonReleaseMask,
              False,
              cxm_MButton_EH,
              (XtPointer)cx_draw_widget);
  }
  built_gui = 1;
}

/* Application call to pass in Widget menubar already created.
   Work back up the instance tree to learn top and save it.
   Use only the first valid call -- none before or after. */

void
gui_init(void *w)
{
  Atom   prop_actual_type;
  int    prop_actual_format;
  unsigned long prop_nitems;
  unsigned long prop_bytes_leftover;
  unsigned char *prop_data = NULL;

  int *int_data;
  long *long_data;

  if (menubar)
    return;

  menubar = (Widget) w;

  if (!menubar)
    return;

  cx_display = XtDisplay(menubar);
  appcontext = XtDisplayToApplicationContext(cx_display);
  cx_screen = XtScreen((Widget) w);

  cx_TimeOut_Time = XtGetMultiClickTime(cx_display);

  cx_rootwindow = cx_screen->root;

  XtGetApplicationNameAndClass(cx_display, &app_name, &app_class);

/* BTW the XtName(cx_toplevel) is also app_name.

   Our toplevel is NOT directly a child of root window,
   due to re-parenting by a window manager.
   Not sure what all this implies! */

  cx_toplevel = menubar;
  while (!XtIsShell(cx_toplevel))
    cx_toplevel = XtParent(cx_toplevel);

/* Find drawing_widget sibling of menubar if one is defined. */

  XtVaGetValues(XtParent(menubar),
          XmNworkWindow, &cx_draw_widget,
          NULL);

  if (XtIsRealized(cx_toplevel))
    cx_topwindow = XtWindow(cx_toplevel);

/* Disable the built-in Window Menu / Quit response.
   We will respond as if Menubar / File / Exit was chosen.  */

  XtVaSetValues(cx_toplevel,
          XmNdeleteResponse, XmDO_NOTHING,
          NULL);

/* Atomize our private property name. */

  _GUI_BALLOON_HELP = XmInternAtom(cx_display, "_GUI_BALLOON_HELP", False);

/* See if already defined as root property and use it if so. */

  if ((XGetWindowProperty(cx_display, cx_rootwindow,
              _GUI_BALLOON_HELP,
              0L, 1L, False, AnyPropertyType,
              &prop_actual_type,
              &prop_actual_format,
              &prop_nitems,
              &prop_bytes_leftover,
              &prop_data) == Success) && prop_data) {

    if (prop_actual_format == sizeof(char)) {
      want_Balloon = *prop_data;
    }
    else if (prop_actual_format == sizeof(int)) {
      int_data = (int *)prop_data;
      want_Balloon = *int_data;
    }
    else {
      long_data = (long *)prop_data;
      want_Balloon = *long_data;
    }

    XFree((char *)prop_data);
  }

/* Atomize some common (but not built-in) property names. */

  WM_SAVE_YOURSELF = XmInternAtom(cx_display, "WM_SAVE_YOURSELF", False);
  WM_DELETE_WINDOW = XmInternAtom(cx_display, "WM_DELETE_WINDOW", False);

/* Make sure we get PropertyNotify events on root window.
   Another (cleaner) way is to create a special root widget,
   which does nothing but support events and callbacks. */

  XSelectInput(cx_display, cx_rootwindow, PropertyChangeMask);
}

/* Event when a root property has been changed.
   Notice this is not a standard event callback on a widget,
   but it would be if we used a special root widget.

   Fields of interest include:
   Boolean send_event; true if due to a client XSendEvent.
   Display *display; where changed;
   Window window; where changed;
   Atom atom; what changed.
   int state; either PropertyNewValue or PropertyDeleted.

   Use XGetWindowProperty only if we care to learn the new data value.
   Remember we get a ->pointer<- we must dereference and later release,
   and be careful to use the proper length data item. */

static void 
cxm_PropertyNotify(XPropertyEvent * XPE)
{
  Atom      actual_type;
  int       actual_format;
  unsigned long   nitems;
  unsigned long   bytes_leftover;
  unsigned char *data = NULL;
  int *int_data;
  long *long_data;
  int newvalue;

/* All we care about for now... */

  if (XPE->atom == _GUI_BALLOON_HELP) {
    if (XGetWindowProperty(XPE->display, XPE->window,
                 _GUI_BALLOON_HELP,
                 0L, 1L, False, AnyPropertyType,
                 &actual_type,
                 &actual_format,
                 &nitems,
                 &bytes_leftover,
                 &data) == Success) {

      if (actual_format == sizeof(char)) {
        newvalue = *data;
      }
      else if (actual_format == sizeof(int)) {
        int_data = (int *)data;
        newvalue = *int_data;
      }
      else {
        long_data = (long *)data;
        newvalue = *long_data;
      }

      cxm_want_Balloon_CB((Widget) NULL,
                  (XtPointer) newvalue,
                  (XtPointer) NULL);

      if (data)
        XFree((char *)data);
    }
  }
}

/* An application calls here to hide the gui.
   Useful for clean hands-off display once properly set up,
   but obviously needs some none-gui way to get it back!

   Discard anything on the dictionary stack.
   Also release any memory no longer valid.

   Unmanaging the menubar leaves any popup dialog visible,
   because dialog shells are parented directly to root,
   so we make sure to unmanage them ourselves.

   We have to jiggle the size of cx_toplevel (not mainwindow)
   to properly allocate space w/wo the menubar. */

void
gui_hide(void)
{
  if (!menubar)
    return;

  if (!built_gui)
    return;

  cxm_zap_Help();
  cxm_zap_Error();
  cxm_zap_Yes_No();

  if (CHOICE_ADD)
    XtFree(CHOICE_ADD);
  CHOICE_ADD = NULL;

  if (CHOICE_DEL)
    XtFree(CHOICE_DEL);
  CHOICE_DEL = NULL;

  if (CHOICE_LIST)
    XtFree(CHOICE_LIST);
  CHOICE_LIST = NULL;

  if (STRING_VAL)
    XtFree(STRING_VAL);
  STRING_VAL = NULL;

  while (Actives)
    cxm_cancel_node(UITOP);

  GUI_RUN = 0;

  if (XtIsManaged(menubar)) {
    XtUnmanageChild(menubar);
    if (toolbar)
      XtUnmanageChild(toolbar);
    cx_resize(cx_toplevel);
  }
}

/* An application calls here to show gui. */

void
gui_show(void)
{
  if (!menubar) {
    printf("cxm: %s gui_show ERROR: first pass menubar Widget to gui_init\n",
         app_name);
    exit(-1);
  }

  if (!built_gui)
    cxm_Build_gui();

  GUI_RUN = 1;

/* Make sure the menubar is visible. */

  if (!XtIsManaged(menubar)) {
    XtManageChild(menubar);
    if (toolbar)
      XtManageChild(toolbar);
    cx_resize(cx_toplevel);
  }

/* Activate the root node.
   It will in turn activate the toolbar if one is defined. */

  Actives = 0;
  cxm_showing_node(ROOTNODE);
}

/* Application calls this periodically if it has its own main loop,
   for example servicing a message queue or external devices,
   otherwise it would simply use XtAppMainLoop(appcontext).

   Option value to show or hide the gui or zero to just run.
   The option is discouraged in favor of direct calls to show or hide. */

long
guim(long opt)
{
  XEvent      event;
  int       evcounter;
  static int    posted_interest = NULL;

  XtInputMask   imask;

  if (!menubar) {
    printf("cxm: %s guim ERROR: first pass menubar Widget to gui_init\n",
         app_name);
    exit(-1);
  }

  if (GUI_RUN && (opt < 0))
    gui_hide();

  else if (!GUI_RUN && (opt > 0))
    gui_show();

/* Works fine without ANY counter but can block other processes.
   That is a problem with several real-time displays running.

   Small limits (under 25) cause noticeable delay in our drawing.
   Large limits increase the possible delay to other proceses.

   Regardless of limit there is no delay if nothing is pending,
   and of course the mouse can only be in one place at a time. */

  evcounter = 0;
  while ((evcounter++ < 50) && (imask = XtAppPending(appcontext))) {

    XtAppPeekEvent(appcontext, &event);

/* Until we use a root-window-widget must do it this way.
   Apps that use the normal XtAppMainLoop will not see these;
   they will just use the Balloon state at their startup. */

    if ((event.type == PropertyNotify)
      && (event.xproperty.window == cx_rootwindow))
      cxm_PropertyNotify(&event.xproperty);

    XtAppProcessEvent(appcontext, imask);
  }

  if (!cx_topwindow)
    cx_topwindow = XtWindow(cx_toplevel);

  return GUI_RUN;
}

/* To avoid crash if calling too soon. */

int 
gui_realized(void)
{
  return ((cx_display != NULL) && (cx_topwindow != NULL));
}

/* Application has changed something so update the GUI.
   Simply updates the whole panel (if active) regardless.
   Update the current top panel if not named one or null.
   (Any or all of these args may be null or empty strings.)
   Should do a much better job here! */

void
gui_ext(char *ext_win, char *ext_item, char *value_string)
{
  NODEID      anode;

  if (gui_realized() && (Actives > 0)) {

#ifdef DEBUG
    if (DEBUG) {
      fprintf(DEBUG,
          "gui_ext Top is %s begin: %s %s %s\n",
          Node_Name(UITOP),
          ext_win, ext_item, value_string);
      fflush(DEBUG);
    }
#endif

/* Flag prevents app-updates from issuing actions back to the app. */

    By_Gui_Ext = 1;
    if (anode = uiknown(ext_win))
      cxm_revise_node(anode, False);
    else
      cxm_revise_node(UITOP, False);
    By_Gui_Ext = 0;

#ifdef DEBUG
    if (DEBUG) {
      fprintf(DEBUG,
          "gui_ext end: %s %s %s\n",
          ext_win, ext_item, value_string);
      fflush(DEBUG);
    }
#endif

  }
}
